/* libguestfs generated file
 * WARNING: THIS FILE IS GENERATED FROM:
 *   generator/generator_*.ml
 * ANY CHANGES YOU MAKE TO THIS FILE WILL BE LOST.
 *
 * Copyright (C) 2009-2011 Red Hat Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#include <config.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <inttypes.h>

#include <guestfs.h>
#include "c-ctype.h"
#include "full-write.h"
#include "xstrtol.h"
#include "fish.h"
#include "cmds_gperf.h"

/* Valid suffixes allowed for numbers.  See Gnulib xstrtol function. */
static const char *xstrtol_suffixes = "0kKMGTPEZY";

static int run_launch (const char *cmd, size_t argc, char *argv[]);
static int run_kill_subprocess (const char *cmd, size_t argc, char *argv[]);
static int run_add_drive (const char *cmd, size_t argc, char *argv[]);
static int run_add_cdrom (const char *cmd, size_t argc, char *argv[]);
static int run_add_drive_ro (const char *cmd, size_t argc, char *argv[]);
static int run_config (const char *cmd, size_t argc, char *argv[]);
static int run_set_qemu (const char *cmd, size_t argc, char *argv[]);
static int run_get_qemu (const char *cmd, size_t argc, char *argv[]);
static int run_set_path (const char *cmd, size_t argc, char *argv[]);
static int run_get_path (const char *cmd, size_t argc, char *argv[]);
static int run_set_append (const char *cmd, size_t argc, char *argv[]);
static int run_get_append (const char *cmd, size_t argc, char *argv[]);
static int run_set_autosync (const char *cmd, size_t argc, char *argv[]);
static int run_get_autosync (const char *cmd, size_t argc, char *argv[]);
static int run_set_verbose (const char *cmd, size_t argc, char *argv[]);
static int run_get_verbose (const char *cmd, size_t argc, char *argv[]);
static int run_is_ready (const char *cmd, size_t argc, char *argv[]);
static int run_is_config (const char *cmd, size_t argc, char *argv[]);
static int run_is_launching (const char *cmd, size_t argc, char *argv[]);
static int run_is_busy (const char *cmd, size_t argc, char *argv[]);
static int run_get_state (const char *cmd, size_t argc, char *argv[]);
static int run_set_memsize (const char *cmd, size_t argc, char *argv[]);
static int run_get_memsize (const char *cmd, size_t argc, char *argv[]);
static int run_get_pid (const char *cmd, size_t argc, char *argv[]);
static int run_version (const char *cmd, size_t argc, char *argv[]);
static int run_set_selinux (const char *cmd, size_t argc, char *argv[]);
static int run_get_selinux (const char *cmd, size_t argc, char *argv[]);
static int run_set_trace (const char *cmd, size_t argc, char *argv[]);
static int run_get_trace (const char *cmd, size_t argc, char *argv[]);
static int run_set_direct (const char *cmd, size_t argc, char *argv[]);
static int run_get_direct (const char *cmd, size_t argc, char *argv[]);
static int run_set_recovery_proc (const char *cmd, size_t argc, char *argv[]);
static int run_get_recovery_proc (const char *cmd, size_t argc, char *argv[]);
static int run_add_drive_with_if (const char *cmd, size_t argc, char *argv[]);
static int run_add_drive_ro_with_if (const char *cmd, size_t argc, char *argv[]);
static int run_file_architecture (const char *cmd, size_t argc, char *argv[]);
static int run_inspect_os (const char *cmd, size_t argc, char *argv[]);
static int run_inspect_get_type (const char *cmd, size_t argc, char *argv[]);
static int run_inspect_get_arch (const char *cmd, size_t argc, char *argv[]);
static int run_inspect_get_distro (const char *cmd, size_t argc, char *argv[]);
static int run_inspect_get_major_version (const char *cmd, size_t argc, char *argv[]);
static int run_inspect_get_minor_version (const char *cmd, size_t argc, char *argv[]);
static int run_inspect_get_product_name (const char *cmd, size_t argc, char *argv[]);
static int run_inspect_get_mountpoints (const char *cmd, size_t argc, char *argv[]);
static int run_inspect_get_filesystems (const char *cmd, size_t argc, char *argv[]);
static int run_set_network (const char *cmd, size_t argc, char *argv[]);
static int run_get_network (const char *cmd, size_t argc, char *argv[]);
static int run_list_filesystems (const char *cmd, size_t argc, char *argv[]);
static int run_add_drive_opts (const char *cmd, size_t argc, char *argv[]);
static int run_inspect_get_windows_systemroot (const char *cmd, size_t argc, char *argv[]);
static int run_mount (const char *cmd, size_t argc, char *argv[]);
static int run_sync (const char *cmd, size_t argc, char *argv[]);
static int run_touch (const char *cmd, size_t argc, char *argv[]);
static int run_cat (const char *cmd, size_t argc, char *argv[]);
static int run_ll (const char *cmd, size_t argc, char *argv[]);
static int run_ls (const char *cmd, size_t argc, char *argv[]);
static int run_list_devices (const char *cmd, size_t argc, char *argv[]);
static int run_list_partitions (const char *cmd, size_t argc, char *argv[]);
static int run_pvs (const char *cmd, size_t argc, char *argv[]);
static int run_vgs (const char *cmd, size_t argc, char *argv[]);
static int run_lvs (const char *cmd, size_t argc, char *argv[]);
static int run_pvs_full (const char *cmd, size_t argc, char *argv[]);
static int run_vgs_full (const char *cmd, size_t argc, char *argv[]);
static int run_lvs_full (const char *cmd, size_t argc, char *argv[]);
static int run_read_lines (const char *cmd, size_t argc, char *argv[]);
static int run_aug_init (const char *cmd, size_t argc, char *argv[]);
static int run_aug_close (const char *cmd, size_t argc, char *argv[]);
static int run_aug_defvar (const char *cmd, size_t argc, char *argv[]);
static int run_aug_defnode (const char *cmd, size_t argc, char *argv[]);
static int run_aug_get (const char *cmd, size_t argc, char *argv[]);
static int run_aug_set (const char *cmd, size_t argc, char *argv[]);
static int run_aug_insert (const char *cmd, size_t argc, char *argv[]);
static int run_aug_rm (const char *cmd, size_t argc, char *argv[]);
static int run_aug_mv (const char *cmd, size_t argc, char *argv[]);
static int run_aug_match (const char *cmd, size_t argc, char *argv[]);
static int run_aug_save (const char *cmd, size_t argc, char *argv[]);
static int run_aug_load (const char *cmd, size_t argc, char *argv[]);
static int run_aug_ls (const char *cmd, size_t argc, char *argv[]);
static int run_rm (const char *cmd, size_t argc, char *argv[]);
static int run_rmdir (const char *cmd, size_t argc, char *argv[]);
static int run_rm_rf (const char *cmd, size_t argc, char *argv[]);
static int run_mkdir (const char *cmd, size_t argc, char *argv[]);
static int run_mkdir_p (const char *cmd, size_t argc, char *argv[]);
static int run_chmod (const char *cmd, size_t argc, char *argv[]);
static int run_chown (const char *cmd, size_t argc, char *argv[]);
static int run_exists (const char *cmd, size_t argc, char *argv[]);
static int run_is_file (const char *cmd, size_t argc, char *argv[]);
static int run_is_dir (const char *cmd, size_t argc, char *argv[]);
static int run_pvcreate (const char *cmd, size_t argc, char *argv[]);
static int run_vgcreate (const char *cmd, size_t argc, char *argv[]);
static int run_lvcreate (const char *cmd, size_t argc, char *argv[]);
static int run_mkfs (const char *cmd, size_t argc, char *argv[]);
static int run_sfdisk (const char *cmd, size_t argc, char *argv[]);
static int run_write_file (const char *cmd, size_t argc, char *argv[]);
static int run_umount (const char *cmd, size_t argc, char *argv[]);
static int run_mounts (const char *cmd, size_t argc, char *argv[]);
static int run_umount_all (const char *cmd, size_t argc, char *argv[]);
static int run_lvm_remove_all (const char *cmd, size_t argc, char *argv[]);
static int run_file (const char *cmd, size_t argc, char *argv[]);
static int run_command (const char *cmd, size_t argc, char *argv[]);
static int run_command_lines (const char *cmd, size_t argc, char *argv[]);
static int run_stat (const char *cmd, size_t argc, char *argv[]);
static int run_lstat (const char *cmd, size_t argc, char *argv[]);
static int run_statvfs (const char *cmd, size_t argc, char *argv[]);
static int run_tune2fs_l (const char *cmd, size_t argc, char *argv[]);
static int run_blockdev_setro (const char *cmd, size_t argc, char *argv[]);
static int run_blockdev_setrw (const char *cmd, size_t argc, char *argv[]);
static int run_blockdev_getro (const char *cmd, size_t argc, char *argv[]);
static int run_blockdev_getss (const char *cmd, size_t argc, char *argv[]);
static int run_blockdev_getbsz (const char *cmd, size_t argc, char *argv[]);
static int run_blockdev_setbsz (const char *cmd, size_t argc, char *argv[]);
static int run_blockdev_getsz (const char *cmd, size_t argc, char *argv[]);
static int run_blockdev_getsize64 (const char *cmd, size_t argc, char *argv[]);
static int run_blockdev_flushbufs (const char *cmd, size_t argc, char *argv[]);
static int run_blockdev_rereadpt (const char *cmd, size_t argc, char *argv[]);
static int run_upload (const char *cmd, size_t argc, char *argv[]);
static int run_download (const char *cmd, size_t argc, char *argv[]);
static int run_checksum (const char *cmd, size_t argc, char *argv[]);
static int run_tar_in (const char *cmd, size_t argc, char *argv[]);
static int run_tar_out (const char *cmd, size_t argc, char *argv[]);
static int run_tgz_in (const char *cmd, size_t argc, char *argv[]);
static int run_tgz_out (const char *cmd, size_t argc, char *argv[]);
static int run_mount_ro (const char *cmd, size_t argc, char *argv[]);
static int run_mount_options (const char *cmd, size_t argc, char *argv[]);
static int run_mount_vfs (const char *cmd, size_t argc, char *argv[]);
static int run_debug (const char *cmd, size_t argc, char *argv[]);
static int run_lvremove (const char *cmd, size_t argc, char *argv[]);
static int run_vgremove (const char *cmd, size_t argc, char *argv[]);
static int run_pvremove (const char *cmd, size_t argc, char *argv[]);
static int run_set_e2label (const char *cmd, size_t argc, char *argv[]);
static int run_get_e2label (const char *cmd, size_t argc, char *argv[]);
static int run_set_e2uuid (const char *cmd, size_t argc, char *argv[]);
static int run_get_e2uuid (const char *cmd, size_t argc, char *argv[]);
static int run_fsck (const char *cmd, size_t argc, char *argv[]);
static int run_zero (const char *cmd, size_t argc, char *argv[]);
static int run_grub_install (const char *cmd, size_t argc, char *argv[]);
static int run_cp (const char *cmd, size_t argc, char *argv[]);
static int run_cp_a (const char *cmd, size_t argc, char *argv[]);
static int run_mv (const char *cmd, size_t argc, char *argv[]);
static int run_drop_caches (const char *cmd, size_t argc, char *argv[]);
static int run_dmesg (const char *cmd, size_t argc, char *argv[]);
static int run_ping_daemon (const char *cmd, size_t argc, char *argv[]);
static int run_equal (const char *cmd, size_t argc, char *argv[]);
static int run_strings (const char *cmd, size_t argc, char *argv[]);
static int run_strings_e (const char *cmd, size_t argc, char *argv[]);
static int run_hexdump (const char *cmd, size_t argc, char *argv[]);
static int run_zerofree (const char *cmd, size_t argc, char *argv[]);
static int run_pvresize (const char *cmd, size_t argc, char *argv[]);
static int run_sfdisk_N (const char *cmd, size_t argc, char *argv[]);
static int run_sfdisk_l (const char *cmd, size_t argc, char *argv[]);
static int run_sfdisk_kernel_geometry (const char *cmd, size_t argc, char *argv[]);
static int run_sfdisk_disk_geometry (const char *cmd, size_t argc, char *argv[]);
static int run_vg_activate_all (const char *cmd, size_t argc, char *argv[]);
static int run_vg_activate (const char *cmd, size_t argc, char *argv[]);
static int run_lvresize (const char *cmd, size_t argc, char *argv[]);
static int run_resize2fs (const char *cmd, size_t argc, char *argv[]);
static int run_find (const char *cmd, size_t argc, char *argv[]);
static int run_e2fsck_f (const char *cmd, size_t argc, char *argv[]);
static int run_sleep (const char *cmd, size_t argc, char *argv[]);
static int run_ntfs_3g_probe (const char *cmd, size_t argc, char *argv[]);
static int run_sh (const char *cmd, size_t argc, char *argv[]);
static int run_sh_lines (const char *cmd, size_t argc, char *argv[]);
static int run_glob_expand (const char *cmd, size_t argc, char *argv[]);
static int run_scrub_device (const char *cmd, size_t argc, char *argv[]);
static int run_scrub_file (const char *cmd, size_t argc, char *argv[]);
static int run_scrub_freespace (const char *cmd, size_t argc, char *argv[]);
static int run_mkdtemp (const char *cmd, size_t argc, char *argv[]);
static int run_wc_l (const char *cmd, size_t argc, char *argv[]);
static int run_wc_w (const char *cmd, size_t argc, char *argv[]);
static int run_wc_c (const char *cmd, size_t argc, char *argv[]);
static int run_head (const char *cmd, size_t argc, char *argv[]);
static int run_head_n (const char *cmd, size_t argc, char *argv[]);
static int run_tail (const char *cmd, size_t argc, char *argv[]);
static int run_tail_n (const char *cmd, size_t argc, char *argv[]);
static int run_df (const char *cmd, size_t argc, char *argv[]);
static int run_df_h (const char *cmd, size_t argc, char *argv[]);
static int run_du (const char *cmd, size_t argc, char *argv[]);
static int run_initrd_list (const char *cmd, size_t argc, char *argv[]);
static int run_mount_loop (const char *cmd, size_t argc, char *argv[]);
static int run_mkswap (const char *cmd, size_t argc, char *argv[]);
static int run_mkswap_L (const char *cmd, size_t argc, char *argv[]);
static int run_mkswap_U (const char *cmd, size_t argc, char *argv[]);
static int run_mknod (const char *cmd, size_t argc, char *argv[]);
static int run_mkfifo (const char *cmd, size_t argc, char *argv[]);
static int run_mknod_b (const char *cmd, size_t argc, char *argv[]);
static int run_mknod_c (const char *cmd, size_t argc, char *argv[]);
static int run_umask (const char *cmd, size_t argc, char *argv[]);
static int run_readdir (const char *cmd, size_t argc, char *argv[]);
static int run_sfdiskM (const char *cmd, size_t argc, char *argv[]);
static int run_zfile (const char *cmd, size_t argc, char *argv[]);
static int run_getxattrs (const char *cmd, size_t argc, char *argv[]);
static int run_lgetxattrs (const char *cmd, size_t argc, char *argv[]);
static int run_setxattr (const char *cmd, size_t argc, char *argv[]);
static int run_lsetxattr (const char *cmd, size_t argc, char *argv[]);
static int run_removexattr (const char *cmd, size_t argc, char *argv[]);
static int run_lremovexattr (const char *cmd, size_t argc, char *argv[]);
static int run_mountpoints (const char *cmd, size_t argc, char *argv[]);
static int run_mkmountpoint (const char *cmd, size_t argc, char *argv[]);
static int run_rmmountpoint (const char *cmd, size_t argc, char *argv[]);
static int run_read_file (const char *cmd, size_t argc, char *argv[]);
static int run_grep (const char *cmd, size_t argc, char *argv[]);
static int run_egrep (const char *cmd, size_t argc, char *argv[]);
static int run_fgrep (const char *cmd, size_t argc, char *argv[]);
static int run_grepi (const char *cmd, size_t argc, char *argv[]);
static int run_egrepi (const char *cmd, size_t argc, char *argv[]);
static int run_fgrepi (const char *cmd, size_t argc, char *argv[]);
static int run_zgrep (const char *cmd, size_t argc, char *argv[]);
static int run_zegrep (const char *cmd, size_t argc, char *argv[]);
static int run_zfgrep (const char *cmd, size_t argc, char *argv[]);
static int run_zgrepi (const char *cmd, size_t argc, char *argv[]);
static int run_zegrepi (const char *cmd, size_t argc, char *argv[]);
static int run_zfgrepi (const char *cmd, size_t argc, char *argv[]);
static int run_realpath (const char *cmd, size_t argc, char *argv[]);
static int run_ln (const char *cmd, size_t argc, char *argv[]);
static int run_ln_f (const char *cmd, size_t argc, char *argv[]);
static int run_ln_s (const char *cmd, size_t argc, char *argv[]);
static int run_ln_sf (const char *cmd, size_t argc, char *argv[]);
static int run_readlink (const char *cmd, size_t argc, char *argv[]);
static int run_fallocate (const char *cmd, size_t argc, char *argv[]);
static int run_swapon_device (const char *cmd, size_t argc, char *argv[]);
static int run_swapoff_device (const char *cmd, size_t argc, char *argv[]);
static int run_swapon_file (const char *cmd, size_t argc, char *argv[]);
static int run_swapoff_file (const char *cmd, size_t argc, char *argv[]);
static int run_swapon_label (const char *cmd, size_t argc, char *argv[]);
static int run_swapoff_label (const char *cmd, size_t argc, char *argv[]);
static int run_swapon_uuid (const char *cmd, size_t argc, char *argv[]);
static int run_swapoff_uuid (const char *cmd, size_t argc, char *argv[]);
static int run_mkswap_file (const char *cmd, size_t argc, char *argv[]);
static int run_inotify_init (const char *cmd, size_t argc, char *argv[]);
static int run_inotify_add_watch (const char *cmd, size_t argc, char *argv[]);
static int run_inotify_rm_watch (const char *cmd, size_t argc, char *argv[]);
static int run_inotify_read (const char *cmd, size_t argc, char *argv[]);
static int run_inotify_files (const char *cmd, size_t argc, char *argv[]);
static int run_inotify_close (const char *cmd, size_t argc, char *argv[]);
static int run_setcon (const char *cmd, size_t argc, char *argv[]);
static int run_getcon (const char *cmd, size_t argc, char *argv[]);
static int run_mkfs_b (const char *cmd, size_t argc, char *argv[]);
static int run_mke2journal (const char *cmd, size_t argc, char *argv[]);
static int run_mke2journal_L (const char *cmd, size_t argc, char *argv[]);
static int run_mke2journal_U (const char *cmd, size_t argc, char *argv[]);
static int run_mke2fs_J (const char *cmd, size_t argc, char *argv[]);
static int run_mke2fs_JL (const char *cmd, size_t argc, char *argv[]);
static int run_mke2fs_JU (const char *cmd, size_t argc, char *argv[]);
static int run_modprobe (const char *cmd, size_t argc, char *argv[]);
static int run_echo_daemon (const char *cmd, size_t argc, char *argv[]);
static int run_find0 (const char *cmd, size_t argc, char *argv[]);
static int run_case_sensitive_path (const char *cmd, size_t argc, char *argv[]);
static int run_vfs_type (const char *cmd, size_t argc, char *argv[]);
static int run_truncate (const char *cmd, size_t argc, char *argv[]);
static int run_truncate_size (const char *cmd, size_t argc, char *argv[]);
static int run_utimens (const char *cmd, size_t argc, char *argv[]);
static int run_mkdir_mode (const char *cmd, size_t argc, char *argv[]);
static int run_lchown (const char *cmd, size_t argc, char *argv[]);
static int run_lstatlist (const char *cmd, size_t argc, char *argv[]);
static int run_lxattrlist (const char *cmd, size_t argc, char *argv[]);
static int run_readlinklist (const char *cmd, size_t argc, char *argv[]);
static int run_pread (const char *cmd, size_t argc, char *argv[]);
static int run_part_init (const char *cmd, size_t argc, char *argv[]);
static int run_part_add (const char *cmd, size_t argc, char *argv[]);
static int run_part_disk (const char *cmd, size_t argc, char *argv[]);
static int run_part_set_bootable (const char *cmd, size_t argc, char *argv[]);
static int run_part_set_name (const char *cmd, size_t argc, char *argv[]);
static int run_part_list (const char *cmd, size_t argc, char *argv[]);
static int run_part_get_parttype (const char *cmd, size_t argc, char *argv[]);
static int run_fill (const char *cmd, size_t argc, char *argv[]);
static int run_available (const char *cmd, size_t argc, char *argv[]);
static int run_dd (const char *cmd, size_t argc, char *argv[]);
static int run_filesize (const char *cmd, size_t argc, char *argv[]);
static int run_lvrename (const char *cmd, size_t argc, char *argv[]);
static int run_vgrename (const char *cmd, size_t argc, char *argv[]);
static int run_initrd_cat (const char *cmd, size_t argc, char *argv[]);
static int run_pvuuid (const char *cmd, size_t argc, char *argv[]);
static int run_vguuid (const char *cmd, size_t argc, char *argv[]);
static int run_lvuuid (const char *cmd, size_t argc, char *argv[]);
static int run_vgpvuuids (const char *cmd, size_t argc, char *argv[]);
static int run_vglvuuids (const char *cmd, size_t argc, char *argv[]);
static int run_copy_size (const char *cmd, size_t argc, char *argv[]);
static int run_zero_device (const char *cmd, size_t argc, char *argv[]);
static int run_txz_in (const char *cmd, size_t argc, char *argv[]);
static int run_txz_out (const char *cmd, size_t argc, char *argv[]);
static int run_ntfsresize (const char *cmd, size_t argc, char *argv[]);
static int run_vgscan (const char *cmd, size_t argc, char *argv[]);
static int run_part_del (const char *cmd, size_t argc, char *argv[]);
static int run_part_get_bootable (const char *cmd, size_t argc, char *argv[]);
static int run_part_get_mbr_id (const char *cmd, size_t argc, char *argv[]);
static int run_part_set_mbr_id (const char *cmd, size_t argc, char *argv[]);
static int run_checksum_device (const char *cmd, size_t argc, char *argv[]);
static int run_lvresize_free (const char *cmd, size_t argc, char *argv[]);
static int run_aug_clear (const char *cmd, size_t argc, char *argv[]);
static int run_get_umask (const char *cmd, size_t argc, char *argv[]);
static int run_debug_upload (const char *cmd, size_t argc, char *argv[]);
static int run_base64_in (const char *cmd, size_t argc, char *argv[]);
static int run_base64_out (const char *cmd, size_t argc, char *argv[]);
static int run_checksums_out (const char *cmd, size_t argc, char *argv[]);
static int run_fill_pattern (const char *cmd, size_t argc, char *argv[]);
static int run_write (const char *cmd, size_t argc, char *argv[]);
static int run_pwrite (const char *cmd, size_t argc, char *argv[]);
static int run_resize2fs_size (const char *cmd, size_t argc, char *argv[]);
static int run_pvresize_size (const char *cmd, size_t argc, char *argv[]);
static int run_ntfsresize_size (const char *cmd, size_t argc, char *argv[]);
static int run_available_all_groups (const char *cmd, size_t argc, char *argv[]);
static int run_fallocate64 (const char *cmd, size_t argc, char *argv[]);
static int run_vfs_label (const char *cmd, size_t argc, char *argv[]);
static int run_vfs_uuid (const char *cmd, size_t argc, char *argv[]);
static int run_lvm_set_filter (const char *cmd, size_t argc, char *argv[]);
static int run_lvm_clear_filter (const char *cmd, size_t argc, char *argv[]);
static int run_luks_open (const char *cmd, size_t argc, char *argv[]);
static int run_luks_open_ro (const char *cmd, size_t argc, char *argv[]);
static int run_luks_close (const char *cmd, size_t argc, char *argv[]);
static int run_luks_format (const char *cmd, size_t argc, char *argv[]);
static int run_luks_format_cipher (const char *cmd, size_t argc, char *argv[]);
static int run_luks_add_key (const char *cmd, size_t argc, char *argv[]);
static int run_luks_kill_slot (const char *cmd, size_t argc, char *argv[]);
static int run_is_lv (const char *cmd, size_t argc, char *argv[]);
static int run_findfs_uuid (const char *cmd, size_t argc, char *argv[]);
static int run_findfs_label (const char *cmd, size_t argc, char *argv[]);
static int run_is_chardev (const char *cmd, size_t argc, char *argv[]);
static int run_is_blockdev (const char *cmd, size_t argc, char *argv[]);
static int run_is_fifo (const char *cmd, size_t argc, char *argv[]);
static int run_is_symlink (const char *cmd, size_t argc, char *argv[]);
static int run_is_socket (const char *cmd, size_t argc, char *argv[]);
static int run_part_to_dev (const char *cmd, size_t argc, char *argv[]);
static int run_upload_offset (const char *cmd, size_t argc, char *argv[]);
static int run_download_offset (const char *cmd, size_t argc, char *argv[]);
static int run_pwrite_device (const char *cmd, size_t argc, char *argv[]);
static int run_pread_device (const char *cmd, size_t argc, char *argv[]);
static int run_lvm_canonical_lv_name (const char *cmd, size_t argc, char *argv[]);

struct command_entry alloc_cmd_entry = {
  .name = "alloc",
  .shortdesc = "allocate and add a disk file",
  .podbody = "=head1 DESCRIPTION\n\n alloc filename size\n\nThis creates an empty (zeroed) file of the given size, and then adds\nso it can be further examined.\n\nFor more advanced image creation, see L<qemu-img(1)> utility.\n\nSize can be specified using standard suffixes, eg. C<1M>.\n\nTo create a sparse file, use L</sparse> instead.  To create a\nprepared disk image, see L</PREPARED DISK IMAGES>.\n\nYou can use 'allocate' as an alias for this command.",
  .run = run_alloc
};

struct command_entry copy_in_cmd_entry = {
  .name = "copy-in",
  .shortdesc = "copy local files or directories into an image",
  .podbody = "=head1 DESCRIPTION\n\n copy-in local [local ...] /remotedir\n\nC<copy-in> copies local files or directories recursively into the disk\nimage, placing them in the directory called C</remotedir> (which must\nexist).  This guestfish meta-command turns into a sequence of\nL</tar-in> and other commands as necessary.\n\nMultiple local files and directories can be specified, but the last\nparameter must always be a remote directory.  Wildcards cannot be\nused.",
  .run = run_copy_in
};

struct command_entry copy_out_cmd_entry = {
  .name = "copy-out",
  .shortdesc = "copy remote files or directories out of an image",
  .podbody = "=head1 DESCRIPTION\n\n copy-out remote [remote ...] localdir\n\nC<copy-out> copies remote files or directories recursively out of the\ndisk image, placing them on the host disk in a local directory called\nC<localdir> (which must exist).  This guestfish meta-command turns\ninto a sequence of L</download>, L</tar-out> and other commands as\nnecessary.\n\nMultiple remote files and directories can be specified, but the last\nparameter must always be a local directory.  To download to the\ncurrent directory, use C<.> as in:\n\n copy-out /home .\n\nWildcards cannot be used in the ordinary command, but you can use\nthem with the help of L</glob> like this:\n\n glob copy-out /home/* .",
  .run = run_copy_out
};

struct command_entry echo_cmd_entry = {
  .name = "echo",
  .shortdesc = "display a line of text",
  .podbody = "=head1 DESCRIPTION\n\n echo [params ...]\n\nThis echos the parameters to the terminal.",
  .run = run_echo
};

struct command_entry edit_cmd_entry = {
  .name = "edit",
  .shortdesc = "edit a file",
  .podbody = "=head1 DESCRIPTION\n\n edit filename\n\nThis is used to edit a file.  It downloads the file, edits it\nlocally using your editor, then uploads the result.\n\nThe editor is C<$EDITOR>.  However if you use the alternate\ncommands C<vi> or C<emacs> you will get those corresponding\neditors.\n\nYou can use 'vi' or 'emacs' as an alias for this command.",
  .run = run_edit
};

struct command_entry glob_cmd_entry = {
  .name = "glob",
  .shortdesc = "expand wildcards in command",
  .podbody = "=head1 DESCRIPTION\n\n glob command args...\n\nExpand wildcards in any paths in the args list, and run C<command>\nrepeatedly on each matching path.\n\nSee L</WILDCARDS AND GLOBBING>.",
  .run = run_glob
};

struct command_entry hexedit_cmd_entry = {
  .name = "hexedit",
  .shortdesc = "edit with a hex editor",
  .podbody = "=head1 DESCRIPTION\n\n hexedit <filename|device>\n hexedit <filename|device> <max>\n hexedit <filename|device> <start> <max>\n\nUse hexedit (a hex editor) to edit all or part of a binary file\nor block device.\n\nThis command works by downloading potentially the whole file or\ndevice, editing it locally, then uploading it.  If the file or\ndevice is large, you have to specify which part you wish to edit\nby using C<max> and/or C<start> C<max> parameters.\nC<start> and C<max> are specified in bytes, with the usual\nmodifiers allowed such as C<1M> (1 megabyte).\n\nFor example to edit the first few sectors of a disk you\nmight do:\n\n hexedit /dev/sda 1M\n\nwhich would allow you to edit anywhere within the first megabyte\nof the disk.\n\nTo edit the superblock of an ext2 filesystem on C</dev/sda1>, do:\n\n hexedit /dev/sda1 0x400 0x400\n\n(assuming the superblock is in the standard location).\n\nThis command requires the external L<hexedit(1)> program.  You\ncan specify another program to use by setting the C<HEXEDITOR>\nenvironment variable.\n\nSee also L</hexdump>.",
  .run = run_hexedit
};

struct command_entry lcd_cmd_entry = {
  .name = "lcd",
  .shortdesc = "change working directory",
  .podbody = "=head1 DESCRIPTION\n\n lcd directory\n\nChange the local directory, ie. the current directory of guestfish\nitself.\n\nNote that C<!cd> won't do what you might expect.",
  .run = run_lcd
};

struct command_entry man_cmd_entry = {
  .name = "man",
  .shortdesc = "open the manual",
  .podbody = "=head1 DESCRIPTION\n\n  man\n\nOpens the manual page for guestfish.\n\nYou can use 'manual' as an alias for this command.",
  .run = run_man
};

struct command_entry more_cmd_entry = {
  .name = "more",
  .shortdesc = "view a file",
  .podbody = "=head1 DESCRIPTION\n\n more filename\n\n less filename\n\nThis is used to view a file.\n\nThe default viewer is C<$PAGER>.  However if you use the alternate\ncommand C<less> you will get the C<less> command specifically.\n\nYou can use 'less' as an alias for this command.",
  .run = run_more
};

struct command_entry reopen_cmd_entry = {
  .name = "reopen",
  .shortdesc = "close and reopen libguestfs handle",
  .podbody = "=head1 DESCRIPTION\n\n  reopen\n\nClose and reopen the libguestfs handle.  It is not necessary to use\nthis normally, because the handle is closed properly when guestfish\nexits.  However this is occasionally useful for testing.",
  .run = run_reopen
};

struct command_entry sparse_cmd_entry = {
  .name = "sparse",
  .shortdesc = "create a sparse disk image and add",
  .podbody = "=head1 DESCRIPTION\n\n sparse filename size\n\nThis creates an empty sparse file of the given size, and then adds\nso it can be further examined.\n\nIn all respects it works the same as the L</alloc> command, except that\nthe image file is allocated sparsely, which means that disk blocks are\nnot assigned to the file until they are needed.  Sparse disk files\nonly use space when written to, but they are slower and there is a\ndanger you could run out of real disk space during a write operation.\n\nFor more advanced image creation, see L<qemu-img(1)> utility.\n\nSize can be specified using standard suffixes, eg. C<1M>.",
  .run = run_sparse
};

struct command_entry supported_cmd_entry = {
  .name = "supported",
  .shortdesc = "list supported groups of commands",
  .podbody = "=head1 DESCRIPTION\n\n supported\n\nThis command returns a list of the optional groups\nknown to the daemon, and indicates which ones are\nsupported by this build of the libguestfs appliance.\n\nSee also L<guestfs(3)/AVAILABILITY>.",
  .run = run_supported
};

struct command_entry time_cmd_entry = {
  .name = "time",
  .shortdesc = "print elapsed time taken to run a command",
  .podbody = "=head1 DESCRIPTION\n\n time command args...\n\nRun the command as usual, but print the elapsed time afterwards.  This\ncan be useful for benchmarking operations.",
  .run = run_time
};

struct command_entry launch_cmd_entry = {
  .name = "launch",
  .shortdesc = "launch the qemu subprocess",
  .podbody = "=head1 SYNOPSIS\n\n launch\n\n=head1 DESCRIPTION\n\nInternally libguestfs is implemented by running a virtual machine\nusing L<qemu(1)>.\n\nYou should call this after configuring the handle\n(eg. adding drives) but before performing any actions.\n\nYou can use 'run' as an alias for this command.",
  .run = run_launch
};

struct command_entry kill_subprocess_cmd_entry = {
  .name = "kill-subprocess",
  .shortdesc = "kill the qemu subprocess",
  .podbody = "=head1 SYNOPSIS\n\n kill-subprocess\n\n=head1 DESCRIPTION\n\nThis kills the qemu subprocess.  You should never need to call this.",
  .run = run_kill_subprocess
};

struct command_entry add_drive_cmd_entry = {
  .name = "add-drive",
  .shortdesc = "add an image to examine or modify",
  .podbody = "=head1 SYNOPSIS\n\n add-drive filename\n\n=head1 DESCRIPTION\n\nThis function is the equivalent of calling C<add_drive_opts>\nwith no optional parameters, so the disk is added writable, with\nthe format being detected automatically.\n\nAutomatic detection of the format opens you up to a potential\nsecurity hole when dealing with untrusted raw-format images.\nSee CVE-2010-3851 and RHBZ#642934.  Specifying the format closes\nthis security hole.  Therefore you should think about replacing\ncalls to this function with calls to C<add_drive_opts>,\nand specifying the format.",
  .run = run_add_drive
};

struct command_entry add_cdrom_cmd_entry = {
  .name = "add-cdrom",
  .shortdesc = "add a CD-ROM disk image to examine",
  .podbody = "=head1 SYNOPSIS\n\n add-cdrom filename\n\n=head1 DESCRIPTION\n\nThis function adds a virtual CD-ROM disk image to the guest.\n\nThis is equivalent to the qemu parameter C<-cdrom filename>.\n\nNotes:\n\n=over 4\n\n=item *\n\nThis call checks for the existence of C<filename>.  This\nstops you from specifying other types of drive which are supported\nby qemu such as C<nbd:> and C<http:> URLs.  To specify those, use\nthe general C<config> call instead.\n\n=item *\n\nIf you just want to add an ISO file (often you use this as an\nefficient way to transfer large files into the guest), then you\nshould probably use C<add_drive_ro> instead.\n\n=back\n\nThis function is deprecated.\nIn new code, use the C<add_drive_opts> call instead.\n\nDeprecated functions will not be removed from the API, but the\nfact that they are deprecated indicates that there are problems\nwith correct use of these functions.",
  .run = run_add_cdrom
};

struct command_entry add_drive_ro_cmd_entry = {
  .name = "add-drive-ro",
  .shortdesc = "add a drive in snapshot mode (read-only)",
  .podbody = "=head1 SYNOPSIS\n\n add-drive-ro filename\n\n=head1 DESCRIPTION\n\nThis function is the equivalent of calling C<add_drive_opts>\nwith the optional parameter C<GUESTFS_ADD_DRIVE_OPTS_READONLY> set to 1,\nso the disk is added read-only, with the format being detected\nautomatically.\n\nYou can use 'add-ro' as an alias for this command.",
  .run = run_add_drive_ro
};

struct command_entry config_cmd_entry = {
  .name = "config",
  .shortdesc = "add qemu parameters",
  .podbody = "=head1 SYNOPSIS\n\n config qemuparam qemuvalue\n\n=head1 DESCRIPTION\n\nThis can be used to add arbitrary qemu command line parameters\nof the form C<-param value>.  Actually it's not quite arbitrary - we\nprevent you from setting some parameters which would interfere with\nparameters that we use.\n\nThe first character of C<param> string must be a C<-> (dash).\n\nC<value> can be NULL.",
  .run = run_config
};

struct command_entry set_qemu_cmd_entry = {
  .name = "set-qemu",
  .shortdesc = "set the qemu binary",
  .podbody = "=head1 SYNOPSIS\n\n set-qemu qemu\n\n=head1 DESCRIPTION\n\nSet the qemu binary that we will use.\n\nThe default is chosen when the library was compiled by the\nconfigure script.\n\nYou can also override this by setting the C<LIBGUESTFS_QEMU>\nenvironment variable.\n\nSetting C<qemu> to C<NULL> restores the default qemu binary.\n\nNote that you should call this function as early as possible\nafter creating the handle.  This is because some pre-launch\noperations depend on testing qemu features (by running C<qemu -help>).\nIf the qemu binary changes, we don't retest features, and\nso you might see inconsistent results.  Using the environment\nvariable C<LIBGUESTFS_QEMU> is safest of all since that picks\nthe qemu binary at the same time as the handle is created.\n\nYou can use 'qemu' as an alias for this command.",
  .run = run_set_qemu
};

struct command_entry get_qemu_cmd_entry = {
  .name = "get-qemu",
  .shortdesc = "get the qemu binary",
  .podbody = "=head1 SYNOPSIS\n\n get-qemu\n\n=head1 DESCRIPTION\n\nReturn the current qemu binary.\n\nThis is always non-NULL.  If it wasn't set already, then this will\nreturn the default qemu binary name.",
  .run = run_get_qemu
};

struct command_entry set_path_cmd_entry = {
  .name = "set-path",
  .shortdesc = "set the search path",
  .podbody = "=head1 SYNOPSIS\n\n set-path searchpath\n\n=head1 DESCRIPTION\n\nSet the path that libguestfs searches for kernel and initrd.img.\n\nThe default is C<$libdir/guestfs> unless overridden by setting\nC<LIBGUESTFS_PATH> environment variable.\n\nSetting C<path> to C<NULL> restores the default path.\n\nYou can use 'path' as an alias for this command.",
  .run = run_set_path
};

struct command_entry get_path_cmd_entry = {
  .name = "get-path",
  .shortdesc = "get the search path",
  .podbody = "=head1 SYNOPSIS\n\n get-path\n\n=head1 DESCRIPTION\n\nReturn the current search path.\n\nThis is always non-NULL.  If it wasn't set already, then this will\nreturn the default path.",
  .run = run_get_path
};

struct command_entry set_append_cmd_entry = {
  .name = "set-append",
  .shortdesc = "add options to kernel command line",
  .podbody = "=head1 SYNOPSIS\n\n set-append append\n\n=head1 DESCRIPTION\n\nThis function is used to add additional options to the\nguest kernel command line.\n\nThe default is C<NULL> unless overridden by setting\nC<LIBGUESTFS_APPEND> environment variable.\n\nSetting C<append> to C<NULL> means I<no> additional options\nare passed (libguestfs always adds a few of its own).\n\nYou can use 'append' as an alias for this command.",
  .run = run_set_append
};

struct command_entry get_append_cmd_entry = {
  .name = "get-append",
  .shortdesc = "get the additional kernel options",
  .podbody = "=head1 SYNOPSIS\n\n get-append\n\n=head1 DESCRIPTION\n\nReturn the additional kernel options which are added to the\nguest kernel command line.\n\nIf C<NULL> then no options are added.",
  .run = run_get_append
};

struct command_entry set_autosync_cmd_entry = {
  .name = "set-autosync",
  .shortdesc = "set autosync mode",
  .podbody = "=head1 SYNOPSIS\n\n set-autosync autosync\n\n=head1 DESCRIPTION\n\nIf C<autosync> is true, this enables autosync.  Libguestfs will make a\nbest effort attempt to run C<umount_all> followed by\nC<sync> when the handle is closed\n(also if the program exits without closing handles).\n\nThis is enabled by default (since libguestfs 1.5.24, previously it was\ndisabled by default).\n\nYou can use 'autosync' as an alias for this command.",
  .run = run_set_autosync
};

struct command_entry get_autosync_cmd_entry = {
  .name = "get-autosync",
  .shortdesc = "get autosync mode",
  .podbody = "=head1 SYNOPSIS\n\n get-autosync\n\n=head1 DESCRIPTION\n\nGet the autosync flag.",
  .run = run_get_autosync
};

struct command_entry set_verbose_cmd_entry = {
  .name = "set-verbose",
  .shortdesc = "set verbose mode",
  .podbody = "=head1 SYNOPSIS\n\n set-verbose verbose\n\n=head1 DESCRIPTION\n\nIf C<verbose> is true, this turns on verbose messages (to C<stderr>).\n\nVerbose messages are disabled unless the environment variable\nC<LIBGUESTFS_DEBUG> is defined and set to C<1>.\n\nYou can use 'verbose' as an alias for this command.",
  .run = run_set_verbose
};

struct command_entry get_verbose_cmd_entry = {
  .name = "get-verbose",
  .shortdesc = "get verbose mode",
  .podbody = "=head1 SYNOPSIS\n\n get-verbose\n\n=head1 DESCRIPTION\n\nThis returns the verbose messages flag.",
  .run = run_get_verbose
};

struct command_entry is_ready_cmd_entry = {
  .name = "is-ready",
  .shortdesc = "is ready to accept commands",
  .podbody = "=head1 SYNOPSIS\n\n is-ready\n\n=head1 DESCRIPTION\n\nThis returns true iff this handle is ready to accept commands\n(in the C<READY> state).\n\nFor more information on states, see L<guestfs(3)>.",
  .run = run_is_ready
};

struct command_entry is_config_cmd_entry = {
  .name = "is-config",
  .shortdesc = "is in configuration state",
  .podbody = "=head1 SYNOPSIS\n\n is-config\n\n=head1 DESCRIPTION\n\nThis returns true iff this handle is being configured\n(in the C<CONFIG> state).\n\nFor more information on states, see L<guestfs(3)>.",
  .run = run_is_config
};

struct command_entry is_launching_cmd_entry = {
  .name = "is-launching",
  .shortdesc = "is launching subprocess",
  .podbody = "=head1 SYNOPSIS\n\n is-launching\n\n=head1 DESCRIPTION\n\nThis returns true iff this handle is launching the subprocess\n(in the C<LAUNCHING> state).\n\nFor more information on states, see L<guestfs(3)>.",
  .run = run_is_launching
};

struct command_entry is_busy_cmd_entry = {
  .name = "is-busy",
  .shortdesc = "is busy processing a command",
  .podbody = "=head1 SYNOPSIS\n\n is-busy\n\n=head1 DESCRIPTION\n\nThis returns true iff this handle is busy processing a command\n(in the C<BUSY> state).\n\nFor more information on states, see L<guestfs(3)>.",
  .run = run_is_busy
};

struct command_entry get_state_cmd_entry = {
  .name = "get-state",
  .shortdesc = "get the current state",
  .podbody = "=head1 SYNOPSIS\n\n get-state\n\n=head1 DESCRIPTION\n\nThis returns the current state as an opaque integer.  This is\nonly useful for printing debug and internal error messages.\n\nFor more information on states, see L<guestfs(3)>.",
  .run = run_get_state
};

struct command_entry set_memsize_cmd_entry = {
  .name = "set-memsize",
  .shortdesc = "set memory allocated to the qemu subprocess",
  .podbody = "=head1 SYNOPSIS\n\n set-memsize memsize\n\n=head1 DESCRIPTION\n\nThis sets the memory size in megabytes allocated to the\nqemu subprocess.  This only has any effect if called before\nC<launch>.\n\nYou can also change this by setting the environment\nvariable C<LIBGUESTFS_MEMSIZE> before the handle is\ncreated.\n\nFor more information on the architecture of libguestfs,\nsee L<guestfs(3)>.\n\nYou can use 'memsize' as an alias for this command.",
  .run = run_set_memsize
};

struct command_entry get_memsize_cmd_entry = {
  .name = "get-memsize",
  .shortdesc = "get memory allocated to the qemu subprocess",
  .podbody = "=head1 SYNOPSIS\n\n get-memsize\n\n=head1 DESCRIPTION\n\nThis gets the memory size in megabytes allocated to the\nqemu subprocess.\n\nIf C<set_memsize> was not called\non this handle, and if C<LIBGUESTFS_MEMSIZE> was not set,\nthen this returns the compiled-in default value for memsize.\n\nFor more information on the architecture of libguestfs,\nsee L<guestfs(3)>.",
  .run = run_get_memsize
};

struct command_entry get_pid_cmd_entry = {
  .name = "get-pid",
  .shortdesc = "get PID of qemu subprocess",
  .podbody = "=head1 SYNOPSIS\n\n get-pid\n\n=head1 DESCRIPTION\n\nReturn the process ID of the qemu subprocess.  If there is no\nqemu subprocess, then this will return an error.\n\nThis is an internal call used for debugging and testing.\n\nYou can use 'pid' as an alias for this command.",
  .run = run_get_pid
};

struct command_entry version_cmd_entry = {
  .name = "version",
  .shortdesc = "get the library version number",
  .podbody = "=head1 SYNOPSIS\n\n version\n\n=head1 DESCRIPTION\n\nReturn the libguestfs version number that the program is linked\nagainst.\n\nNote that because of dynamic linking this is not necessarily\nthe version of libguestfs that you compiled against.  You can\ncompile the program, and then at runtime dynamically link\nagainst a completely different C<libguestfs.so> library.\n\nThis call was added in version C<1.0.58>.  In previous\nversions of libguestfs there was no way to get the version\nnumber.  From C code you can use dynamic linker functions\nto find out if this symbol exists (if it doesn't, then\nit's an earlier version).\n\nThe call returns a structure with four elements.  The first\nthree (C<major>, C<minor> and C<release>) are numbers and\ncorrespond to the usual version triplet.  The fourth element\n(C<extra>) is a string and is normally empty, but may be\nused for distro-specific information.\n\nTo construct the original version string:\nC<$major.$minor.$release$extra>\n\nSee also: L<guestfs(3)/LIBGUESTFS VERSION NUMBERS>.\n\nI<Note:> Don't use this call to test for availability\nof features.  In enterprise distributions we backport\nfeatures from later versions into earlier versions,\nmaking this an unreliable way to test for features.\nUse C<available> instead.",
  .run = run_version
};

struct command_entry set_selinux_cmd_entry = {
  .name = "set-selinux",
  .shortdesc = "set SELinux enabled or disabled at appliance boot",
  .podbody = "=head1 SYNOPSIS\n\n set-selinux selinux\n\n=head1 DESCRIPTION\n\nThis sets the selinux flag that is passed to the appliance\nat boot time.  The default is C<selinux=0> (disabled).\n\nNote that if SELinux is enabled, it is always in\nPermissive mode (C<enforcing=0>).\n\nFor more information on the architecture of libguestfs,\nsee L<guestfs(3)>.\n\nYou can use 'selinux' as an alias for this command.",
  .run = run_set_selinux
};

struct command_entry get_selinux_cmd_entry = {
  .name = "get-selinux",
  .shortdesc = "get SELinux enabled flag",
  .podbody = "=head1 SYNOPSIS\n\n get-selinux\n\n=head1 DESCRIPTION\n\nThis returns the current setting of the selinux flag which\nis passed to the appliance at boot time.  See C<set_selinux>.\n\nFor more information on the architecture of libguestfs,\nsee L<guestfs(3)>.",
  .run = run_get_selinux
};

struct command_entry set_trace_cmd_entry = {
  .name = "set-trace",
  .shortdesc = "enable or disable command traces",
  .podbody = "=head1 SYNOPSIS\n\n set-trace trace\n\n=head1 DESCRIPTION\n\nIf the command trace flag is set to 1, then commands are\nprinted on stderr before they are executed in a format\nwhich is very similar to the one used by guestfish.  In\nother words, you can run a program with this enabled, and\nyou will get out a script which you can feed to guestfish\nto perform the same set of actions.\n\nIf you want to trace C API calls into libguestfs (and\nother libraries) then possibly a better way is to use\nthe external ltrace(1) command.\n\nCommand traces are disabled unless the environment variable\nC<LIBGUESTFS_TRACE> is defined and set to C<1>.\n\nYou can use 'trace' as an alias for this command.",
  .run = run_set_trace
};

struct command_entry get_trace_cmd_entry = {
  .name = "get-trace",
  .shortdesc = "get command trace enabled flag",
  .podbody = "=head1 SYNOPSIS\n\n get-trace\n\n=head1 DESCRIPTION\n\nReturn the command trace flag.",
  .run = run_get_trace
};

struct command_entry set_direct_cmd_entry = {
  .name = "set-direct",
  .shortdesc = "enable or disable direct appliance mode",
  .podbody = "=head1 SYNOPSIS\n\n set-direct direct\n\n=head1 DESCRIPTION\n\nIf the direct appliance mode flag is enabled, then stdin and\nstdout are passed directly through to the appliance once it\nis launched.\n\nOne consequence of this is that log messages aren't caught\nby the library and handled by C<set_log_message_callback>,\nbut go straight to stdout.\n\nYou probably don't want to use this unless you know what you\nare doing.\n\nThe default is disabled.\n\nYou can use 'direct' as an alias for this command.",
  .run = run_set_direct
};

struct command_entry get_direct_cmd_entry = {
  .name = "get-direct",
  .shortdesc = "get direct appliance mode flag",
  .podbody = "=head1 SYNOPSIS\n\n get-direct\n\n=head1 DESCRIPTION\n\nReturn the direct appliance mode flag.",
  .run = run_get_direct
};

struct command_entry set_recovery_proc_cmd_entry = {
  .name = "set-recovery-proc",
  .shortdesc = "enable or disable the recovery process",
  .podbody = "=head1 SYNOPSIS\n\n set-recovery-proc recoveryproc\n\n=head1 DESCRIPTION\n\nIf this is called with the parameter C<false> then\nC<launch> does not create a recovery process.  The\npurpose of the recovery process is to stop runaway qemu\nprocesses in the case where the main program aborts abruptly.\n\nThis only has any effect if called before C<launch>,\nand the default is true.\n\nAbout the only time when you would want to disable this is\nif the main process will fork itself into the background\n(\"daemonize\" itself).  In this case the recovery process\nthinks that the main program has disappeared and so kills\nqemu, which is not very helpful.\n\nYou can use 'recovery-proc' as an alias for this command.",
  .run = run_set_recovery_proc
};

struct command_entry get_recovery_proc_cmd_entry = {
  .name = "get-recovery-proc",
  .shortdesc = "get recovery process enabled flag",
  .podbody = "=head1 SYNOPSIS\n\n get-recovery-proc\n\n=head1 DESCRIPTION\n\nReturn the recovery process enabled flag.",
  .run = run_get_recovery_proc
};

struct command_entry add_drive_with_if_cmd_entry = {
  .name = "add-drive-with-if",
  .shortdesc = "add a drive specifying the QEMU block emulation to use",
  .podbody = "=head1 SYNOPSIS\n\n add-drive-with-if filename iface\n\n=head1 DESCRIPTION\n\nThis is the same as C<add_drive> but it allows you\nto specify the QEMU interface emulation to use at run time.\n\nThis function is deprecated.\nIn new code, use the C<add_drive_opts> call instead.\n\nDeprecated functions will not be removed from the API, but the\nfact that they are deprecated indicates that there are problems\nwith correct use of these functions.",
  .run = run_add_drive_with_if
};

struct command_entry add_drive_ro_with_if_cmd_entry = {
  .name = "add-drive-ro-with-if",
  .shortdesc = "add a drive read-only specifying the QEMU block emulation to use",
  .podbody = "=head1 SYNOPSIS\n\n add-drive-ro-with-if filename iface\n\n=head1 DESCRIPTION\n\nThis is the same as C<add_drive_ro> but it allows you\nto specify the QEMU interface emulation to use at run time.\n\nThis function is deprecated.\nIn new code, use the C<add_drive_opts> call instead.\n\nDeprecated functions will not be removed from the API, but the\nfact that they are deprecated indicates that there are problems\nwith correct use of these functions.",
  .run = run_add_drive_ro_with_if
};

struct command_entry file_architecture_cmd_entry = {
  .name = "file-architecture",
  .shortdesc = "detect the architecture of a binary file",
  .podbody = "=head1 SYNOPSIS\n\n file-architecture filename\n\n=head1 DESCRIPTION\n\nThis detects the architecture of the binary C<filename>,\nand returns it if known.\n\nCurrently defined architectures are:\n\n=over 4\n\n=item \"i386\"\n\nThis string is returned for all 32 bit i386, i486, i586, i686 binaries\nirrespective of the precise processor requirements of the binary.\n\n=item \"x86_64\"\n\n64 bit x86-64.\n\n=item \"sparc\"\n\n32 bit SPARC.\n\n=item \"sparc64\"\n\n64 bit SPARC V9 and above.\n\n=item \"ia64\"\n\nIntel Itanium.\n\n=item \"ppc\"\n\n32 bit Power PC.\n\n=item \"ppc64\"\n\n64 bit Power PC.\n\n=back\n\nLibguestfs may return other architecture strings in future.\n\nThe function works on at least the following types of files:\n\n=over 4\n\n=item *\n\nmany types of Un*x and Linux binary\n\n=item *\n\nmany types of Un*x and Linux shared library\n\n=item *\n\nWindows Win32 and Win64 binaries\n\n=item *\n\nWindows Win32 and Win64 DLLs\n\nWin32 binaries and DLLs return C<i386>.\n\nWin64 binaries and DLLs return C<x86_64>.\n\n=item *\n\nLinux kernel modules\n\n=item *\n\nLinux new-style initrd images\n\n=item *\n\nsome non-x86 Linux vmlinuz kernels\n\n=back\n\nWhat it can't do currently:\n\n=over 4\n\n=item *\n\nstatic libraries (libfoo.a)\n\n=item *\n\nLinux old-style initrd as compressed ext2 filesystem (RHEL 3)\n\n=item *\n\nx86 Linux vmlinuz kernels\n\nx86 vmlinuz images (bzImage format) consist of a mix of 16-, 32- and\ncompressed code, and are horribly hard to unpack.  If you want to find\nthe architecture of a kernel, use the architecture of the associated\ninitrd or kernel module(s) instead.\n\n=back",
  .run = run_file_architecture
};

struct command_entry inspect_os_cmd_entry = {
  .name = "inspect-os",
  .shortdesc = "inspect disk and return list of operating systems found",
  .podbody = "=head1 SYNOPSIS\n\n inspect-os\n\n=head1 DESCRIPTION\n\nThis function uses other libguestfs functions and certain\nheuristics to inspect the disk(s) (usually disks belonging to\na virtual machine), looking for operating systems.\n\nThe list returned is empty if no operating systems were found.\n\nIf one operating system was found, then this returns a list with\na single element, which is the name of the root filesystem of\nthis operating system.  It is also possible for this function\nto return a list containing more than one element, indicating\na dual-boot or multi-boot virtual machine, with each element being\nthe root filesystem of one of the operating systems.\n\nYou can pass the root string(s) returned to other\nC<inspect_get_*> functions in order to query further\ninformation about each operating system, such as the name\nand version.\n\nThis function uses other libguestfs features such as\nC<mount_ro> and C<umount_all> in order to mount\nand unmount filesystems and look at the contents.  This should\nbe called with no disks currently mounted.  The function may also\nuse Augeas, so any existing Augeas handle will be closed.\n\nThis function cannot decrypt encrypted disks.  The caller\nmust do that first (supplying the necessary keys) if the\ndisk is encrypted.\n\nPlease read L<guestfs(3)/INSPECTION> for more details.\n\nSee also C<list_filesystems>.",
  .run = run_inspect_os
};

struct command_entry inspect_get_type_cmd_entry = {
  .name = "inspect-get-type",
  .shortdesc = "get type of inspected operating system",
  .podbody = "=head1 SYNOPSIS\n\n inspect-get-type root\n\n=head1 DESCRIPTION\n\nThis function should only be called with a root device string\nas returned by C<inspect_os>.\n\nThis returns the type of the inspected operating system.\nCurrently defined types are:\n\n=over 4\n\n=item \"linux\"\n\nAny Linux-based operating system.\n\n=item \"windows\"\n\nAny Microsoft Windows operating system.\n\n=item \"unknown\"\n\nThe operating system type could not be determined.\n\n=back\n\nFuture versions of libguestfs may return other strings here.\nThe caller should be prepared to handle any string.\n\nPlease read L<guestfs(3)/INSPECTION> for more details.",
  .run = run_inspect_get_type
};

struct command_entry inspect_get_arch_cmd_entry = {
  .name = "inspect-get-arch",
  .shortdesc = "get architecture of inspected operating system",
  .podbody = "=head1 SYNOPSIS\n\n inspect-get-arch root\n\n=head1 DESCRIPTION\n\nThis function should only be called with a root device string\nas returned by C<inspect_os>.\n\nThis returns the architecture of the inspected operating system.\nThe possible return values are listed under\nC<file_architecture>.\n\nIf the architecture could not be determined, then the\nstring C<unknown> is returned.\n\nPlease read L<guestfs(3)/INSPECTION> for more details.",
  .run = run_inspect_get_arch
};

struct command_entry inspect_get_distro_cmd_entry = {
  .name = "inspect-get-distro",
  .shortdesc = "get distro of inspected operating system",
  .podbody = "=head1 SYNOPSIS\n\n inspect-get-distro root\n\n=head1 DESCRIPTION\n\nThis function should only be called with a root device string\nas returned by C<inspect_os>.\n\nThis returns the distro (distribution) of the inspected operating\nsystem.\n\nCurrently defined distros are:\n\n=over 4\n\n=item \"archlinux\"\n\nArch Linux.\n\n=item \"debian\"\n\nDebian.\n\n=item \"fedora\"\n\nFedora.\n\n=item \"gentoo\"\n\nGentoo.\n\n=item \"meego\"\n\nMeeGo.\n\n=item \"pardus\"\n\nPardus.\n\n=item \"redhat-based\"\n\nSome Red Hat-derived distro.\n\n=item \"rhel\"\n\nRed Hat Enterprise Linux and some derivatives.\n\n=item \"ubuntu\"\n\nUbuntu.\n\n=item \"unknown\"\n\nThe distro could not be determined.\n\n=item \"windows\"\n\nWindows does not have distributions.  This string is\nreturned if the OS type is Windows.\n\n=back\n\nFuture versions of libguestfs may return other strings here.\nThe caller should be prepared to handle any string.\n\nPlease read L<guestfs(3)/INSPECTION> for more details.",
  .run = run_inspect_get_distro
};

struct command_entry inspect_get_major_version_cmd_entry = {
  .name = "inspect-get-major-version",
  .shortdesc = "get major version of inspected operating system",
  .podbody = "=head1 SYNOPSIS\n\n inspect-get-major-version root\n\n=head1 DESCRIPTION\n\nThis function should only be called with a root device string\nas returned by C<inspect_os>.\n\nThis returns the major version number of the inspected operating\nsystem.\n\nWindows uses a consistent versioning scheme which is I<not>\nreflected in the popular public names used by the operating system.\nNotably the operating system known as \"Windows 7\" is really\nversion 6.1 (ie. major = 6, minor = 1).  You can find out the\nreal versions corresponding to releases of Windows by consulting\nWikipedia or MSDN.\n\nIf the version could not be determined, then C<0> is returned.\n\nPlease read L<guestfs(3)/INSPECTION> for more details.",
  .run = run_inspect_get_major_version
};

struct command_entry inspect_get_minor_version_cmd_entry = {
  .name = "inspect-get-minor-version",
  .shortdesc = "get minor version of inspected operating system",
  .podbody = "=head1 SYNOPSIS\n\n inspect-get-minor-version root\n\n=head1 DESCRIPTION\n\nThis function should only be called with a root device string\nas returned by C<inspect_os>.\n\nThis returns the minor version number of the inspected operating\nsystem.\n\nIf the version could not be determined, then C<0> is returned.\n\nPlease read L<guestfs(3)/INSPECTION> for more details.\nSee also C<inspect_get_major_version>.",
  .run = run_inspect_get_minor_version
};

struct command_entry inspect_get_product_name_cmd_entry = {
  .name = "inspect-get-product-name",
  .shortdesc = "get product name of inspected operating system",
  .podbody = "=head1 SYNOPSIS\n\n inspect-get-product-name root\n\n=head1 DESCRIPTION\n\nThis function should only be called with a root device string\nas returned by C<inspect_os>.\n\nThis returns the product name of the inspected operating\nsystem.  The product name is generally some freeform string\nwhich can be displayed to the user, but should not be\nparsed by programs.\n\nIf the product name could not be determined, then the\nstring C<unknown> is returned.\n\nPlease read L<guestfs(3)/INSPECTION> for more details.",
  .run = run_inspect_get_product_name
};

struct command_entry inspect_get_mountpoints_cmd_entry = {
  .name = "inspect-get-mountpoints",
  .shortdesc = "get mountpoints of inspected operating system",
  .podbody = "=head1 SYNOPSIS\n\n inspect-get-mountpoints root\n\n=head1 DESCRIPTION\n\nThis function should only be called with a root device string\nas returned by C<inspect_os>.\n\nThis returns a hash of where we think the filesystems\nassociated with this operating system should be mounted.\nCallers should note that this is at best an educated guess\nmade by reading configuration files such as C</etc/fstab>.\n\nEach element in the returned hashtable has a key which\nis the path of the mountpoint (eg. C</boot>) and a value\nwhich is the filesystem that would be mounted there\n(eg. C</dev/sda1>).\n\nNon-mounted devices such as swap devices are I<not>\nreturned in this list.\n\nPlease read L<guestfs(3)/INSPECTION> for more details.\nSee also C<inspect_get_filesystems>.",
  .run = run_inspect_get_mountpoints
};

struct command_entry inspect_get_filesystems_cmd_entry = {
  .name = "inspect-get-filesystems",
  .shortdesc = "get filesystems associated with inspected operating system",
  .podbody = "=head1 SYNOPSIS\n\n inspect-get-filesystems root\n\n=head1 DESCRIPTION\n\nThis function should only be called with a root device string\nas returned by C<inspect_os>.\n\nThis returns a list of all the filesystems that we think\nare associated with this operating system.  This includes\nthe root filesystem, other ordinary filesystems, and\nnon-mounted devices like swap partitions.\n\nIn the case of a multi-boot virtual machine, it is possible\nfor a filesystem to be shared between operating systems.\n\nPlease read L<guestfs(3)/INSPECTION> for more details.\nSee also C<inspect_get_mountpoints>.",
  .run = run_inspect_get_filesystems
};

struct command_entry set_network_cmd_entry = {
  .name = "set-network",
  .shortdesc = "set enable network flag",
  .podbody = "=head1 SYNOPSIS\n\n set-network network\n\n=head1 DESCRIPTION\n\nIf C<network> is true, then the network is enabled in the\nlibguestfs appliance.  The default is false.\n\nThis affects whether commands are able to access the network\n(see L<guestfs(3)/RUNNING COMMANDS>).\n\nYou must call this before calling C<launch>, otherwise\nit has no effect.\n\nYou can use 'network' as an alias for this command.",
  .run = run_set_network
};

struct command_entry get_network_cmd_entry = {
  .name = "get-network",
  .shortdesc = "get enable network flag",
  .podbody = "=head1 SYNOPSIS\n\n get-network\n\n=head1 DESCRIPTION\n\nThis returns the enable network flag.",
  .run = run_get_network
};

struct command_entry list_filesystems_cmd_entry = {
  .name = "list-filesystems",
  .shortdesc = "list filesystems",
  .podbody = "=head1 SYNOPSIS\n\n list-filesystems\n\n=head1 DESCRIPTION\n\nThis inspection command looks for filesystems on partitions,\nblock devices and logical volumes, returning a list of devices\ncontaining filesystems and their type.\n\nThe return value is a hash, where the keys are the devices\ncontaining filesystems, and the values are the filesystem types.\nFor example:\n\n \"/dev/sda1\" => \"ntfs\"\n \"/dev/sda2\" => \"ext2\"\n \"/dev/vg_guest/lv_root\" => \"ext4\"\n \"/dev/vg_guest/lv_swap\" => \"swap\"\n\nThe value can have the special value \"unknown\", meaning the\ncontent of the device is undetermined or empty.\n\"swap\" means a Linux swap partition.\n\nThis command runs other libguestfs commands, which might include\nC<mount> and C<umount>, and therefore you should\nuse this soon after launch and only when nothing is mounted.\n\nNot all of the filesystems returned will be mountable.  In\nparticular, swap partitions are returned in the list.  Also\nthis command does not check that each filesystem\nfound is valid and mountable, and some filesystems might\nbe mountable but require special options.  Filesystems may\nnot all belong to a single logical operating system\n(use C<inspect_os> to look for OSes).",
  .run = run_list_filesystems
};

struct command_entry add_drive_opts_cmd_entry = {
  .name = "add-drive-opts",
  .shortdesc = "add an image to examine or modify",
  .podbody = "=head1 SYNOPSIS\n\n add-drive-opts filename [readonly:..] [format:..] [iface:..]\n\n=head1 DESCRIPTION\n\nThis function adds a virtual machine disk image C<filename> to\nlibguestfs.  The first time you call this function, the disk\nappears as C</dev/sda>, the second time as C</dev/sdb>, and\nso on.\n\nYou don't necessarily need to be root when using libguestfs.  However\nyou obviously do need sufficient permissions to access the filename\nfor whatever operations you want to perform (ie. read access if you\njust want to read the image or write access if you want to modify the\nimage).\n\nThis call checks that C<filename> exists.\n\nThe optional arguments are:\n\n=over 4\n\n=item C<readonly>\n\nIf true then the image is treated as read-only.  Writes are still\nallowed, but they are stored in a temporary snapshot overlay which\nis discarded at the end.  The disk that you add is not modified.\n\n=item C<format>\n\nThis forces the image format.  If you omit this (or use C<add_drive>\nor C<add_drive_ro>) then the format is automatically detected.\nPossible formats include C<raw> and C<qcow2>.\n\nAutomatic detection of the format opens you up to a potential\nsecurity hole when dealing with untrusted raw-format images.\nSee CVE-2010-3851 and RHBZ#642934.  Specifying the format closes\nthis security hole.\n\n=item C<iface>\n\nThis rarely-used option lets you emulate the behaviour of the\ndeprecated C<add_drive_with_if> call (q.v.)\n\n=back\n\nYou can use 'add' as an alias for this command.",
  .run = run_add_drive_opts
};

struct command_entry inspect_get_windows_systemroot_cmd_entry = {
  .name = "inspect-get-windows-systemroot",
  .shortdesc = "get Windows systemroot of inspected operating system",
  .podbody = "=head1 SYNOPSIS\n\n inspect-get-windows-systemroot root\n\n=head1 DESCRIPTION\n\nThis function should only be called with a root device string\nas returned by C<inspect_os>.\n\nThis returns the Windows systemroot of the inspected guest.\nThe systemroot is a directory path such as C</WINDOWS>.\n\nThis call assumes that the guest is Windows and that the\nsystemroot could be determined by inspection.  If this is not\nthe case then an error is returned.\n\nPlease read L<guestfs(3)/INSPECTION> for more details.",
  .run = run_inspect_get_windows_systemroot
};

struct command_entry mount_cmd_entry = {
  .name = "mount",
  .shortdesc = "mount a guest disk at a position in the filesystem",
  .podbody = "=head1 SYNOPSIS\n\n mount device mountpoint\n\n=head1 DESCRIPTION\n\nMount a guest disk at a position in the filesystem.  Block devices\nare named C</dev/sda>, C</dev/sdb> and so on, as they were added to\nthe guest.  If those block devices contain partitions, they will have\nthe usual names (eg. C</dev/sda1>).  Also LVM C</dev/VG/LV>-style\nnames can be used.\n\nThe rules are the same as for L<mount(2)>:  A filesystem must\nfirst be mounted on C</> before others can be mounted.  Other\nfilesystems can only be mounted on directories which already\nexist.\n\nThe mounted filesystem is writable, if we have sufficient permissions\non the underlying device.\n\nB<Important note:>\nWhen you use this call, the filesystem options C<sync> and C<noatime>\nare set implicitly.  This was originally done because we thought it\nwould improve reliability, but it turns out that I<-o sync> has a\nvery large negative performance impact and negligible effect on\nreliability.  Therefore we recommend that you avoid using\nC<mount> in any code that needs performance, and instead\nuse C<mount_options> (use an empty string for the first\nparameter if you don't want any options).",
  .run = run_mount
};

struct command_entry sync_cmd_entry = {
  .name = "sync",
  .shortdesc = "sync disks, writes are flushed through to the disk image",
  .podbody = "=head1 SYNOPSIS\n\n sync\n\n=head1 DESCRIPTION\n\nThis syncs the disk, so that any writes are flushed through to the\nunderlying disk image.\n\nYou should always call this if you have modified a disk image, before\nclosing the handle.",
  .run = run_sync
};

struct command_entry touch_cmd_entry = {
  .name = "touch",
  .shortdesc = "update file timestamps or create a new file",
  .podbody = "=head1 SYNOPSIS\n\n touch path\n\n=head1 DESCRIPTION\n\nTouch acts like the L<touch(1)> command.  It can be used to\nupdate the timestamps on a file, or, if the file does not exist,\nto create a new zero-length file.\n\nThis command only works on regular files, and will fail on other\nfile types such as directories, symbolic links, block special etc.",
  .run = run_touch
};

struct command_entry cat_cmd_entry = {
  .name = "cat",
  .shortdesc = "list the contents of a file",
  .podbody = "=head1 SYNOPSIS\n\n cat path\n\n=head1 DESCRIPTION\n\nReturn the contents of the file named C<path>.\n\nNote that this function cannot correctly handle binary files\n(specifically, files containing C<\\0> character which is treated\nas end of string).  For those you need to use the C<read_file>\nor C<download> functions which have a more complex interface.\n\nBecause of the message protocol, there is a transfer limit\nof somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.",
  .run = run_cat
};

struct command_entry ll_cmd_entry = {
  .name = "ll",
  .shortdesc = "list the files in a directory (long format)",
  .podbody = "=head1 SYNOPSIS\n\n ll directory\n\n=head1 DESCRIPTION\n\nList the files in C<directory> (relative to the root directory,\nthere is no cwd) in the format of 'ls -la'.\n\nThis command is mostly useful for interactive sessions.  It\nis I<not> intended that you try to parse the output string.",
  .run = run_ll
};

struct command_entry ls_cmd_entry = {
  .name = "ls",
  .shortdesc = "list the files in a directory",
  .podbody = "=head1 SYNOPSIS\n\n ls directory\n\n=head1 DESCRIPTION\n\nList the files in C<directory> (relative to the root directory,\nthere is no cwd).  The '.' and '..' entries are not returned, but\nhidden files are shown.\n\nThis command is mostly useful for interactive sessions.  Programs\nshould probably use C<readdir> instead.",
  .run = run_ls
};

struct command_entry list_devices_cmd_entry = {
  .name = "list-devices",
  .shortdesc = "list the block devices",
  .podbody = "=head1 SYNOPSIS\n\n list-devices\n\n=head1 DESCRIPTION\n\nList all the block devices.\n\nThe full block device names are returned, eg. C</dev/sda>.\n\nSee also C<list_filesystems>.",
  .run = run_list_devices
};

struct command_entry list_partitions_cmd_entry = {
  .name = "list-partitions",
  .shortdesc = "list the partitions",
  .podbody = "=head1 SYNOPSIS\n\n list-partitions\n\n=head1 DESCRIPTION\n\nList all the partitions detected on all block devices.\n\nThe full partition device names are returned, eg. C</dev/sda1>\n\nThis does not return logical volumes.  For that you will need to\ncall C<lvs>.\n\nSee also C<list_filesystems>.",
  .run = run_list_partitions
};

struct command_entry pvs_cmd_entry = {
  .name = "pvs",
  .shortdesc = "list the LVM physical volumes (PVs)",
  .podbody = "=head1 SYNOPSIS\n\n pvs\n\n=head1 DESCRIPTION\n\nList all the physical volumes detected.  This is the equivalent\nof the L<pvs(8)> command.\n\nThis returns a list of just the device names that contain\nPVs (eg. C</dev/sda2>).\n\nSee also C<pvs_full>.",
  .run = run_pvs
};

struct command_entry vgs_cmd_entry = {
  .name = "vgs",
  .shortdesc = "list the LVM volume groups (VGs)",
  .podbody = "=head1 SYNOPSIS\n\n vgs\n\n=head1 DESCRIPTION\n\nList all the volumes groups detected.  This is the equivalent\nof the L<vgs(8)> command.\n\nThis returns a list of just the volume group names that were\ndetected (eg. C<VolGroup00>).\n\nSee also C<vgs_full>.",
  .run = run_vgs
};

struct command_entry lvs_cmd_entry = {
  .name = "lvs",
  .shortdesc = "list the LVM logical volumes (LVs)",
  .podbody = "=head1 SYNOPSIS\n\n lvs\n\n=head1 DESCRIPTION\n\nList all the logical volumes detected.  This is the equivalent\nof the L<lvs(8)> command.\n\nThis returns a list of the logical volume device names\n(eg. C</dev/VolGroup00/LogVol00>).\n\nSee also C<lvs_full>, C<list_filesystems>.",
  .run = run_lvs
};

struct command_entry pvs_full_cmd_entry = {
  .name = "pvs-full",
  .shortdesc = "list the LVM physical volumes (PVs)",
  .podbody = "=head1 SYNOPSIS\n\n pvs-full\n\n=head1 DESCRIPTION\n\nList all the physical volumes detected.  This is the equivalent\nof the L<pvs(8)> command.  The \"full\" version includes all fields.",
  .run = run_pvs_full
};

struct command_entry vgs_full_cmd_entry = {
  .name = "vgs-full",
  .shortdesc = "list the LVM volume groups (VGs)",
  .podbody = "=head1 SYNOPSIS\n\n vgs-full\n\n=head1 DESCRIPTION\n\nList all the volumes groups detected.  This is the equivalent\nof the L<vgs(8)> command.  The \"full\" version includes all fields.",
  .run = run_vgs_full
};

struct command_entry lvs_full_cmd_entry = {
  .name = "lvs-full",
  .shortdesc = "list the LVM logical volumes (LVs)",
  .podbody = "=head1 SYNOPSIS\n\n lvs-full\n\n=head1 DESCRIPTION\n\nList all the logical volumes detected.  This is the equivalent\nof the L<lvs(8)> command.  The \"full\" version includes all fields.",
  .run = run_lvs_full
};

struct command_entry read_lines_cmd_entry = {
  .name = "read-lines",
  .shortdesc = "read file as lines",
  .podbody = "=head1 SYNOPSIS\n\n read-lines path\n\n=head1 DESCRIPTION\n\nReturn the contents of the file named C<path>.\n\nThe file contents are returned as a list of lines.  Trailing\nC<LF> and C<CRLF> character sequences are I<not> returned.\n\nNote that this function cannot correctly handle binary files\n(specifically, files containing C<\\0> character which is treated\nas end of line).  For those you need to use the C<read_file>\nfunction which has a more complex interface.",
  .run = run_read_lines
};

struct command_entry aug_init_cmd_entry = {
  .name = "aug-init",
  .shortdesc = "create a new Augeas handle",
  .podbody = "=head1 SYNOPSIS\n\n aug-init root flags\n\n=head1 DESCRIPTION\n\nCreate a new Augeas handle for editing configuration files.\nIf there was any previous Augeas handle associated with this\nguestfs session, then it is closed.\n\nYou must call this before using any other C<aug_*>\ncommands.\n\nC<root> is the filesystem root.  C<root> must not be NULL,\nuse C</> instead.\n\nThe flags are the same as the flags defined in\nE<lt>augeas.hE<gt>, the logical I<or> of the following\nintegers:\n\n=over 4\n\n=item C<AUG_SAVE_BACKUP> = 1\n\nKeep the original file with a C<.augsave> extension.\n\n=item C<AUG_SAVE_NEWFILE> = 2\n\nSave changes into a file with extension C<.augnew>, and\ndo not overwrite original.  Overrides C<AUG_SAVE_BACKUP>.\n\n=item C<AUG_TYPE_CHECK> = 4\n\nTypecheck lenses (can be expensive).\n\n=item C<AUG_NO_STDINC> = 8\n\nDo not use standard load path for modules.\n\n=item C<AUG_SAVE_NOOP> = 16\n\nMake save a no-op, just record what would have been changed.\n\n=item C<AUG_NO_LOAD> = 32\n\nDo not load the tree in C<aug_init>.\n\n=back\n\nTo close the handle, you can call C<aug_close>.\n\nTo find out more about Augeas, see L<http://augeas.net/>.",
  .run = run_aug_init
};

struct command_entry aug_close_cmd_entry = {
  .name = "aug-close",
  .shortdesc = "close the current Augeas handle",
  .podbody = "=head1 SYNOPSIS\n\n aug-close\n\n=head1 DESCRIPTION\n\nClose the current Augeas handle and free up any resources\nused by it.  After calling this, you have to call\nC<aug_init> again before you can use any other\nAugeas functions.",
  .run = run_aug_close
};

struct command_entry aug_defvar_cmd_entry = {
  .name = "aug-defvar",
  .shortdesc = "define an Augeas variable",
  .podbody = "=head1 SYNOPSIS\n\n aug-defvar name expr\n\n=head1 DESCRIPTION\n\nDefines an Augeas variable C<name> whose value is the result\nof evaluating C<expr>.  If C<expr> is NULL, then C<name> is\nundefined.\n\nOn success this returns the number of nodes in C<expr>, or\nC<0> if C<expr> evaluates to something which is not a nodeset.",
  .run = run_aug_defvar
};

struct command_entry aug_defnode_cmd_entry = {
  .name = "aug-defnode",
  .shortdesc = "define an Augeas node",
  .podbody = "=head1 SYNOPSIS\n\n aug-defnode name expr val\n\n=head1 DESCRIPTION\n\nDefines a variable C<name> whose value is the result of\nevaluating C<expr>.\n\nIf C<expr> evaluates to an empty nodeset, a node is created,\nequivalent to calling C<aug_set> C<expr>, C<value>.\nC<name> will be the nodeset containing that single node.\n\nOn success this returns a pair containing the\nnumber of nodes in the nodeset, and a boolean flag\nif a node was created.",
  .run = run_aug_defnode
};

struct command_entry aug_get_cmd_entry = {
  .name = "aug-get",
  .shortdesc = "look up the value of an Augeas path",
  .podbody = "=head1 SYNOPSIS\n\n aug-get augpath\n\n=head1 DESCRIPTION\n\nLook up the value associated with C<path>.  If C<path>\nmatches exactly one node, the C<value> is returned.",
  .run = run_aug_get
};

struct command_entry aug_set_cmd_entry = {
  .name = "aug-set",
  .shortdesc = "set Augeas path to value",
  .podbody = "=head1 SYNOPSIS\n\n aug-set augpath val\n\n=head1 DESCRIPTION\n\nSet the value associated with C<path> to C<val>.\n\nIn the Augeas API, it is possible to clear a node by setting\nthe value to NULL.  Due to an oversight in the libguestfs API\nyou cannot do that with this call.  Instead you must use the\nC<aug_clear> call.",
  .run = run_aug_set
};

struct command_entry aug_insert_cmd_entry = {
  .name = "aug-insert",
  .shortdesc = "insert a sibling Augeas node",
  .podbody = "=head1 SYNOPSIS\n\n aug-insert augpath label before\n\n=head1 DESCRIPTION\n\nCreate a new sibling C<label> for C<path>, inserting it into\nthe tree before or after C<path> (depending on the boolean\nflag C<before>).\n\nC<path> must match exactly one existing node in the tree, and\nC<label> must be a label, ie. not contain C</>, C<*> or end\nwith a bracketed index C<[N]>.",
  .run = run_aug_insert
};

struct command_entry aug_rm_cmd_entry = {
  .name = "aug-rm",
  .shortdesc = "remove an Augeas path",
  .podbody = "=head1 SYNOPSIS\n\n aug-rm augpath\n\n=head1 DESCRIPTION\n\nRemove C<path> and all of its children.\n\nOn success this returns the number of entries which were removed.",
  .run = run_aug_rm
};

struct command_entry aug_mv_cmd_entry = {
  .name = "aug-mv",
  .shortdesc = "move Augeas node",
  .podbody = "=head1 SYNOPSIS\n\n aug-mv src dest\n\n=head1 DESCRIPTION\n\nMove the node C<src> to C<dest>.  C<src> must match exactly\none node.  C<dest> is overwritten if it exists.",
  .run = run_aug_mv
};

struct command_entry aug_match_cmd_entry = {
  .name = "aug-match",
  .shortdesc = "return Augeas nodes which match augpath",
  .podbody = "=head1 SYNOPSIS\n\n aug-match augpath\n\n=head1 DESCRIPTION\n\nReturns a list of paths which match the path expression C<path>.\nThe returned paths are sufficiently qualified so that they match\nexactly one node in the current tree.",
  .run = run_aug_match
};

struct command_entry aug_save_cmd_entry = {
  .name = "aug-save",
  .shortdesc = "write all pending Augeas changes to disk",
  .podbody = "=head1 SYNOPSIS\n\n aug-save\n\n=head1 DESCRIPTION\n\nThis writes all pending changes to disk.\n\nThe flags which were passed to C<aug_init> affect exactly\nhow files are saved.",
  .run = run_aug_save
};

struct command_entry aug_load_cmd_entry = {
  .name = "aug-load",
  .shortdesc = "load files into the tree",
  .podbody = "=head1 SYNOPSIS\n\n aug-load\n\n=head1 DESCRIPTION\n\nLoad files into the tree.\n\nSee C<aug_load> in the Augeas documentation for the full gory\ndetails.",
  .run = run_aug_load
};

struct command_entry aug_ls_cmd_entry = {
  .name = "aug-ls",
  .shortdesc = "list Augeas nodes under augpath",
  .podbody = "=head1 SYNOPSIS\n\n aug-ls augpath\n\n=head1 DESCRIPTION\n\nThis is just a shortcut for listing C<aug_match>\nC<path/*> and sorting the resulting nodes into alphabetical order.",
  .run = run_aug_ls
};

struct command_entry rm_cmd_entry = {
  .name = "rm",
  .shortdesc = "remove a file",
  .podbody = "=head1 SYNOPSIS\n\n rm path\n\n=head1 DESCRIPTION\n\nRemove the single file C<path>.",
  .run = run_rm
};

struct command_entry rmdir_cmd_entry = {
  .name = "rmdir",
  .shortdesc = "remove a directory",
  .podbody = "=head1 SYNOPSIS\n\n rmdir path\n\n=head1 DESCRIPTION\n\nRemove the single directory C<path>.",
  .run = run_rmdir
};

struct command_entry rm_rf_cmd_entry = {
  .name = "rm-rf",
  .shortdesc = "remove a file or directory recursively",
  .podbody = "=head1 SYNOPSIS\n\n rm-rf path\n\n=head1 DESCRIPTION\n\nRemove the file or directory C<path>, recursively removing the\ncontents if its a directory.  This is like the C<rm -rf> shell\ncommand.",
  .run = run_rm_rf
};

struct command_entry mkdir_cmd_entry = {
  .name = "mkdir",
  .shortdesc = "create a directory",
  .podbody = "=head1 SYNOPSIS\n\n mkdir path\n\n=head1 DESCRIPTION\n\nCreate a directory named C<path>.",
  .run = run_mkdir
};

struct command_entry mkdir_p_cmd_entry = {
  .name = "mkdir-p",
  .shortdesc = "create a directory and parents",
  .podbody = "=head1 SYNOPSIS\n\n mkdir-p path\n\n=head1 DESCRIPTION\n\nCreate a directory named C<path>, creating any parent directories\nas necessary.  This is like the C<mkdir -p> shell command.",
  .run = run_mkdir_p
};

struct command_entry chmod_cmd_entry = {
  .name = "chmod",
  .shortdesc = "change file mode",
  .podbody = "=head1 SYNOPSIS\n\n chmod mode path\n\n=head1 DESCRIPTION\n\nChange the mode (permissions) of C<path> to C<mode>.  Only\nnumeric modes are supported.\n\nI<Note>: When using this command from guestfish, C<mode>\nby default would be decimal, unless you prefix it with\nC<0> to get octal, ie. use C<0700> not C<700>.\n\nThe mode actually set is affected by the umask.",
  .run = run_chmod
};

struct command_entry chown_cmd_entry = {
  .name = "chown",
  .shortdesc = "change file owner and group",
  .podbody = "=head1 SYNOPSIS\n\n chown owner group path\n\n=head1 DESCRIPTION\n\nChange the file owner to C<owner> and group to C<group>.\n\nOnly numeric uid and gid are supported.  If you want to use\nnames, you will need to locate and parse the password file\nyourself (Augeas support makes this relatively easy).",
  .run = run_chown
};

struct command_entry exists_cmd_entry = {
  .name = "exists",
  .shortdesc = "test if file or directory exists",
  .podbody = "=head1 SYNOPSIS\n\n exists path\n\n=head1 DESCRIPTION\n\nThis returns C<true> if and only if there is a file, directory\n(or anything) with the given C<path> name.\n\nSee also C<is_file>, C<is_dir>, C<stat>.",
  .run = run_exists
};

struct command_entry is_file_cmd_entry = {
  .name = "is-file",
  .shortdesc = "test if a regular file",
  .podbody = "=head1 SYNOPSIS\n\n is-file path\n\n=head1 DESCRIPTION\n\nThis returns C<true> if and only if there is a regular file\nwith the given C<path> name.  Note that it returns false for\nother objects like directories.\n\nSee also C<stat>.",
  .run = run_is_file
};

struct command_entry is_dir_cmd_entry = {
  .name = "is-dir",
  .shortdesc = "test if a directory",
  .podbody = "=head1 SYNOPSIS\n\n is-dir path\n\n=head1 DESCRIPTION\n\nThis returns C<true> if and only if there is a directory\nwith the given C<path> name.  Note that it returns false for\nother objects like files.\n\nSee also C<stat>.",
  .run = run_is_dir
};

struct command_entry pvcreate_cmd_entry = {
  .name = "pvcreate",
  .shortdesc = "create an LVM physical volume",
  .podbody = "=head1 SYNOPSIS\n\n pvcreate device\n\n=head1 DESCRIPTION\n\nThis creates an LVM physical volume on the named C<device>,\nwhere C<device> should usually be a partition name such\nas C</dev/sda1>.",
  .run = run_pvcreate
};

struct command_entry vgcreate_cmd_entry = {
  .name = "vgcreate",
  .shortdesc = "create an LVM volume group",
  .podbody = "=head1 SYNOPSIS\n\n vgcreate volgroup physvols\n\n=head1 DESCRIPTION\n\nThis creates an LVM volume group called C<volgroup>\nfrom the non-empty list of physical volumes C<physvols>.",
  .run = run_vgcreate
};

struct command_entry lvcreate_cmd_entry = {
  .name = "lvcreate",
  .shortdesc = "create an LVM logical volume",
  .podbody = "=head1 SYNOPSIS\n\n lvcreate logvol volgroup mbytes\n\n=head1 DESCRIPTION\n\nThis creates an LVM logical volume called C<logvol>\non the volume group C<volgroup>, with C<size> megabytes.",
  .run = run_lvcreate
};

struct command_entry mkfs_cmd_entry = {
  .name = "mkfs",
  .shortdesc = "make a filesystem",
  .podbody = "=head1 SYNOPSIS\n\n mkfs fstype device\n\n=head1 DESCRIPTION\n\nThis creates a filesystem on C<device> (usually a partition\nor LVM logical volume).  The filesystem type is C<fstype>, for\nexample C<ext3>.",
  .run = run_mkfs
};

struct command_entry sfdisk_cmd_entry = {
  .name = "sfdisk",
  .shortdesc = "create partitions on a block device",
  .podbody = "=head1 SYNOPSIS\n\n sfdisk device cyls heads sectors lines\n\n=head1 DESCRIPTION\n\nThis is a direct interface to the L<sfdisk(8)> program for creating\npartitions on block devices.\n\nC<device> should be a block device, for example C</dev/sda>.\n\nC<cyls>, C<heads> and C<sectors> are the number of cylinders, heads\nand sectors on the device, which are passed directly to sfdisk as\nthe I<-C>, I<-H> and I<-S> parameters.  If you pass C<0> for any\nof these, then the corresponding parameter is omitted.  Usually for\n'large' disks, you can just pass C<0> for these, but for small\n(floppy-sized) disks, sfdisk (or rather, the kernel) cannot work\nout the right geometry and you will need to tell it.\n\nC<lines> is a list of lines that we feed to C<sfdisk>.  For more\ninformation refer to the L<sfdisk(8)> manpage.\n\nTo create a single partition occupying the whole disk, you would\npass C<lines> as a single element list, when the single element being\nthe string C<,> (comma).\n\nSee also: C<sfdisk_l>, C<sfdisk_N>,\nC<part_init>\n\nB<This command is dangerous.  Without careful use you\ncan easily destroy all your data>.",
  .run = run_sfdisk
};

struct command_entry write_file_cmd_entry = {
  .name = "write-file",
  .shortdesc = "create a file",
  .podbody = "=head1 SYNOPSIS\n\n write-file path content size\n\n=head1 DESCRIPTION\n\nThis call creates a file called C<path>.  The contents of the\nfile is the string C<content> (which can contain any 8 bit data),\nwith length C<size>.\n\nAs a special case, if C<size> is C<0>\nthen the length is calculated using C<strlen> (so in this case\nthe content cannot contain embedded ASCII NULs).\n\nI<NB.> Owing to a bug, writing content containing ASCII NUL\ncharacters does I<not> work, even if the length is specified.\n\nBecause of the message protocol, there is a transfer limit\nof somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.\n\nThis function is deprecated.\nIn new code, use the C<write> call instead.\n\nDeprecated functions will not be removed from the API, but the\nfact that they are deprecated indicates that there are problems\nwith correct use of these functions.",
  .run = run_write_file
};

struct command_entry umount_cmd_entry = {
  .name = "umount",
  .shortdesc = "unmount a filesystem",
  .podbody = "=head1 SYNOPSIS\n\n umount pathordevice\n\n=head1 DESCRIPTION\n\nThis unmounts the given filesystem.  The filesystem may be\nspecified either by its mountpoint (path) or the device which\ncontains the filesystem.\n\nYou can use 'unmount' as an alias for this command.",
  .run = run_umount
};

struct command_entry mounts_cmd_entry = {
  .name = "mounts",
  .shortdesc = "show mounted filesystems",
  .podbody = "=head1 SYNOPSIS\n\n mounts\n\n=head1 DESCRIPTION\n\nThis returns the list of currently mounted filesystems.  It returns\nthe list of devices (eg. C</dev/sda1>, C</dev/VG/LV>).\n\nSome internal mounts are not shown.\n\nSee also: C<mountpoints>",
  .run = run_mounts
};

struct command_entry umount_all_cmd_entry = {
  .name = "umount-all",
  .shortdesc = "unmount all filesystems",
  .podbody = "=head1 SYNOPSIS\n\n umount-all\n\n=head1 DESCRIPTION\n\nThis unmounts all mounted filesystems.\n\nSome internal mounts are not unmounted by this call.\n\nYou can use 'unmount-all' as an alias for this command.",
  .run = run_umount_all
};

struct command_entry lvm_remove_all_cmd_entry = {
  .name = "lvm-remove-all",
  .shortdesc = "remove all LVM LVs, VGs and PVs",
  .podbody = "=head1 SYNOPSIS\n\n lvm-remove-all\n\n=head1 DESCRIPTION\n\nThis command removes all LVM logical volumes, volume groups\nand physical volumes.\n\nB<This command is dangerous.  Without careful use you\ncan easily destroy all your data>.",
  .run = run_lvm_remove_all
};

struct command_entry file_cmd_entry = {
  .name = "file",
  .shortdesc = "determine file type",
  .podbody = "=head1 SYNOPSIS\n\n file path\n\n=head1 DESCRIPTION\n\nThis call uses the standard L<file(1)> command to determine\nthe type or contents of the file.\n\nThis call will also transparently look inside various types\nof compressed file.\n\nThe exact command which runs is C<file -zb path>.  Note in\nparticular that the filename is not prepended to the output\n(the C<-b> option).\n\nThis command can also be used on C</dev/> devices\n(and partitions, LV names).  You can for example use this\nto determine if a device contains a filesystem, although\nit's usually better to use C<vfs_type>.\n\nIf the C<path> does not begin with C</dev/> then\nthis command only works for the content of regular files.\nFor other file types (directory, symbolic link etc) it\nwill just return the string C<directory> etc.",
  .run = run_file
};

struct command_entry command_cmd_entry = {
  .name = "command",
  .shortdesc = "run a command from the guest filesystem",
  .podbody = "=head1 SYNOPSIS\n\n command arguments\n\n=head1 DESCRIPTION\n\nThis call runs a command from the guest filesystem.  The\nfilesystem must be mounted, and must contain a compatible\noperating system (ie. something Linux, with the same\nor compatible processor architecture).\n\nThe single parameter is an argv-style list of arguments.\nThe first element is the name of the program to run.\nSubsequent elements are parameters.  The list must be\nnon-empty (ie. must contain a program name).  Note that\nthe command runs directly, and is I<not> invoked via\nthe shell (see C<sh>).\n\nThe return value is anything printed to I<stdout> by\nthe command.\n\nIf the command returns a non-zero exit status, then\nthis function returns an error message.  The error message\nstring is the content of I<stderr> from the command.\n\nThe C<$PATH> environment variable will contain at least\nC</usr/bin> and C</bin>.  If you require a program from\nanother location, you should provide the full path in the\nfirst parameter.\n\nShared libraries and data files required by the program\nmust be available on filesystems which are mounted in the\ncorrect places.  It is the caller's responsibility to ensure\nall filesystems that are needed are mounted at the right\nlocations.\n\nBecause of the message protocol, there is a transfer limit\nof somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.",
  .run = run_command
};

struct command_entry command_lines_cmd_entry = {
  .name = "command-lines",
  .shortdesc = "run a command, returning lines",
  .podbody = "=head1 SYNOPSIS\n\n command-lines arguments\n\n=head1 DESCRIPTION\n\nThis is the same as C<command>, but splits the\nresult into a list of lines.\n\nSee also: C<sh_lines>\n\nBecause of the message protocol, there is a transfer limit\nof somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.",
  .run = run_command_lines
};

struct command_entry stat_cmd_entry = {
  .name = "stat",
  .shortdesc = "get file information",
  .podbody = "=head1 SYNOPSIS\n\n stat path\n\n=head1 DESCRIPTION\n\nReturns file information for the given C<path>.\n\nThis is the same as the C<stat(2)> system call.",
  .run = run_stat
};

struct command_entry lstat_cmd_entry = {
  .name = "lstat",
  .shortdesc = "get file information for a symbolic link",
  .podbody = "=head1 SYNOPSIS\n\n lstat path\n\n=head1 DESCRIPTION\n\nReturns file information for the given C<path>.\n\nThis is the same as C<stat> except that if C<path>\nis a symbolic link, then the link is stat-ed, not the file it\nrefers to.\n\nThis is the same as the C<lstat(2)> system call.",
  .run = run_lstat
};

struct command_entry statvfs_cmd_entry = {
  .name = "statvfs",
  .shortdesc = "get file system statistics",
  .podbody = "=head1 SYNOPSIS\n\n statvfs path\n\n=head1 DESCRIPTION\n\nReturns file system statistics for any mounted file system.\nC<path> should be a file or directory in the mounted file system\n(typically it is the mount point itself, but it doesn't need to be).\n\nThis is the same as the C<statvfs(2)> system call.",
  .run = run_statvfs
};

struct command_entry tune2fs_l_cmd_entry = {
  .name = "tune2fs-l",
  .shortdesc = "get ext2/ext3/ext4 superblock details",
  .podbody = "=head1 SYNOPSIS\n\n tune2fs-l device\n\n=head1 DESCRIPTION\n\nThis returns the contents of the ext2, ext3 or ext4 filesystem\nsuperblock on C<device>.\n\nIt is the same as running C<tune2fs -l device>.  See L<tune2fs(8)>\nmanpage for more details.  The list of fields returned isn't\nclearly defined, and depends on both the version of C<tune2fs>\nthat libguestfs was built against, and the filesystem itself.",
  .run = run_tune2fs_l
};

struct command_entry blockdev_setro_cmd_entry = {
  .name = "blockdev-setro",
  .shortdesc = "set block device to read-only",
  .podbody = "=head1 SYNOPSIS\n\n blockdev-setro device\n\n=head1 DESCRIPTION\n\nSets the block device named C<device> to read-only.\n\nThis uses the L<blockdev(8)> command.",
  .run = run_blockdev_setro
};

struct command_entry blockdev_setrw_cmd_entry = {
  .name = "blockdev-setrw",
  .shortdesc = "set block device to read-write",
  .podbody = "=head1 SYNOPSIS\n\n blockdev-setrw device\n\n=head1 DESCRIPTION\n\nSets the block device named C<device> to read-write.\n\nThis uses the L<blockdev(8)> command.",
  .run = run_blockdev_setrw
};

struct command_entry blockdev_getro_cmd_entry = {
  .name = "blockdev-getro",
  .shortdesc = "is block device set to read-only",
  .podbody = "=head1 SYNOPSIS\n\n blockdev-getro device\n\n=head1 DESCRIPTION\n\nReturns a boolean indicating if the block device is read-only\n(true if read-only, false if not).\n\nThis uses the L<blockdev(8)> command.",
  .run = run_blockdev_getro
};

struct command_entry blockdev_getss_cmd_entry = {
  .name = "blockdev-getss",
  .shortdesc = "get sectorsize of block device",
  .podbody = "=head1 SYNOPSIS\n\n blockdev-getss device\n\n=head1 DESCRIPTION\n\nThis returns the size of sectors on a block device.\nUsually 512, but can be larger for modern devices.\n\n(Note, this is not the size in sectors, use C<blockdev_getsz>\nfor that).\n\nThis uses the L<blockdev(8)> command.",
  .run = run_blockdev_getss
};

struct command_entry blockdev_getbsz_cmd_entry = {
  .name = "blockdev-getbsz",
  .shortdesc = "get blocksize of block device",
  .podbody = "=head1 SYNOPSIS\n\n blockdev-getbsz device\n\n=head1 DESCRIPTION\n\nThis returns the block size of a device.\n\n(Note this is different from both I<size in blocks> and\nI<filesystem block size>).\n\nThis uses the L<blockdev(8)> command.",
  .run = run_blockdev_getbsz
};

struct command_entry blockdev_setbsz_cmd_entry = {
  .name = "blockdev-setbsz",
  .shortdesc = "set blocksize of block device",
  .podbody = "=head1 SYNOPSIS\n\n blockdev-setbsz device blocksize\n\n=head1 DESCRIPTION\n\nThis sets the block size of a device.\n\n(Note this is different from both I<size in blocks> and\nI<filesystem block size>).\n\nThis uses the L<blockdev(8)> command.",
  .run = run_blockdev_setbsz
};

struct command_entry blockdev_getsz_cmd_entry = {
  .name = "blockdev-getsz",
  .shortdesc = "get total size of device in 512-byte sectors",
  .podbody = "=head1 SYNOPSIS\n\n blockdev-getsz device\n\n=head1 DESCRIPTION\n\nThis returns the size of the device in units of 512-byte sectors\n(even if the sectorsize isn't 512 bytes ... weird).\n\nSee also C<blockdev_getss> for the real sector size of\nthe device, and C<blockdev_getsize64> for the more\nuseful I<size in bytes>.\n\nThis uses the L<blockdev(8)> command.",
  .run = run_blockdev_getsz
};

struct command_entry blockdev_getsize64_cmd_entry = {
  .name = "blockdev-getsize64",
  .shortdesc = "get total size of device in bytes",
  .podbody = "=head1 SYNOPSIS\n\n blockdev-getsize64 device\n\n=head1 DESCRIPTION\n\nThis returns the size of the device in bytes.\n\nSee also C<blockdev_getsz>.\n\nThis uses the L<blockdev(8)> command.",
  .run = run_blockdev_getsize64
};

struct command_entry blockdev_flushbufs_cmd_entry = {
  .name = "blockdev-flushbufs",
  .shortdesc = "flush device buffers",
  .podbody = "=head1 SYNOPSIS\n\n blockdev-flushbufs device\n\n=head1 DESCRIPTION\n\nThis tells the kernel to flush internal buffers associated\nwith C<device>.\n\nThis uses the L<blockdev(8)> command.",
  .run = run_blockdev_flushbufs
};

struct command_entry blockdev_rereadpt_cmd_entry = {
  .name = "blockdev-rereadpt",
  .shortdesc = "reread partition table",
  .podbody = "=head1 SYNOPSIS\n\n blockdev-rereadpt device\n\n=head1 DESCRIPTION\n\nReread the partition table on C<device>.\n\nThis uses the L<blockdev(8)> command.",
  .run = run_blockdev_rereadpt
};

struct command_entry upload_cmd_entry = {
  .name = "upload",
  .shortdesc = "upload a file from the local machine",
  .podbody = "=head1 SYNOPSIS\n\n upload filename remotefilename\n\n=head1 DESCRIPTION\n\nUpload local file C<filename> to C<remotefilename> on the\nfilesystem.\n\nC<filename> can also be a named pipe.\n\nSee also C<download>.",
  .run = run_upload
};

struct command_entry download_cmd_entry = {
  .name = "download",
  .shortdesc = "download a file to the local machine",
  .podbody = "=head1 SYNOPSIS\n\n download remotefilename filename\n\n=head1 DESCRIPTION\n\nDownload file C<remotefilename> and save it as C<filename>\non the local machine.\n\nC<filename> can also be a named pipe.\n\nSee also C<upload>, C<cat>.",
  .run = run_download
};

struct command_entry checksum_cmd_entry = {
  .name = "checksum",
  .shortdesc = "compute MD5, SHAx or CRC checksum of file",
  .podbody = "=head1 SYNOPSIS\n\n checksum csumtype path\n\n=head1 DESCRIPTION\n\nThis call computes the MD5, SHAx or CRC checksum of the\nfile named C<path>.\n\nThe type of checksum to compute is given by the C<csumtype>\nparameter which must have one of the following values:\n\n=over 4\n\n=item C<crc>\n\nCompute the cyclic redundancy check (CRC) specified by POSIX\nfor the C<cksum> command.\n\n=item C<md5>\n\nCompute the MD5 hash (using the C<md5sum> program).\n\n=item C<sha1>\n\nCompute the SHA1 hash (using the C<sha1sum> program).\n\n=item C<sha224>\n\nCompute the SHA224 hash (using the C<sha224sum> program).\n\n=item C<sha256>\n\nCompute the SHA256 hash (using the C<sha256sum> program).\n\n=item C<sha384>\n\nCompute the SHA384 hash (using the C<sha384sum> program).\n\n=item C<sha512>\n\nCompute the SHA512 hash (using the C<sha512sum> program).\n\n=back\n\nThe checksum is returned as a printable string.\n\nTo get the checksum for a device, use C<checksum_device>.\n\nTo get the checksums for many files, use C<checksums_out>.",
  .run = run_checksum
};

struct command_entry tar_in_cmd_entry = {
  .name = "tar-in",
  .shortdesc = "unpack tarfile to directory",
  .podbody = "=head1 SYNOPSIS\n\n tar-in tarfile directory\n\n=head1 DESCRIPTION\n\nThis command uploads and unpacks local file C<tarfile> (an\nI<uncompressed> tar file) into C<directory>.\n\nTo upload a compressed tarball, use C<tgz_in>\nor C<txz_in>.",
  .run = run_tar_in
};

struct command_entry tar_out_cmd_entry = {
  .name = "tar-out",
  .shortdesc = "pack directory into tarfile",
  .podbody = "=head1 SYNOPSIS\n\n tar-out directory tarfile\n\n=head1 DESCRIPTION\n\nThis command packs the contents of C<directory> and downloads\nit to local file C<tarfile>.\n\nTo download a compressed tarball, use C<tgz_out>\nor C<txz_out>.",
  .run = run_tar_out
};

struct command_entry tgz_in_cmd_entry = {
  .name = "tgz-in",
  .shortdesc = "unpack compressed tarball to directory",
  .podbody = "=head1 SYNOPSIS\n\n tgz-in tarball directory\n\n=head1 DESCRIPTION\n\nThis command uploads and unpacks local file C<tarball> (a\nI<gzip compressed> tar file) into C<directory>.\n\nTo upload an uncompressed tarball, use C<tar_in>.",
  .run = run_tgz_in
};

struct command_entry tgz_out_cmd_entry = {
  .name = "tgz-out",
  .shortdesc = "pack directory into compressed tarball",
  .podbody = "=head1 SYNOPSIS\n\n tgz-out directory tarball\n\n=head1 DESCRIPTION\n\nThis command packs the contents of C<directory> and downloads\nit to local file C<tarball>.\n\nTo download an uncompressed tarball, use C<tar_out>.",
  .run = run_tgz_out
};

struct command_entry mount_ro_cmd_entry = {
  .name = "mount-ro",
  .shortdesc = "mount a guest disk, read-only",
  .podbody = "=head1 SYNOPSIS\n\n mount-ro device mountpoint\n\n=head1 DESCRIPTION\n\nThis is the same as the C<mount> command, but it\nmounts the filesystem with the read-only (I<-o ro>) flag.",
  .run = run_mount_ro
};

struct command_entry mount_options_cmd_entry = {
  .name = "mount-options",
  .shortdesc = "mount a guest disk with mount options",
  .podbody = "=head1 SYNOPSIS\n\n mount-options options device mountpoint\n\n=head1 DESCRIPTION\n\nThis is the same as the C<mount> command, but it\nallows you to set the mount options as for the\nL<mount(8)> I<-o> flag.\n\nIf the C<options> parameter is an empty string, then\nno options are passed (all options default to whatever\nthe filesystem uses).",
  .run = run_mount_options
};

struct command_entry mount_vfs_cmd_entry = {
  .name = "mount-vfs",
  .shortdesc = "mount a guest disk with mount options and vfstype",
  .podbody = "=head1 SYNOPSIS\n\n mount-vfs options vfstype device mountpoint\n\n=head1 DESCRIPTION\n\nThis is the same as the C<mount> command, but it\nallows you to set both the mount options and the vfstype\nas for the L<mount(8)> I<-o> and I<-t> flags.",
  .run = run_mount_vfs
};

struct command_entry debug_cmd_entry = {
  .name = "debug",
  .shortdesc = "debugging and internals",
  .podbody = "=head1 SYNOPSIS\n\n debug subcmd extraargs\n\n=head1 DESCRIPTION\n\nThe C<debug> command exposes some internals of\nC<guestfsd> (the guestfs daemon) that runs inside the\nqemu subprocess.\n\nThere is no comprehensive help for this command.  You have\nto look at the file C<daemon/debug.c> in the libguestfs source\nto find out what you can do.",
  .run = run_debug
};

struct command_entry lvremove_cmd_entry = {
  .name = "lvremove",
  .shortdesc = "remove an LVM logical volume",
  .podbody = "=head1 SYNOPSIS\n\n lvremove device\n\n=head1 DESCRIPTION\n\nRemove an LVM logical volume C<device>, where C<device> is\nthe path to the LV, such as C</dev/VG/LV>.\n\nYou can also remove all LVs in a volume group by specifying\nthe VG name, C</dev/VG>.",
  .run = run_lvremove
};

struct command_entry vgremove_cmd_entry = {
  .name = "vgremove",
  .shortdesc = "remove an LVM volume group",
  .podbody = "=head1 SYNOPSIS\n\n vgremove vgname\n\n=head1 DESCRIPTION\n\nRemove an LVM volume group C<vgname>, (for example C<VG>).\n\nThis also forcibly removes all logical volumes in the volume\ngroup (if any).",
  .run = run_vgremove
};

struct command_entry pvremove_cmd_entry = {
  .name = "pvremove",
  .shortdesc = "remove an LVM physical volume",
  .podbody = "=head1 SYNOPSIS\n\n pvremove device\n\n=head1 DESCRIPTION\n\nThis wipes a physical volume C<device> so that LVM will no longer\nrecognise it.\n\nThe implementation uses the C<pvremove> command which refuses to\nwipe physical volumes that contain any volume groups, so you have\nto remove those first.",
  .run = run_pvremove
};

struct command_entry set_e2label_cmd_entry = {
  .name = "set-e2label",
  .shortdesc = "set the ext2/3/4 filesystem label",
  .podbody = "=head1 SYNOPSIS\n\n set-e2label device label\n\n=head1 DESCRIPTION\n\nThis sets the ext2/3/4 filesystem label of the filesystem on\nC<device> to C<label>.  Filesystem labels are limited to\n16 characters.\n\nYou can use either C<tune2fs_l> or C<get_e2label>\nto return the existing label on a filesystem.",
  .run = run_set_e2label
};

struct command_entry get_e2label_cmd_entry = {
  .name = "get-e2label",
  .shortdesc = "get the ext2/3/4 filesystem label",
  .podbody = "=head1 SYNOPSIS\n\n get-e2label device\n\n=head1 DESCRIPTION\n\nThis returns the ext2/3/4 filesystem label of the filesystem on\nC<device>.\n\nThis function is deprecated.\nIn new code, use the C<vfs_label> call instead.\n\nDeprecated functions will not be removed from the API, but the\nfact that they are deprecated indicates that there are problems\nwith correct use of these functions.",
  .run = run_get_e2label
};

struct command_entry set_e2uuid_cmd_entry = {
  .name = "set-e2uuid",
  .shortdesc = "set the ext2/3/4 filesystem UUID",
  .podbody = "=head1 SYNOPSIS\n\n set-e2uuid device uuid\n\n=head1 DESCRIPTION\n\nThis sets the ext2/3/4 filesystem UUID of the filesystem on\nC<device> to C<uuid>.  The format of the UUID and alternatives\nsuch as C<clear>, C<random> and C<time> are described in the\nL<tune2fs(8)> manpage.\n\nYou can use either C<tune2fs_l> or C<get_e2uuid>\nto return the existing UUID of a filesystem.",
  .run = run_set_e2uuid
};

struct command_entry get_e2uuid_cmd_entry = {
  .name = "get-e2uuid",
  .shortdesc = "get the ext2/3/4 filesystem UUID",
  .podbody = "=head1 SYNOPSIS\n\n get-e2uuid device\n\n=head1 DESCRIPTION\n\nThis returns the ext2/3/4 filesystem UUID of the filesystem on\nC<device>.\n\nThis function is deprecated.\nIn new code, use the C<vfs_uuid> call instead.\n\nDeprecated functions will not be removed from the API, but the\nfact that they are deprecated indicates that there are problems\nwith correct use of these functions.",
  .run = run_get_e2uuid
};

struct command_entry fsck_cmd_entry = {
  .name = "fsck",
  .shortdesc = "run the filesystem checker",
  .podbody = "=head1 SYNOPSIS\n\n fsck fstype device\n\n=head1 DESCRIPTION\n\nThis runs the filesystem checker (fsck) on C<device> which\nshould have filesystem type C<fstype>.\n\nThe returned integer is the status.  See L<fsck(8)> for the\nlist of status codes from C<fsck>.\n\nNotes:\n\n=over 4\n\n=item *\n\nMultiple status codes can be summed together.\n\n=item *\n\nA non-zero return code can mean \"success\", for example if\nerrors have been corrected on the filesystem.\n\n=item *\n\nChecking or repairing NTFS volumes is not supported\n(by linux-ntfs).\n\n=back\n\nThis command is entirely equivalent to running C<fsck -a -t fstype device>.",
  .run = run_fsck
};

struct command_entry zero_cmd_entry = {
  .name = "zero",
  .shortdesc = "write zeroes to the device",
  .podbody = "=head1 SYNOPSIS\n\n zero device\n\n=head1 DESCRIPTION\n\nThis command writes zeroes over the first few blocks of C<device>.\n\nHow many blocks are zeroed isn't specified (but it's I<not> enough\nto securely wipe the device).  It should be sufficient to remove\nany partition tables, filesystem superblocks and so on.\n\nSee also: C<zero_device>, C<scrub_device>.",
  .run = run_zero
};

struct command_entry grub_install_cmd_entry = {
  .name = "grub-install",
  .shortdesc = "install GRUB",
  .podbody = "=head1 SYNOPSIS\n\n grub-install root device\n\n=head1 DESCRIPTION\n\nThis command installs GRUB (the Grand Unified Bootloader) on\nC<device>, with the root directory being C<root>.\n\nNote: If grub-install reports the error\n\"No suitable drive was found in the generated device map.\"\nit may be that you need to create a C</boot/grub/device.map>\nfile first that contains the mapping between grub device names\nand Linux device names.  It is usually sufficient to create\na file containing:\n\n (hd0) /dev/vda\n\nreplacing C</dev/vda> with the name of the installation device.",
  .run = run_grub_install
};

struct command_entry cp_cmd_entry = {
  .name = "cp",
  .shortdesc = "copy a file",
  .podbody = "=head1 SYNOPSIS\n\n cp src dest\n\n=head1 DESCRIPTION\n\nThis copies a file from C<src> to C<dest> where C<dest> is\neither a destination filename or destination directory.",
  .run = run_cp
};

struct command_entry cp_a_cmd_entry = {
  .name = "cp-a",
  .shortdesc = "copy a file or directory recursively",
  .podbody = "=head1 SYNOPSIS\n\n cp-a src dest\n\n=head1 DESCRIPTION\n\nThis copies a file or directory from C<src> to C<dest>\nrecursively using the C<cp -a> command.",
  .run = run_cp_a
};

struct command_entry mv_cmd_entry = {
  .name = "mv",
  .shortdesc = "move a file",
  .podbody = "=head1 SYNOPSIS\n\n mv src dest\n\n=head1 DESCRIPTION\n\nThis moves a file from C<src> to C<dest> where C<dest> is\neither a destination filename or destination directory.",
  .run = run_mv
};

struct command_entry drop_caches_cmd_entry = {
  .name = "drop-caches",
  .shortdesc = "drop kernel page cache, dentries and inodes",
  .podbody = "=head1 SYNOPSIS\n\n drop-caches whattodrop\n\n=head1 DESCRIPTION\n\nThis instructs the guest kernel to drop its page cache,\nand/or dentries and inode caches.  The parameter C<whattodrop>\ntells the kernel what precisely to drop, see\nL<http://linux-mm.org/Drop_Caches>\n\nSetting C<whattodrop> to 3 should drop everything.\n\nThis automatically calls L<sync(2)> before the operation,\nso that the maximum guest memory is freed.",
  .run = run_drop_caches
};

struct command_entry dmesg_cmd_entry = {
  .name = "dmesg",
  .shortdesc = "return kernel messages",
  .podbody = "=head1 SYNOPSIS\n\n dmesg\n\n=head1 DESCRIPTION\n\nThis returns the kernel messages (C<dmesg> output) from\nthe guest kernel.  This is sometimes useful for extended\ndebugging of problems.\n\nAnother way to get the same information is to enable\nverbose messages with C<set_verbose> or by setting\nthe environment variable C<LIBGUESTFS_DEBUG=1> before\nrunning the program.",
  .run = run_dmesg
};

struct command_entry ping_daemon_cmd_entry = {
  .name = "ping-daemon",
  .shortdesc = "ping the guest daemon",
  .podbody = "=head1 SYNOPSIS\n\n ping-daemon\n\n=head1 DESCRIPTION\n\nThis is a test probe into the guestfs daemon running inside\nthe qemu subprocess.  Calling this function checks that the\ndaemon responds to the ping message, without affecting the daemon\nor attached block device(s) in any other way.",
  .run = run_ping_daemon
};

struct command_entry equal_cmd_entry = {
  .name = "equal",
  .shortdesc = "test if two files have equal contents",
  .podbody = "=head1 SYNOPSIS\n\n equal file1 file2\n\n=head1 DESCRIPTION\n\nThis compares the two files C<file1> and C<file2> and returns\ntrue if their content is exactly equal, or false otherwise.\n\nThe external L<cmp(1)> program is used for the comparison.",
  .run = run_equal
};

struct command_entry strings_cmd_entry = {
  .name = "strings",
  .shortdesc = "print the printable strings in a file",
  .podbody = "=head1 SYNOPSIS\n\n strings path\n\n=head1 DESCRIPTION\n\nThis runs the L<strings(1)> command on a file and returns\nthe list of printable strings found.\n\nBecause of the message protocol, there is a transfer limit\nof somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.",
  .run = run_strings
};

struct command_entry strings_e_cmd_entry = {
  .name = "strings-e",
  .shortdesc = "print the printable strings in a file",
  .podbody = "=head1 SYNOPSIS\n\n strings-e encoding path\n\n=head1 DESCRIPTION\n\nThis is like the C<strings> command, but allows you to\nspecify the encoding of strings that are looked for in\nthe source file C<path>.\n\nAllowed encodings are:\n\n=over 4\n\n=item s\n\nSingle 7-bit-byte characters like ASCII and the ASCII-compatible\nparts of ISO-8859-X (this is what C<strings> uses).\n\n=item S\n\nSingle 8-bit-byte characters.\n\n=item b\n\n16-bit big endian strings such as those encoded in\nUTF-16BE or UCS-2BE.\n\n=item l (lower case letter L)\n\n16-bit little endian such as UTF-16LE and UCS-2LE.\nThis is useful for examining binaries in Windows guests.\n\n=item B\n\n32-bit big endian such as UCS-4BE.\n\n=item L\n\n32-bit little endian such as UCS-4LE.\n\n=back\n\nThe returned strings are transcoded to UTF-8.\n\nBecause of the message protocol, there is a transfer limit\nof somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.",
  .run = run_strings_e
};

struct command_entry hexdump_cmd_entry = {
  .name = "hexdump",
  .shortdesc = "dump a file in hexadecimal",
  .podbody = "=head1 SYNOPSIS\n\n hexdump path\n\n=head1 DESCRIPTION\n\nThis runs C<hexdump -C> on the given C<path>.  The result is\nthe human-readable, canonical hex dump of the file.\n\nBecause of the message protocol, there is a transfer limit\nof somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.",
  .run = run_hexdump
};

struct command_entry zerofree_cmd_entry = {
  .name = "zerofree",
  .shortdesc = "zero unused inodes and disk blocks on ext2/3 filesystem",
  .podbody = "=head1 SYNOPSIS\n\n zerofree device\n\n=head1 DESCRIPTION\n\nThis runs the I<zerofree> program on C<device>.  This program\nclaims to zero unused inodes and disk blocks on an ext2/3\nfilesystem, thus making it possible to compress the filesystem\nmore effectively.\n\nYou should B<not> run this program if the filesystem is\nmounted.\n\nIt is possible that using this program can damage the filesystem\nor data on the filesystem.",
  .run = run_zerofree
};

struct command_entry pvresize_cmd_entry = {
  .name = "pvresize",
  .shortdesc = "resize an LVM physical volume",
  .podbody = "=head1 SYNOPSIS\n\n pvresize device\n\n=head1 DESCRIPTION\n\nThis resizes (expands or shrinks) an existing LVM physical\nvolume to match the new size of the underlying device.",
  .run = run_pvresize
};

struct command_entry sfdisk_N_cmd_entry = {
  .name = "sfdisk-N",
  .shortdesc = "modify a single partition on a block device",
  .podbody = "=head1 SYNOPSIS\n\n sfdisk-N device partnum cyls heads sectors line\n\n=head1 DESCRIPTION\n\nThis runs L<sfdisk(8)> option to modify just the single\npartition C<n> (note: C<n> counts from 1).\n\nFor other parameters, see C<sfdisk>.  You should usually\npass C<0> for the cyls/heads/sectors parameters.\n\nSee also: C<part_add>\n\nB<This command is dangerous.  Without careful use you\ncan easily destroy all your data>.",
  .run = run_sfdisk_N
};

struct command_entry sfdisk_l_cmd_entry = {
  .name = "sfdisk-l",
  .shortdesc = "display the partition table",
  .podbody = "=head1 SYNOPSIS\n\n sfdisk-l device\n\n=head1 DESCRIPTION\n\nThis displays the partition table on C<device>, in the\nhuman-readable output of the L<sfdisk(8)> command.  It is\nnot intended to be parsed.\n\nSee also: C<part_list>",
  .run = run_sfdisk_l
};

struct command_entry sfdisk_kernel_geometry_cmd_entry = {
  .name = "sfdisk-kernel-geometry",
  .shortdesc = "display the kernel geometry",
  .podbody = "=head1 SYNOPSIS\n\n sfdisk-kernel-geometry device\n\n=head1 DESCRIPTION\n\nThis displays the kernel's idea of the geometry of C<device>.\n\nThe result is in human-readable format, and not designed to\nbe parsed.",
  .run = run_sfdisk_kernel_geometry
};

struct command_entry sfdisk_disk_geometry_cmd_entry = {
  .name = "sfdisk-disk-geometry",
  .shortdesc = "display the disk geometry from the partition table",
  .podbody = "=head1 SYNOPSIS\n\n sfdisk-disk-geometry device\n\n=head1 DESCRIPTION\n\nThis displays the disk geometry of C<device> read from the\npartition table.  Especially in the case where the underlying\nblock device has been resized, this can be different from the\nkernel's idea of the geometry (see C<sfdisk_kernel_geometry>).\n\nThe result is in human-readable format, and not designed to\nbe parsed.",
  .run = run_sfdisk_disk_geometry
};

struct command_entry vg_activate_all_cmd_entry = {
  .name = "vg-activate-all",
  .shortdesc = "activate or deactivate all volume groups",
  .podbody = "=head1 SYNOPSIS\n\n vg-activate-all activate\n\n=head1 DESCRIPTION\n\nThis command activates or (if C<activate> is false) deactivates\nall logical volumes in all volume groups.\nIf activated, then they are made known to the\nkernel, ie. they appear as C</dev/mapper> devices.  If deactivated,\nthen those devices disappear.\n\nThis command is the same as running C<vgchange -a y|n>",
  .run = run_vg_activate_all
};

struct command_entry vg_activate_cmd_entry = {
  .name = "vg-activate",
  .shortdesc = "activate or deactivate some volume groups",
  .podbody = "=head1 SYNOPSIS\n\n vg-activate activate volgroups\n\n=head1 DESCRIPTION\n\nThis command activates or (if C<activate> is false) deactivates\nall logical volumes in the listed volume groups C<volgroups>.\nIf activated, then they are made known to the\nkernel, ie. they appear as C</dev/mapper> devices.  If deactivated,\nthen those devices disappear.\n\nThis command is the same as running C<vgchange -a y|n volgroups...>\n\nNote that if C<volgroups> is an empty list then B<all> volume groups\nare activated or deactivated.",
  .run = run_vg_activate
};

struct command_entry lvresize_cmd_entry = {
  .name = "lvresize",
  .shortdesc = "resize an LVM logical volume",
  .podbody = "=head1 SYNOPSIS\n\n lvresize device mbytes\n\n=head1 DESCRIPTION\n\nThis resizes (expands or shrinks) an existing LVM logical\nvolume to C<mbytes>.  When reducing, data in the reduced part\nis lost.",
  .run = run_lvresize
};

struct command_entry resize2fs_cmd_entry = {
  .name = "resize2fs",
  .shortdesc = "resize an ext2, ext3 or ext4 filesystem",
  .podbody = "=head1 SYNOPSIS\n\n resize2fs device\n\n=head1 DESCRIPTION\n\nThis resizes an ext2, ext3 or ext4 filesystem to match the size of\nthe underlying device.\n\nI<Note:> It is sometimes required that you run C<e2fsck_f>\non the C<device> before calling this command.  For unknown reasons\nC<resize2fs> sometimes gives an error about this and sometimes not.\nIn any case, it is always safe to call C<e2fsck_f> before\ncalling this function.",
  .run = run_resize2fs
};

struct command_entry find_cmd_entry = {
  .name = "find",
  .shortdesc = "find all files and directories",
  .podbody = "=head1 SYNOPSIS\n\n find directory\n\n=head1 DESCRIPTION\n\nThis command lists out all files and directories, recursively,\nstarting at C<directory>.  It is essentially equivalent to\nrunning the shell command C<find directory -print> but some\npost-processing happens on the output, described below.\n\nThis returns a list of strings I<without any prefix>.  Thus\nif the directory structure was:\n\n /tmp/a\n /tmp/b\n /tmp/c/d\n\nthen the returned list from C<find> C</tmp> would be\n4 elements:\n\n a\n b\n c\n c/d\n\nIf C<directory> is not a directory, then this command returns\nan error.\n\nThe returned list is sorted.\n\nSee also C<find0>.\n\nBecause of the message protocol, there is a transfer limit\nof somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.",
  .run = run_find
};

struct command_entry e2fsck_f_cmd_entry = {
  .name = "e2fsck-f",
  .shortdesc = "check an ext2/ext3 filesystem",
  .podbody = "=head1 SYNOPSIS\n\n e2fsck-f device\n\n=head1 DESCRIPTION\n\nThis runs C<e2fsck -p -f device>, ie. runs the ext2/ext3\nfilesystem checker on C<device>, noninteractively (C<-p>),\neven if the filesystem appears to be clean (C<-f>).\n\nThis command is only needed because of C<resize2fs>\n(q.v.).  Normally you should use C<fsck>.",
  .run = run_e2fsck_f
};

struct command_entry sleep_cmd_entry = {
  .name = "sleep",
  .shortdesc = "sleep for some seconds",
  .podbody = "=head1 SYNOPSIS\n\n sleep secs\n\n=head1 DESCRIPTION\n\nSleep for C<secs> seconds.",
  .run = run_sleep
};

struct command_entry ntfs_3g_probe_cmd_entry = {
  .name = "ntfs-3g-probe",
  .shortdesc = "probe NTFS volume",
  .podbody = "=head1 SYNOPSIS\n\n ntfs-3g-probe rw device\n\n=head1 DESCRIPTION\n\nThis command runs the L<ntfs-3g.probe(8)> command which probes\nan NTFS C<device> for mountability.  (Not all NTFS volumes can\nbe mounted read-write, and some cannot be mounted at all).\n\nC<rw> is a boolean flag.  Set it to true if you want to test\nif the volume can be mounted read-write.  Set it to false if\nyou want to test if the volume can be mounted read-only.\n\nThe return value is an integer which C<0> if the operation\nwould succeed, or some non-zero value documented in the\nL<ntfs-3g.probe(8)> manual page.",
  .run = run_ntfs_3g_probe
};

struct command_entry sh_cmd_entry = {
  .name = "sh",
  .shortdesc = "run a command via the shell",
  .podbody = "=head1 SYNOPSIS\n\n sh command\n\n=head1 DESCRIPTION\n\nThis call runs a command from the guest filesystem via the\nguest's C</bin/sh>.\n\nThis is like C<command>, but passes the command to:\n\n /bin/sh -c \"command\"\n\nDepending on the guest's shell, this usually results in\nwildcards being expanded, shell expressions being interpolated\nand so on.\n\nAll the provisos about C<command> apply to this call.",
  .run = run_sh
};

struct command_entry sh_lines_cmd_entry = {
  .name = "sh-lines",
  .shortdesc = "run a command via the shell returning lines",
  .podbody = "=head1 SYNOPSIS\n\n sh-lines command\n\n=head1 DESCRIPTION\n\nThis is the same as C<sh>, but splits the result\ninto a list of lines.\n\nSee also: C<command_lines>",
  .run = run_sh_lines
};

struct command_entry glob_expand_cmd_entry = {
  .name = "glob-expand",
  .shortdesc = "expand a wildcard path",
  .podbody = "=head1 SYNOPSIS\n\n glob-expand pattern\n\n=head1 DESCRIPTION\n\nThis command searches for all the pathnames matching\nC<pattern> according to the wildcard expansion rules\nused by the shell.\n\nIf no paths match, then this returns an empty list\n(note: not an error).\n\nIt is just a wrapper around the C L<glob(3)> function\nwith flags C<GLOB_MARK|GLOB_BRACE>.\nSee that manual page for more details.",
  .run = run_glob_expand
};

struct command_entry scrub_device_cmd_entry = {
  .name = "scrub-device",
  .shortdesc = "scrub (securely wipe) a device",
  .podbody = "=head1 SYNOPSIS\n\n scrub-device device\n\n=head1 DESCRIPTION\n\nThis command writes patterns over C<device> to make data retrieval\nmore difficult.\n\nIt is an interface to the L<scrub(1)> program.  See that\nmanual page for more details.\n\nB<This command is dangerous.  Without careful use you\ncan easily destroy all your data>.",
  .run = run_scrub_device
};

struct command_entry scrub_file_cmd_entry = {
  .name = "scrub-file",
  .shortdesc = "scrub (securely wipe) a file",
  .podbody = "=head1 SYNOPSIS\n\n scrub-file file\n\n=head1 DESCRIPTION\n\nThis command writes patterns over a file to make data retrieval\nmore difficult.\n\nThe file is I<removed> after scrubbing.\n\nIt is an interface to the L<scrub(1)> program.  See that\nmanual page for more details.",
  .run = run_scrub_file
};

struct command_entry scrub_freespace_cmd_entry = {
  .name = "scrub-freespace",
  .shortdesc = "scrub (securely wipe) free space",
  .podbody = "=head1 SYNOPSIS\n\n scrub-freespace dir\n\n=head1 DESCRIPTION\n\nThis command creates the directory C<dir> and then fills it\nwith files until the filesystem is full, and scrubs the files\nas for C<scrub_file>, and deletes them.\nThe intention is to scrub any free space on the partition\ncontaining C<dir>.\n\nIt is an interface to the L<scrub(1)> program.  See that\nmanual page for more details.",
  .run = run_scrub_freespace
};

struct command_entry mkdtemp_cmd_entry = {
  .name = "mkdtemp",
  .shortdesc = "create a temporary directory",
  .podbody = "=head1 SYNOPSIS\n\n mkdtemp template\n\n=head1 DESCRIPTION\n\nThis command creates a temporary directory.  The\nC<template> parameter should be a full pathname for the\ntemporary directory name with the final six characters being\n\"XXXXXX\".\n\nFor example: \"/tmp/myprogXXXXXX\" or \"/Temp/myprogXXXXXX\",\nthe second one being suitable for Windows filesystems.\n\nThe name of the temporary directory that was created\nis returned.\n\nThe temporary directory is created with mode 0700\nand is owned by root.\n\nThe caller is responsible for deleting the temporary\ndirectory and its contents after use.\n\nSee also: L<mkdtemp(3)>",
  .run = run_mkdtemp
};

struct command_entry wc_l_cmd_entry = {
  .name = "wc-l",
  .shortdesc = "count lines in a file",
  .podbody = "=head1 SYNOPSIS\n\n wc-l path\n\n=head1 DESCRIPTION\n\nThis command counts the lines in a file, using the\nC<wc -l> external command.",
  .run = run_wc_l
};

struct command_entry wc_w_cmd_entry = {
  .name = "wc-w",
  .shortdesc = "count words in a file",
  .podbody = "=head1 SYNOPSIS\n\n wc-w path\n\n=head1 DESCRIPTION\n\nThis command counts the words in a file, using the\nC<wc -w> external command.",
  .run = run_wc_w
};

struct command_entry wc_c_cmd_entry = {
  .name = "wc-c",
  .shortdesc = "count characters in a file",
  .podbody = "=head1 SYNOPSIS\n\n wc-c path\n\n=head1 DESCRIPTION\n\nThis command counts the characters in a file, using the\nC<wc -c> external command.",
  .run = run_wc_c
};

struct command_entry head_cmd_entry = {
  .name = "head",
  .shortdesc = "return first 10 lines of a file",
  .podbody = "=head1 SYNOPSIS\n\n head path\n\n=head1 DESCRIPTION\n\nThis command returns up to the first 10 lines of a file as\na list of strings.\n\nBecause of the message protocol, there is a transfer limit\nof somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.",
  .run = run_head
};

struct command_entry head_n_cmd_entry = {
  .name = "head-n",
  .shortdesc = "return first N lines of a file",
  .podbody = "=head1 SYNOPSIS\n\n head-n nrlines path\n\n=head1 DESCRIPTION\n\nIf the parameter C<nrlines> is a positive number, this returns the first\nC<nrlines> lines of the file C<path>.\n\nIf the parameter C<nrlines> is a negative number, this returns lines\nfrom the file C<path>, excluding the last C<nrlines> lines.\n\nIf the parameter C<nrlines> is zero, this returns an empty list.\n\nBecause of the message protocol, there is a transfer limit\nof somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.",
  .run = run_head_n
};

struct command_entry tail_cmd_entry = {
  .name = "tail",
  .shortdesc = "return last 10 lines of a file",
  .podbody = "=head1 SYNOPSIS\n\n tail path\n\n=head1 DESCRIPTION\n\nThis command returns up to the last 10 lines of a file as\na list of strings.\n\nBecause of the message protocol, there is a transfer limit\nof somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.",
  .run = run_tail
};

struct command_entry tail_n_cmd_entry = {
  .name = "tail-n",
  .shortdesc = "return last N lines of a file",
  .podbody = "=head1 SYNOPSIS\n\n tail-n nrlines path\n\n=head1 DESCRIPTION\n\nIf the parameter C<nrlines> is a positive number, this returns the last\nC<nrlines> lines of the file C<path>.\n\nIf the parameter C<nrlines> is a negative number, this returns lines\nfrom the file C<path>, starting with the C<-nrlines>th line.\n\nIf the parameter C<nrlines> is zero, this returns an empty list.\n\nBecause of the message protocol, there is a transfer limit\nof somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.",
  .run = run_tail_n
};

struct command_entry df_cmd_entry = {
  .name = "df",
  .shortdesc = "report file system disk space usage",
  .podbody = "=head1 SYNOPSIS\n\n df\n\n=head1 DESCRIPTION\n\nThis command runs the C<df> command to report disk space used.\n\nThis command is mostly useful for interactive sessions.  It\nis I<not> intended that you try to parse the output string.\nUse C<statvfs> from programs.",
  .run = run_df
};

struct command_entry df_h_cmd_entry = {
  .name = "df-h",
  .shortdesc = "report file system disk space usage (human readable)",
  .podbody = "=head1 SYNOPSIS\n\n df-h\n\n=head1 DESCRIPTION\n\nThis command runs the C<df -h> command to report disk space used\nin human-readable format.\n\nThis command is mostly useful for interactive sessions.  It\nis I<not> intended that you try to parse the output string.\nUse C<statvfs> from programs.",
  .run = run_df_h
};

struct command_entry du_cmd_entry = {
  .name = "du",
  .shortdesc = "estimate file space usage",
  .podbody = "=head1 SYNOPSIS\n\n du path\n\n=head1 DESCRIPTION\n\nThis command runs the C<du -s> command to estimate file space\nusage for C<path>.\n\nC<path> can be a file or a directory.  If C<path> is a directory\nthen the estimate includes the contents of the directory and all\nsubdirectories (recursively).\n\nThe result is the estimated size in I<kilobytes>\n(ie. units of 1024 bytes).",
  .run = run_du
};

struct command_entry initrd_list_cmd_entry = {
  .name = "initrd-list",
  .shortdesc = "list files in an initrd",
  .podbody = "=head1 SYNOPSIS\n\n initrd-list path\n\n=head1 DESCRIPTION\n\nThis command lists out files contained in an initrd.\n\nThe files are listed without any initial C</> character.  The\nfiles are listed in the order they appear (not necessarily\nalphabetical).  Directory names are listed as separate items.\n\nOld Linux kernels (2.4 and earlier) used a compressed ext2\nfilesystem as initrd.  We I<only> support the newer initramfs\nformat (compressed cpio files).",
  .run = run_initrd_list
};

struct command_entry mount_loop_cmd_entry = {
  .name = "mount-loop",
  .shortdesc = "mount a file using the loop device",
  .podbody = "=head1 SYNOPSIS\n\n mount-loop file mountpoint\n\n=head1 DESCRIPTION\n\nThis command lets you mount C<file> (a filesystem image\nin a file) on a mount point.  It is entirely equivalent to\nthe command C<mount -o loop file mountpoint>.",
  .run = run_mount_loop
};

struct command_entry mkswap_cmd_entry = {
  .name = "mkswap",
  .shortdesc = "create a swap partition",
  .podbody = "=head1 SYNOPSIS\n\n mkswap device\n\n=head1 DESCRIPTION\n\nCreate a swap partition on C<device>.",
  .run = run_mkswap
};

struct command_entry mkswap_L_cmd_entry = {
  .name = "mkswap-L",
  .shortdesc = "create a swap partition with a label",
  .podbody = "=head1 SYNOPSIS\n\n mkswap-L label device\n\n=head1 DESCRIPTION\n\nCreate a swap partition on C<device> with label C<label>.\n\nNote that you cannot attach a swap label to a block device\n(eg. C</dev/sda>), just to a partition.  This appears to be\na limitation of the kernel or swap tools.",
  .run = run_mkswap_L
};

struct command_entry mkswap_U_cmd_entry = {
  .name = "mkswap-U",
  .shortdesc = "create a swap partition with an explicit UUID",
  .podbody = "=head1 SYNOPSIS\n\n mkswap-U uuid device\n\n=head1 DESCRIPTION\n\nCreate a swap partition on C<device> with UUID C<uuid>.",
  .run = run_mkswap_U
};

struct command_entry mknod_cmd_entry = {
  .name = "mknod",
  .shortdesc = "make block, character or FIFO devices",
  .podbody = "=head1 SYNOPSIS\n\n mknod mode devmajor devminor path\n\n=head1 DESCRIPTION\n\nThis call creates block or character special devices, or\nnamed pipes (FIFOs).\n\nThe C<mode> parameter should be the mode, using the standard\nconstants.  C<devmajor> and C<devminor> are the\ndevice major and minor numbers, only used when creating block\nand character special devices.\n\nNote that, just like L<mknod(2)>, the mode must be bitwise\nOR'd with S_IFBLK, S_IFCHR, S_IFIFO or S_IFSOCK (otherwise this call\njust creates a regular file).  These constants are\navailable in the standard Linux header files, or you can use\nC<mknod_b>, C<mknod_c> or C<mkfifo>\nwhich are wrappers around this command which bitwise OR\nin the appropriate constant for you.\n\nThe mode actually set is affected by the umask.",
  .run = run_mknod
};

struct command_entry mkfifo_cmd_entry = {
  .name = "mkfifo",
  .shortdesc = "make FIFO (named pipe)",
  .podbody = "=head1 SYNOPSIS\n\n mkfifo mode path\n\n=head1 DESCRIPTION\n\nThis call creates a FIFO (named pipe) called C<path> with\nmode C<mode>.  It is just a convenient wrapper around\nC<mknod>.\n\nThe mode actually set is affected by the umask.",
  .run = run_mkfifo
};

struct command_entry mknod_b_cmd_entry = {
  .name = "mknod-b",
  .shortdesc = "make block device node",
  .podbody = "=head1 SYNOPSIS\n\n mknod-b mode devmajor devminor path\n\n=head1 DESCRIPTION\n\nThis call creates a block device node called C<path> with\nmode C<mode> and device major/minor C<devmajor> and C<devminor>.\nIt is just a convenient wrapper around C<mknod>.\n\nThe mode actually set is affected by the umask.",
  .run = run_mknod_b
};

struct command_entry mknod_c_cmd_entry = {
  .name = "mknod-c",
  .shortdesc = "make char device node",
  .podbody = "=head1 SYNOPSIS\n\n mknod-c mode devmajor devminor path\n\n=head1 DESCRIPTION\n\nThis call creates a char device node called C<path> with\nmode C<mode> and device major/minor C<devmajor> and C<devminor>.\nIt is just a convenient wrapper around C<mknod>.\n\nThe mode actually set is affected by the umask.",
  .run = run_mknod_c
};

struct command_entry umask_cmd_entry = {
  .name = "umask",
  .shortdesc = "set file mode creation mask (umask)",
  .podbody = "=head1 SYNOPSIS\n\n umask mask\n\n=head1 DESCRIPTION\n\nThis function sets the mask used for creating new files and\ndevice nodes to C<mask & 0777>.\n\nTypical umask values would be C<022> which creates new files\nwith permissions like \"-rw-r--r--\" or \"-rwxr-xr-x\", and\nC<002> which creates new files with permissions like\n\"-rw-rw-r--\" or \"-rwxrwxr-x\".\n\nThe default umask is C<022>.  This is important because it\nmeans that directories and device nodes will be created with\nC<0644> or C<0755> mode even if you specify C<0777>.\n\nSee also C<get_umask>,\nL<umask(2)>, C<mknod>, C<mkdir>.\n\nThis call returns the previous umask.",
  .run = run_umask
};

struct command_entry readdir_cmd_entry = {
  .name = "readdir",
  .shortdesc = "read directories entries",
  .podbody = "=head1 SYNOPSIS\n\n readdir dir\n\n=head1 DESCRIPTION\n\nThis returns the list of directory entries in directory C<dir>.\n\nAll entries in the directory are returned, including C<.> and\nC<..>.  The entries are I<not> sorted, but returned in the same\norder as the underlying filesystem.\n\nAlso this call returns basic file type information about each\nfile.  The C<ftyp> field will contain one of the following characters:\n\n=over 4\n\n=item 'b'\n\nBlock special\n\n=item 'c'\n\nChar special\n\n=item 'd'\n\nDirectory\n\n=item 'f'\n\nFIFO (named pipe)\n\n=item 'l'\n\nSymbolic link\n\n=item 'r'\n\nRegular file\n\n=item 's'\n\nSocket\n\n=item 'u'\n\nUnknown file type\n\n=item '?'\n\nThe L<readdir(3)> call returned a C<d_type> field with an\nunexpected value\n\n=back\n\nThis function is primarily intended for use by programs.  To\nget a simple list of names, use C<ls>.  To get a printable\ndirectory for human consumption, use C<ll>.",
  .run = run_readdir
};

struct command_entry sfdiskM_cmd_entry = {
  .name = "sfdiskM",
  .shortdesc = "create partitions on a block device",
  .podbody = "=head1 SYNOPSIS\n\n sfdiskM device lines\n\n=head1 DESCRIPTION\n\nThis is a simplified interface to the C<sfdisk>\ncommand, where partition sizes are specified in megabytes\nonly (rounded to the nearest cylinder) and you don't need\nto specify the cyls, heads and sectors parameters which\nwere rarely if ever used anyway.\n\nSee also: C<sfdisk>, the L<sfdisk(8)> manpage\nand C<part_disk>\n\nB<This command is dangerous.  Without careful use you\ncan easily destroy all your data>.",
  .run = run_sfdiskM
};

struct command_entry zfile_cmd_entry = {
  .name = "zfile",
  .shortdesc = "determine file type inside a compressed file",
  .podbody = "=head1 SYNOPSIS\n\n zfile meth path\n\n=head1 DESCRIPTION\n\nThis command runs C<file> after first decompressing C<path>\nusing C<method>.\n\nC<method> must be one of C<gzip>, C<compress> or C<bzip2>.\n\nSince 1.0.63, use C<file> instead which can now\nprocess compressed files.\n\nThis function is deprecated.\nIn new code, use the C<file> call instead.\n\nDeprecated functions will not be removed from the API, but the\nfact that they are deprecated indicates that there are problems\nwith correct use of these functions.",
  .run = run_zfile
};

struct command_entry getxattrs_cmd_entry = {
  .name = "getxattrs",
  .shortdesc = "list extended attributes of a file or directory",
  .podbody = "=head1 SYNOPSIS\n\n getxattrs path\n\n=head1 DESCRIPTION\n\nThis call lists the extended attributes of the file or directory\nC<path>.\n\nAt the system call level, this is a combination of the\nL<listxattr(2)> and L<getxattr(2)> calls.\n\nSee also: C<lgetxattrs>, L<attr(5)>.",
  .run = run_getxattrs
};

struct command_entry lgetxattrs_cmd_entry = {
  .name = "lgetxattrs",
  .shortdesc = "list extended attributes of a file or directory",
  .podbody = "=head1 SYNOPSIS\n\n lgetxattrs path\n\n=head1 DESCRIPTION\n\nThis is the same as C<getxattrs>, but if C<path>\nis a symbolic link, then it returns the extended attributes\nof the link itself.",
  .run = run_lgetxattrs
};

struct command_entry setxattr_cmd_entry = {
  .name = "setxattr",
  .shortdesc = "set extended attribute of a file or directory",
  .podbody = "=head1 SYNOPSIS\n\n setxattr xattr val vallen path\n\n=head1 DESCRIPTION\n\nThis call sets the extended attribute named C<xattr>\nof the file C<path> to the value C<val> (of length C<vallen>).\nThe value is arbitrary 8 bit data.\n\nSee also: C<lsetxattr>, L<attr(5)>.",
  .run = run_setxattr
};

struct command_entry lsetxattr_cmd_entry = {
  .name = "lsetxattr",
  .shortdesc = "set extended attribute of a file or directory",
  .podbody = "=head1 SYNOPSIS\n\n lsetxattr xattr val vallen path\n\n=head1 DESCRIPTION\n\nThis is the same as C<setxattr>, but if C<path>\nis a symbolic link, then it sets an extended attribute\nof the link itself.",
  .run = run_lsetxattr
};

struct command_entry removexattr_cmd_entry = {
  .name = "removexattr",
  .shortdesc = "remove extended attribute of a file or directory",
  .podbody = "=head1 SYNOPSIS\n\n removexattr xattr path\n\n=head1 DESCRIPTION\n\nThis call removes the extended attribute named C<xattr>\nof the file C<path>.\n\nSee also: C<lremovexattr>, L<attr(5)>.",
  .run = run_removexattr
};

struct command_entry lremovexattr_cmd_entry = {
  .name = "lremovexattr",
  .shortdesc = "remove extended attribute of a file or directory",
  .podbody = "=head1 SYNOPSIS\n\n lremovexattr xattr path\n\n=head1 DESCRIPTION\n\nThis is the same as C<removexattr>, but if C<path>\nis a symbolic link, then it removes an extended attribute\nof the link itself.",
  .run = run_lremovexattr
};

struct command_entry mountpoints_cmd_entry = {
  .name = "mountpoints",
  .shortdesc = "show mountpoints",
  .podbody = "=head1 SYNOPSIS\n\n mountpoints\n\n=head1 DESCRIPTION\n\nThis call is similar to C<mounts>.  That call returns\na list of devices.  This one returns a hash table (map) of\ndevice name to directory where the device is mounted.",
  .run = run_mountpoints
};

struct command_entry mkmountpoint_cmd_entry = {
  .name = "mkmountpoint",
  .shortdesc = "create a mountpoint",
  .podbody = "=head1 SYNOPSIS\n\n mkmountpoint exemptpath\n\n=head1 DESCRIPTION\n\nC<mkmountpoint> and C<rmmountpoint> are\nspecialized calls that can be used to create extra mountpoints\nbefore mounting the first filesystem.\n\nThese calls are I<only> necessary in some very limited circumstances,\nmainly the case where you want to mount a mix of unrelated and/or\nread-only filesystems together.\n\nFor example, live CDs often contain a \"Russian doll\" nest of\nfilesystems, an ISO outer layer, with a squashfs image inside, with\nan ext2/3 image inside that.  You can unpack this as follows\nin guestfish:\n\n add-ro Fedora-11-i686-Live.iso\n run\n mkmountpoint /cd\n mkmountpoint /sqsh\n mkmountpoint /ext3fs\n mount /dev/sda /cd\n mount-loop /cd/LiveOS/squashfs.img /sqsh\n mount-loop /sqsh/LiveOS/ext3fs.img /ext3fs\n\nThe inner filesystem is now unpacked under the /ext3fs mountpoint.\n\nC<mkmountpoint> is not compatible with C<umount_all>.\nYou may get unexpected errors if you try to mix these calls.  It is\nsafest to manually unmount filesystems and remove mountpoints after use.\n\nC<umount_all> unmounts filesystems by sorting the paths\nlongest first, so for this to work for manual mountpoints, you\nmust ensure that the innermost mountpoints have the longest\npathnames, as in the example code above.\n\nFor more details see L<https://bugzilla.redhat.com/show_bug.cgi?id=599503>\n\nAutosync [see C<set_autosync>, this is set by default on\nhandles] means that C<umount_all> is called when the handle\nis closed which can also trigger these issues.",
  .run = run_mkmountpoint
};

struct command_entry rmmountpoint_cmd_entry = {
  .name = "rmmountpoint",
  .shortdesc = "remove a mountpoint",
  .podbody = "=head1 SYNOPSIS\n\n rmmountpoint exemptpath\n\n=head1 DESCRIPTION\n\nThis calls removes a mountpoint that was previously created\nwith C<mkmountpoint>.  See C<mkmountpoint>\nfor full details.",
  .run = run_rmmountpoint
};

struct command_entry read_file_cmd_entry = {
  .name = "read-file",
  .shortdesc = "read a file",
  .podbody = "=head1 SYNOPSIS\n\n read-file path\n\n=head1 DESCRIPTION\n\nThis calls returns the contents of the file C<path> as a\nbuffer.\n\nUnlike C<cat>, this function can correctly\nhandle files that contain embedded ASCII NUL characters.\nHowever unlike C<download>, this function is limited\nin the total size of file that can be handled.\n\nBecause of the message protocol, there is a transfer limit\nof somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.",
  .run = run_read_file
};

struct command_entry grep_cmd_entry = {
  .name = "grep",
  .shortdesc = "return lines matching a pattern",
  .podbody = "=head1 SYNOPSIS\n\n grep regex path\n\n=head1 DESCRIPTION\n\nThis calls the external C<grep> program and returns the\nmatching lines.\n\nBecause of the message protocol, there is a transfer limit\nof somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.",
  .run = run_grep
};

struct command_entry egrep_cmd_entry = {
  .name = "egrep",
  .shortdesc = "return lines matching a pattern",
  .podbody = "=head1 SYNOPSIS\n\n egrep regex path\n\n=head1 DESCRIPTION\n\nThis calls the external C<egrep> program and returns the\nmatching lines.\n\nBecause of the message protocol, there is a transfer limit\nof somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.",
  .run = run_egrep
};

struct command_entry fgrep_cmd_entry = {
  .name = "fgrep",
  .shortdesc = "return lines matching a pattern",
  .podbody = "=head1 SYNOPSIS\n\n fgrep pattern path\n\n=head1 DESCRIPTION\n\nThis calls the external C<fgrep> program and returns the\nmatching lines.\n\nBecause of the message protocol, there is a transfer limit\nof somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.",
  .run = run_fgrep
};

struct command_entry grepi_cmd_entry = {
  .name = "grepi",
  .shortdesc = "return lines matching a pattern",
  .podbody = "=head1 SYNOPSIS\n\n grepi regex path\n\n=head1 DESCRIPTION\n\nThis calls the external C<grep -i> program and returns the\nmatching lines.\n\nBecause of the message protocol, there is a transfer limit\nof somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.",
  .run = run_grepi
};

struct command_entry egrepi_cmd_entry = {
  .name = "egrepi",
  .shortdesc = "return lines matching a pattern",
  .podbody = "=head1 SYNOPSIS\n\n egrepi regex path\n\n=head1 DESCRIPTION\n\nThis calls the external C<egrep -i> program and returns the\nmatching lines.\n\nBecause of the message protocol, there is a transfer limit\nof somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.",
  .run = run_egrepi
};

struct command_entry fgrepi_cmd_entry = {
  .name = "fgrepi",
  .shortdesc = "return lines matching a pattern",
  .podbody = "=head1 SYNOPSIS\n\n fgrepi pattern path\n\n=head1 DESCRIPTION\n\nThis calls the external C<fgrep -i> program and returns the\nmatching lines.\n\nBecause of the message protocol, there is a transfer limit\nof somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.",
  .run = run_fgrepi
};

struct command_entry zgrep_cmd_entry = {
  .name = "zgrep",
  .shortdesc = "return lines matching a pattern",
  .podbody = "=head1 SYNOPSIS\n\n zgrep regex path\n\n=head1 DESCRIPTION\n\nThis calls the external C<zgrep> program and returns the\nmatching lines.\n\nBecause of the message protocol, there is a transfer limit\nof somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.",
  .run = run_zgrep
};

struct command_entry zegrep_cmd_entry = {
  .name = "zegrep",
  .shortdesc = "return lines matching a pattern",
  .podbody = "=head1 SYNOPSIS\n\n zegrep regex path\n\n=head1 DESCRIPTION\n\nThis calls the external C<zegrep> program and returns the\nmatching lines.\n\nBecause of the message protocol, there is a transfer limit\nof somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.",
  .run = run_zegrep
};

struct command_entry zfgrep_cmd_entry = {
  .name = "zfgrep",
  .shortdesc = "return lines matching a pattern",
  .podbody = "=head1 SYNOPSIS\n\n zfgrep pattern path\n\n=head1 DESCRIPTION\n\nThis calls the external C<zfgrep> program and returns the\nmatching lines.\n\nBecause of the message protocol, there is a transfer limit\nof somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.",
  .run = run_zfgrep
};

struct command_entry zgrepi_cmd_entry = {
  .name = "zgrepi",
  .shortdesc = "return lines matching a pattern",
  .podbody = "=head1 SYNOPSIS\n\n zgrepi regex path\n\n=head1 DESCRIPTION\n\nThis calls the external C<zgrep -i> program and returns the\nmatching lines.\n\nBecause of the message protocol, there is a transfer limit\nof somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.",
  .run = run_zgrepi
};

struct command_entry zegrepi_cmd_entry = {
  .name = "zegrepi",
  .shortdesc = "return lines matching a pattern",
  .podbody = "=head1 SYNOPSIS\n\n zegrepi regex path\n\n=head1 DESCRIPTION\n\nThis calls the external C<zegrep -i> program and returns the\nmatching lines.\n\nBecause of the message protocol, there is a transfer limit\nof somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.",
  .run = run_zegrepi
};

struct command_entry zfgrepi_cmd_entry = {
  .name = "zfgrepi",
  .shortdesc = "return lines matching a pattern",
  .podbody = "=head1 SYNOPSIS\n\n zfgrepi pattern path\n\n=head1 DESCRIPTION\n\nThis calls the external C<zfgrep -i> program and returns the\nmatching lines.\n\nBecause of the message protocol, there is a transfer limit\nof somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.",
  .run = run_zfgrepi
};

struct command_entry realpath_cmd_entry = {
  .name = "realpath",
  .shortdesc = "canonicalized absolute pathname",
  .podbody = "=head1 SYNOPSIS\n\n realpath path\n\n=head1 DESCRIPTION\n\nReturn the canonicalized absolute pathname of C<path>.  The\nreturned path has no C<.>, C<..> or symbolic link path elements.",
  .run = run_realpath
};

struct command_entry ln_cmd_entry = {
  .name = "ln",
  .shortdesc = "create a hard link",
  .podbody = "=head1 SYNOPSIS\n\n ln target linkname\n\n=head1 DESCRIPTION\n\nThis command creates a hard link using the C<ln> command.",
  .run = run_ln
};

struct command_entry ln_f_cmd_entry = {
  .name = "ln-f",
  .shortdesc = "create a hard link",
  .podbody = "=head1 SYNOPSIS\n\n ln-f target linkname\n\n=head1 DESCRIPTION\n\nThis command creates a hard link using the C<ln -f> command.\nThe C<-f> option removes the link (C<linkname>) if it exists already.",
  .run = run_ln_f
};

struct command_entry ln_s_cmd_entry = {
  .name = "ln-s",
  .shortdesc = "create a symbolic link",
  .podbody = "=head1 SYNOPSIS\n\n ln-s target linkname\n\n=head1 DESCRIPTION\n\nThis command creates a symbolic link using the C<ln -s> command.",
  .run = run_ln_s
};

struct command_entry ln_sf_cmd_entry = {
  .name = "ln-sf",
  .shortdesc = "create a symbolic link",
  .podbody = "=head1 SYNOPSIS\n\n ln-sf target linkname\n\n=head1 DESCRIPTION\n\nThis command creates a symbolic link using the C<ln -sf> command,\nThe C<-f> option removes the link (C<linkname>) if it exists already.",
  .run = run_ln_sf
};

struct command_entry readlink_cmd_entry = {
  .name = "readlink",
  .shortdesc = "read the target of a symbolic link",
  .podbody = "=head1 SYNOPSIS\n\n readlink path\n\n=head1 DESCRIPTION\n\nThis command reads the target of a symbolic link.",
  .run = run_readlink
};

struct command_entry fallocate_cmd_entry = {
  .name = "fallocate",
  .shortdesc = "preallocate a file in the guest filesystem",
  .podbody = "=head1 SYNOPSIS\n\n fallocate path len\n\n=head1 DESCRIPTION\n\nThis command preallocates a file (containing zero bytes) named\nC<path> of size C<len> bytes.  If the file exists already, it\nis overwritten.\n\nDo not confuse this with the guestfish-specific\nC<alloc> command which allocates a file in the host and\nattaches it as a device.\n\nThis function is deprecated.\nIn new code, use the C<fallocate64> call instead.\n\nDeprecated functions will not be removed from the API, but the\nfact that they are deprecated indicates that there are problems\nwith correct use of these functions.",
  .run = run_fallocate
};

struct command_entry swapon_device_cmd_entry = {
  .name = "swapon-device",
  .shortdesc = "enable swap on device",
  .podbody = "=head1 SYNOPSIS\n\n swapon-device device\n\n=head1 DESCRIPTION\n\nThis command enables the libguestfs appliance to use the\nswap device or partition named C<device>.  The increased\nmemory is made available for all commands, for example\nthose run using C<command> or C<sh>.\n\nNote that you should not swap to existing guest swap\npartitions unless you know what you are doing.  They may\ncontain hibernation information, or other information that\nthe guest doesn't want you to trash.  You also risk leaking\ninformation about the host to the guest this way.  Instead,\nattach a new host device to the guest and swap on that.",
  .run = run_swapon_device
};

struct command_entry swapoff_device_cmd_entry = {
  .name = "swapoff-device",
  .shortdesc = "disable swap on device",
  .podbody = "=head1 SYNOPSIS\n\n swapoff-device device\n\n=head1 DESCRIPTION\n\nThis command disables the libguestfs appliance swap\ndevice or partition named C<device>.\nSee C<swapon_device>.",
  .run = run_swapoff_device
};

struct command_entry swapon_file_cmd_entry = {
  .name = "swapon-file",
  .shortdesc = "enable swap on file",
  .podbody = "=head1 SYNOPSIS\n\n swapon-file file\n\n=head1 DESCRIPTION\n\nThis command enables swap to a file.\nSee C<swapon_device> for other notes.",
  .run = run_swapon_file
};

struct command_entry swapoff_file_cmd_entry = {
  .name = "swapoff-file",
  .shortdesc = "disable swap on file",
  .podbody = "=head1 SYNOPSIS\n\n swapoff-file file\n\n=head1 DESCRIPTION\n\nThis command disables the libguestfs appliance swap on file.",
  .run = run_swapoff_file
};

struct command_entry swapon_label_cmd_entry = {
  .name = "swapon-label",
  .shortdesc = "enable swap on labeled swap partition",
  .podbody = "=head1 SYNOPSIS\n\n swapon-label label\n\n=head1 DESCRIPTION\n\nThis command enables swap to a labeled swap partition.\nSee C<swapon_device> for other notes.",
  .run = run_swapon_label
};

struct command_entry swapoff_label_cmd_entry = {
  .name = "swapoff-label",
  .shortdesc = "disable swap on labeled swap partition",
  .podbody = "=head1 SYNOPSIS\n\n swapoff-label label\n\n=head1 DESCRIPTION\n\nThis command disables the libguestfs appliance swap on\nlabeled swap partition.",
  .run = run_swapoff_label
};

struct command_entry swapon_uuid_cmd_entry = {
  .name = "swapon-uuid",
  .shortdesc = "enable swap on swap partition by UUID",
  .podbody = "=head1 SYNOPSIS\n\n swapon-uuid uuid\n\n=head1 DESCRIPTION\n\nThis command enables swap to a swap partition with the given UUID.\nSee C<swapon_device> for other notes.",
  .run = run_swapon_uuid
};

struct command_entry swapoff_uuid_cmd_entry = {
  .name = "swapoff-uuid",
  .shortdesc = "disable swap on swap partition by UUID",
  .podbody = "=head1 SYNOPSIS\n\n swapoff-uuid uuid\n\n=head1 DESCRIPTION\n\nThis command disables the libguestfs appliance swap partition\nwith the given UUID.",
  .run = run_swapoff_uuid
};

struct command_entry mkswap_file_cmd_entry = {
  .name = "mkswap-file",
  .shortdesc = "create a swap file",
  .podbody = "=head1 SYNOPSIS\n\n mkswap-file path\n\n=head1 DESCRIPTION\n\nCreate a swap file.\n\nThis command just writes a swap file signature to an existing\nfile.  To create the file itself, use something like C<fallocate>.",
  .run = run_mkswap_file
};

struct command_entry inotify_init_cmd_entry = {
  .name = "inotify-init",
  .shortdesc = "create an inotify handle",
  .podbody = "=head1 SYNOPSIS\n\n inotify-init maxevents\n\n=head1 DESCRIPTION\n\nThis command creates a new inotify handle.\nThe inotify subsystem can be used to notify events which happen to\nobjects in the guest filesystem.\n\nC<maxevents> is the maximum number of events which will be\nqueued up between calls to C<inotify_read> or\nC<inotify_files>.\nIf this is passed as C<0>, then the kernel (or previously set)\ndefault is used.  For Linux 2.6.29 the default was 16384 events.\nBeyond this limit, the kernel throws away events, but records\nthe fact that it threw them away by setting a flag\nC<IN_Q_OVERFLOW> in the returned structure list (see\nC<inotify_read>).\n\nBefore any events are generated, you have to add some\nwatches to the internal watch list.  See:\nC<inotify_add_watch>,\nC<inotify_rm_watch> and\nC<inotify_watch_all>.\n\nQueued up events should be read periodically by calling\nC<inotify_read>\n(or C<inotify_files> which is just a helpful\nwrapper around C<inotify_read>).  If you don't\nread the events out often enough then you risk the internal\nqueue overflowing.\n\nThe handle should be closed after use by calling\nC<inotify_close>.  This also removes any\nwatches automatically.\n\nSee also L<inotify(7)> for an overview of the inotify interface\nas exposed by the Linux kernel, which is roughly what we expose\nvia libguestfs.  Note that there is one global inotify handle\nper libguestfs instance.",
  .run = run_inotify_init
};

struct command_entry inotify_add_watch_cmd_entry = {
  .name = "inotify-add-watch",
  .shortdesc = "add an inotify watch",
  .podbody = "=head1 SYNOPSIS\n\n inotify-add-watch path mask\n\n=head1 DESCRIPTION\n\nWatch C<path> for the events listed in C<mask>.\n\nNote that if C<path> is a directory then events within that\ndirectory are watched, but this does I<not> happen recursively\n(in subdirectories).\n\nNote for non-C or non-Linux callers: the inotify events are\ndefined by the Linux kernel ABI and are listed in\nC</usr/include/sys/inotify.h>.",
  .run = run_inotify_add_watch
};

struct command_entry inotify_rm_watch_cmd_entry = {
  .name = "inotify-rm-watch",
  .shortdesc = "remove an inotify watch",
  .podbody = "=head1 SYNOPSIS\n\n inotify-rm-watch wd\n\n=head1 DESCRIPTION\n\nRemove a previously defined inotify watch.\nSee C<inotify_add_watch>.",
  .run = run_inotify_rm_watch
};

struct command_entry inotify_read_cmd_entry = {
  .name = "inotify-read",
  .shortdesc = "return list of inotify events",
  .podbody = "=head1 SYNOPSIS\n\n inotify-read\n\n=head1 DESCRIPTION\n\nReturn the complete queue of events that have happened\nsince the previous read call.\n\nIf no events have happened, this returns an empty list.\n\nI<Note>: In order to make sure that all events have been\nread, you must call this function repeatedly until it\nreturns an empty list.  The reason is that the call will\nread events up to the maximum appliance-to-host message\nsize and leave remaining events in the queue.",
  .run = run_inotify_read
};

struct command_entry inotify_files_cmd_entry = {
  .name = "inotify-files",
  .shortdesc = "return list of watched files that had events",
  .podbody = "=head1 SYNOPSIS\n\n inotify-files\n\n=head1 DESCRIPTION\n\nThis function is a helpful wrapper around C<inotify_read>\nwhich just returns a list of pathnames of objects that were\ntouched.  The returned pathnames are sorted and deduplicated.",
  .run = run_inotify_files
};

struct command_entry inotify_close_cmd_entry = {
  .name = "inotify-close",
  .shortdesc = "close the inotify handle",
  .podbody = "=head1 SYNOPSIS\n\n inotify-close\n\n=head1 DESCRIPTION\n\nThis closes the inotify handle which was previously\nopened by inotify_init.  It removes all watches, throws\naway any pending events, and deallocates all resources.",
  .run = run_inotify_close
};

struct command_entry setcon_cmd_entry = {
  .name = "setcon",
  .shortdesc = "set SELinux security context",
  .podbody = "=head1 SYNOPSIS\n\n setcon context\n\n=head1 DESCRIPTION\n\nThis sets the SELinux security context of the daemon\nto the string C<context>.\n\nSee the documentation about SELINUX in L<guestfs(3)>.",
  .run = run_setcon
};

struct command_entry getcon_cmd_entry = {
  .name = "getcon",
  .shortdesc = "get SELinux security context",
  .podbody = "=head1 SYNOPSIS\n\n getcon\n\n=head1 DESCRIPTION\n\nThis gets the SELinux security context of the daemon.\n\nSee the documentation about SELINUX in L<guestfs(3)>,\nand C<setcon>",
  .run = run_getcon
};

struct command_entry mkfs_b_cmd_entry = {
  .name = "mkfs-b",
  .shortdesc = "make a filesystem with block size",
  .podbody = "=head1 SYNOPSIS\n\n mkfs-b fstype blocksize device\n\n=head1 DESCRIPTION\n\nThis call is similar to C<mkfs>, but it allows you to\ncontrol the block size of the resulting filesystem.  Supported\nblock sizes depend on the filesystem type, but typically they\nare C<1024>, C<2048> or C<4096> only.\n\nFor VFAT and NTFS the C<blocksize> parameter is treated as\nthe requested cluster size.",
  .run = run_mkfs_b
};

struct command_entry mke2journal_cmd_entry = {
  .name = "mke2journal",
  .shortdesc = "make ext2/3/4 external journal",
  .podbody = "=head1 SYNOPSIS\n\n mke2journal blocksize device\n\n=head1 DESCRIPTION\n\nThis creates an ext2 external journal on C<device>.  It is equivalent\nto the command:\n\n mke2fs -O journal_dev -b blocksize device",
  .run = run_mke2journal
};

struct command_entry mke2journal_L_cmd_entry = {
  .name = "mke2journal-L",
  .shortdesc = "make ext2/3/4 external journal with label",
  .podbody = "=head1 SYNOPSIS\n\n mke2journal-L blocksize label device\n\n=head1 DESCRIPTION\n\nThis creates an ext2 external journal on C<device> with label C<label>.",
  .run = run_mke2journal_L
};

struct command_entry mke2journal_U_cmd_entry = {
  .name = "mke2journal-U",
  .shortdesc = "make ext2/3/4 external journal with UUID",
  .podbody = "=head1 SYNOPSIS\n\n mke2journal-U blocksize uuid device\n\n=head1 DESCRIPTION\n\nThis creates an ext2 external journal on C<device> with UUID C<uuid>.",
  .run = run_mke2journal_U
};

struct command_entry mke2fs_J_cmd_entry = {
  .name = "mke2fs-J",
  .shortdesc = "make ext2/3/4 filesystem with external journal",
  .podbody = "=head1 SYNOPSIS\n\n mke2fs-J fstype blocksize device journal\n\n=head1 DESCRIPTION\n\nThis creates an ext2/3/4 filesystem on C<device> with\nan external journal on C<journal>.  It is equivalent\nto the command:\n\n mke2fs -t fstype -b blocksize -J device=<journal> <device>\n\nSee also C<mke2journal>.",
  .run = run_mke2fs_J
};

struct command_entry mke2fs_JL_cmd_entry = {
  .name = "mke2fs-JL",
  .shortdesc = "make ext2/3/4 filesystem with external journal",
  .podbody = "=head1 SYNOPSIS\n\n mke2fs-JL fstype blocksize device label\n\n=head1 DESCRIPTION\n\nThis creates an ext2/3/4 filesystem on C<device> with\nan external journal on the journal labeled C<label>.\n\nSee also C<mke2journal_L>.",
  .run = run_mke2fs_JL
};

struct command_entry mke2fs_JU_cmd_entry = {
  .name = "mke2fs-JU",
  .shortdesc = "make ext2/3/4 filesystem with external journal",
  .podbody = "=head1 SYNOPSIS\n\n mke2fs-JU fstype blocksize device uuid\n\n=head1 DESCRIPTION\n\nThis creates an ext2/3/4 filesystem on C<device> with\nan external journal on the journal with UUID C<uuid>.\n\nSee also C<mke2journal_U>.",
  .run = run_mke2fs_JU
};

struct command_entry modprobe_cmd_entry = {
  .name = "modprobe",
  .shortdesc = "load a kernel module",
  .podbody = "=head1 SYNOPSIS\n\n modprobe modulename\n\n=head1 DESCRIPTION\n\nThis loads a kernel module in the appliance.\n\nThe kernel module must have been whitelisted when libguestfs\nwas built (see C<appliance/kmod.whitelist.in> in the source).",
  .run = run_modprobe
};

struct command_entry echo_daemon_cmd_entry = {
  .name = "echo-daemon",
  .shortdesc = "echo arguments back to the client",
  .podbody = "=head1 SYNOPSIS\n\n echo-daemon words\n\n=head1 DESCRIPTION\n\nThis command concatenates the list of C<words> passed with single spaces\nbetween them and returns the resulting string.\n\nYou can use this command to test the connection through to the daemon.\n\nSee also C<ping_daemon>.",
  .run = run_echo_daemon
};

struct command_entry find0_cmd_entry = {
  .name = "find0",
  .shortdesc = "find all files and directories, returning NUL-separated list",
  .podbody = "=head1 SYNOPSIS\n\n find0 directory files\n\n=head1 DESCRIPTION\n\nThis command lists out all files and directories, recursively,\nstarting at C<directory>, placing the resulting list in the\nexternal file called C<files>.\n\nThis command works the same way as C<find> with the\nfollowing exceptions:\n\n=over 4\n\n=item *\n\nThe resulting list is written to an external file.\n\n=item *\n\nItems (filenames) in the result are separated\nby C<\\0> characters.  See L<find(1)> option I<-print0>.\n\n=item *\n\nThis command is not limited in the number of names that it\ncan return.\n\n=item *\n\nThe result list is not sorted.\n\n=back",
  .run = run_find0
};

struct command_entry case_sensitive_path_cmd_entry = {
  .name = "case-sensitive-path",
  .shortdesc = "return true path on case-insensitive filesystem",
  .podbody = "=head1 SYNOPSIS\n\n case-sensitive-path path\n\n=head1 DESCRIPTION\n\nThis can be used to resolve case insensitive paths on\na filesystem which is case sensitive.  The use case is\nto resolve paths which you have read from Windows configuration\nfiles or the Windows Registry, to the true path.\n\nThe command handles a peculiarity of the Linux ntfs-3g\nfilesystem driver (and probably others), which is that although\nthe underlying filesystem is case-insensitive, the driver\nexports the filesystem to Linux as case-sensitive.\n\nOne consequence of this is that special directories such\nas C<c:\\windows> may appear as C</WINDOWS> or C</windows>\n(or other things) depending on the precise details of how\nthey were created.  In Windows itself this would not be\na problem.\n\nBug or feature?  You decide:\nL<http://www.tuxera.com/community/ntfs-3g-faq/#posixfilenames1>\n\nThis function resolves the true case of each element in the\npath and returns the case-sensitive path.\n\nThus C<case_sensitive_path> (\"/Windows/System32\")\nmight return C<\"/WINDOWS/system32\"> (the exact return value\nwould depend on details of how the directories were originally\ncreated under Windows).\n\nI<Note>:\nThis function does not handle drive names, backslashes etc.\n\nSee also C<realpath>.",
  .run = run_case_sensitive_path
};

struct command_entry vfs_type_cmd_entry = {
  .name = "vfs-type",
  .shortdesc = "get the Linux VFS type corresponding to a mounted device",
  .podbody = "=head1 SYNOPSIS\n\n vfs-type device\n\n=head1 DESCRIPTION\n\nThis command gets the filesystem type corresponding to\nthe filesystem on C<device>.\n\nFor most filesystems, the result is the name of the Linux\nVFS module which would be used to mount this filesystem\nif you mounted it without specifying the filesystem type.\nFor example a string such as C<ext3> or C<ntfs>.",
  .run = run_vfs_type
};

struct command_entry truncate_cmd_entry = {
  .name = "truncate",
  .shortdesc = "truncate a file to zero size",
  .podbody = "=head1 SYNOPSIS\n\n truncate path\n\n=head1 DESCRIPTION\n\nThis command truncates C<path> to a zero-length file.  The\nfile must exist already.",
  .run = run_truncate
};

struct command_entry truncate_size_cmd_entry = {
  .name = "truncate-size",
  .shortdesc = "truncate a file to a particular size",
  .podbody = "=head1 SYNOPSIS\n\n truncate-size path size\n\n=head1 DESCRIPTION\n\nThis command truncates C<path> to size C<size> bytes.  The file\nmust exist already.\n\nIf the current file size is less than C<size> then\nthe file is extended to the required size with zero bytes.\nThis creates a sparse file (ie. disk blocks are not allocated\nfor the file until you write to it).  To create a non-sparse\nfile of zeroes, use C<fallocate64> instead.",
  .run = run_truncate_size
};

struct command_entry utimens_cmd_entry = {
  .name = "utimens",
  .shortdesc = "set timestamp of a file with nanosecond precision",
  .podbody = "=head1 SYNOPSIS\n\n utimens path atsecs atnsecs mtsecs mtnsecs\n\n=head1 DESCRIPTION\n\nThis command sets the timestamps of a file with nanosecond\nprecision.\n\nC<atsecs, atnsecs> are the last access time (atime) in secs and\nnanoseconds from the epoch.\n\nC<mtsecs, mtnsecs> are the last modification time (mtime) in\nsecs and nanoseconds from the epoch.\n\nIf the C<*nsecs> field contains the special value C<-1> then\nthe corresponding timestamp is set to the current time.  (The\nC<*secs> field is ignored in this case).\n\nIf the C<*nsecs> field contains the special value C<-2> then\nthe corresponding timestamp is left unchanged.  (The\nC<*secs> field is ignored in this case).",
  .run = run_utimens
};

struct command_entry mkdir_mode_cmd_entry = {
  .name = "mkdir-mode",
  .shortdesc = "create a directory with a particular mode",
  .podbody = "=head1 SYNOPSIS\n\n mkdir-mode path mode\n\n=head1 DESCRIPTION\n\nThis command creates a directory, setting the initial permissions\nof the directory to C<mode>.\n\nFor common Linux filesystems, the actual mode which is set will\nbe C<mode & ~umask & 01777>.  Non-native-Linux filesystems may\ninterpret the mode in other ways.\n\nSee also C<mkdir>, C<umask>",
  .run = run_mkdir_mode
};

struct command_entry lchown_cmd_entry = {
  .name = "lchown",
  .shortdesc = "change file owner and group",
  .podbody = "=head1 SYNOPSIS\n\n lchown owner group path\n\n=head1 DESCRIPTION\n\nChange the file owner to C<owner> and group to C<group>.\nThis is like C<chown> but if C<path> is a symlink then\nthe link itself is changed, not the target.\n\nOnly numeric uid and gid are supported.  If you want to use\nnames, you will need to locate and parse the password file\nyourself (Augeas support makes this relatively easy).",
  .run = run_lchown
};

struct command_entry lstatlist_cmd_entry = {
  .name = "lstatlist",
  .shortdesc = "lstat on multiple files",
  .podbody = "=head1 SYNOPSIS\n\n lstatlist path names\n\n=head1 DESCRIPTION\n\nThis call allows you to perform the C<lstat> operation\non multiple files, where all files are in the directory C<path>.\nC<names> is the list of files from this directory.\n\nOn return you get a list of stat structs, with a one-to-one\ncorrespondence to the C<names> list.  If any name did not exist\nor could not be lstat'd, then the C<ino> field of that structure\nis set to C<-1>.\n\nThis call is intended for programs that want to efficiently\nlist a directory contents without making many round-trips.\nSee also C<lxattrlist> for a similarly efficient call\nfor getting extended attributes.  Very long directory listings\nmight cause the protocol message size to be exceeded, causing\nthis call to fail.  The caller must split up such requests\ninto smaller groups of names.",
  .run = run_lstatlist
};

struct command_entry lxattrlist_cmd_entry = {
  .name = "lxattrlist",
  .shortdesc = "lgetxattr on multiple files",
  .podbody = "=head1 SYNOPSIS\n\n lxattrlist path names\n\n=head1 DESCRIPTION\n\nThis call allows you to get the extended attributes\nof multiple files, where all files are in the directory C<path>.\nC<names> is the list of files from this directory.\n\nOn return you get a flat list of xattr structs which must be\ninterpreted sequentially.  The first xattr struct always has a zero-length\nC<attrname>.  C<attrval> in this struct is zero-length\nto indicate there was an error doing C<lgetxattr> for this\nfile, I<or> is a C string which is a decimal number\n(the number of following attributes for this file, which could\nbe C<\"0\">).  Then after the first xattr struct are the\nzero or more attributes for the first named file.\nThis repeats for the second and subsequent files.\n\nThis call is intended for programs that want to efficiently\nlist a directory contents without making many round-trips.\nSee also C<lstatlist> for a similarly efficient call\nfor getting standard stats.  Very long directory listings\nmight cause the protocol message size to be exceeded, causing\nthis call to fail.  The caller must split up such requests\ninto smaller groups of names.",
  .run = run_lxattrlist
};

struct command_entry readlinklist_cmd_entry = {
  .name = "readlinklist",
  .shortdesc = "readlink on multiple files",
  .podbody = "=head1 SYNOPSIS\n\n readlinklist path names\n\n=head1 DESCRIPTION\n\nThis call allows you to do a C<readlink> operation\non multiple files, where all files are in the directory C<path>.\nC<names> is the list of files from this directory.\n\nOn return you get a list of strings, with a one-to-one\ncorrespondence to the C<names> list.  Each string is the\nvalue of the symbolic link.\n\nIf the C<readlink(2)> operation fails on any name, then\nthe corresponding result string is the empty string C<\"\">.\nHowever the whole operation is completed even if there\nwere C<readlink(2)> errors, and so you can call this\nfunction with names where you don't know if they are\nsymbolic links already (albeit slightly less efficient).\n\nThis call is intended for programs that want to efficiently\nlist a directory contents without making many round-trips.\nVery long directory listings might cause the protocol\nmessage size to be exceeded, causing\nthis call to fail.  The caller must split up such requests\ninto smaller groups of names.",
  .run = run_readlinklist
};

struct command_entry pread_cmd_entry = {
  .name = "pread",
  .shortdesc = "read part of a file",
  .podbody = "=head1 SYNOPSIS\n\n pread path count offset\n\n=head1 DESCRIPTION\n\nThis command lets you read part of a file.  It reads C<count>\nbytes of the file, starting at C<offset>, from file C<path>.\n\nThis may read fewer bytes than requested.  For further details\nsee the L<pread(2)> system call.\n\nSee also C<pwrite>, C<pread_device>.\n\nBecause of the message protocol, there is a transfer limit\nof somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.",
  .run = run_pread
};

struct command_entry part_init_cmd_entry = {
  .name = "part-init",
  .shortdesc = "create an empty partition table",
  .podbody = "=head1 SYNOPSIS\n\n part-init device parttype\n\n=head1 DESCRIPTION\n\nThis creates an empty partition table on C<device> of one of the\npartition types listed below.  Usually C<parttype> should be\neither C<msdos> or C<gpt> (for large disks).\n\nInitially there are no partitions.  Following this, you should\ncall C<part_add> for each partition required.\n\nPossible values for C<parttype> are:\n\n=over 4\n\n=item B<efi> | B<gpt>\n\nIntel EFI / GPT partition table.\n\nThis is recommended for >= 2 TB partitions that will be accessed\nfrom Linux and Intel-based Mac OS X.  It also has limited backwards\ncompatibility with the C<mbr> format.\n\n=item B<mbr> | B<msdos>\n\nThe standard PC \"Master Boot Record\" (MBR) format used\nby MS-DOS and Windows.  This partition type will B<only> work\nfor device sizes up to 2 TB.  For large disks we recommend\nusing C<gpt>.\n\n=back\n\nOther partition table types that may work but are not\nsupported include:\n\n=over 4\n\n=item B<aix>\n\nAIX disk labels.\n\n=item B<amiga> | B<rdb>\n\nAmiga \"Rigid Disk Block\" format.\n\n=item B<bsd>\n\nBSD disk labels.\n\n=item B<dasd>\n\nDASD, used on IBM mainframes.\n\n=item B<dvh>\n\nMIPS/SGI volumes.\n\n=item B<mac>\n\nOld Mac partition format.  Modern Macs use C<gpt>.\n\n=item B<pc98>\n\nNEC PC-98 format, common in Japan apparently.\n\n=item B<sun>\n\nSun disk labels.\n\n=back",
  .run = run_part_init
};

struct command_entry part_add_cmd_entry = {
  .name = "part-add",
  .shortdesc = "add a partition to the device",
  .podbody = "=head1 SYNOPSIS\n\n part-add device prlogex startsect endsect\n\n=head1 DESCRIPTION\n\nThis command adds a partition to C<device>.  If there is no partition\ntable on the device, call C<part_init> first.\n\nThe C<prlogex> parameter is the type of partition.  Normally you\nshould pass C<p> or C<primary> here, but MBR partition tables also\nsupport C<l> (or C<logical>) and C<e> (or C<extended>) partition\ntypes.\n\nC<startsect> and C<endsect> are the start and end of the partition\nin I<sectors>.  C<endsect> may be negative, which means it counts\nbackwards from the end of the disk (C<-1> is the last sector).\n\nCreating a partition which covers the whole disk is not so easy.\nUse C<part_disk> to do that.",
  .run = run_part_add
};

struct command_entry part_disk_cmd_entry = {
  .name = "part-disk",
  .shortdesc = "partition whole disk with a single primary partition",
  .podbody = "=head1 SYNOPSIS\n\n part-disk device parttype\n\n=head1 DESCRIPTION\n\nThis command is simply a combination of C<part_init>\nfollowed by C<part_add> to create a single primary partition\ncovering the whole disk.\n\nC<parttype> is the partition table type, usually C<mbr> or C<gpt>,\nbut other possible values are described in C<part_init>.\n\nB<This command is dangerous.  Without careful use you\ncan easily destroy all your data>.",
  .run = run_part_disk
};

struct command_entry part_set_bootable_cmd_entry = {
  .name = "part-set-bootable",
  .shortdesc = "make a partition bootable",
  .podbody = "=head1 SYNOPSIS\n\n part-set-bootable device partnum bootable\n\n=head1 DESCRIPTION\n\nThis sets the bootable flag on partition numbered C<partnum> on\ndevice C<device>.  Note that partitions are numbered from 1.\n\nThe bootable flag is used by some operating systems (notably\nWindows) to determine which partition to boot from.  It is by\nno means universally recognized.",
  .run = run_part_set_bootable
};

struct command_entry part_set_name_cmd_entry = {
  .name = "part-set-name",
  .shortdesc = "set partition name",
  .podbody = "=head1 SYNOPSIS\n\n part-set-name device partnum name\n\n=head1 DESCRIPTION\n\nThis sets the partition name on partition numbered C<partnum> on\ndevice C<device>.  Note that partitions are numbered from 1.\n\nThe partition name can only be set on certain types of partition\ntable.  This works on C<gpt> but not on C<mbr> partitions.",
  .run = run_part_set_name
};

struct command_entry part_list_cmd_entry = {
  .name = "part-list",
  .shortdesc = "list partitions on a device",
  .podbody = "=head1 SYNOPSIS\n\n part-list device\n\n=head1 DESCRIPTION\n\nThis command parses the partition table on C<device> and\nreturns the list of partitions found.\n\nThe fields in the returned structure are:\n\n=over 4\n\n=item B<part_num>\n\nPartition number, counting from 1.\n\n=item B<part_start>\n\nStart of the partition I<in bytes>.  To get sectors you have to\ndivide by the device's sector size, see C<blockdev_getss>.\n\n=item B<part_end>\n\nEnd of the partition in bytes.\n\n=item B<part_size>\n\nSize of the partition in bytes.\n\n=back",
  .run = run_part_list
};

struct command_entry part_get_parttype_cmd_entry = {
  .name = "part-get-parttype",
  .shortdesc = "get the partition table type",
  .podbody = "=head1 SYNOPSIS\n\n part-get-parttype device\n\n=head1 DESCRIPTION\n\nThis command examines the partition table on C<device> and\nreturns the partition table type (format) being used.\n\nCommon return values include: C<msdos> (a DOS/Windows style MBR\npartition table), C<gpt> (a GPT/EFI-style partition table).  Other\nvalues are possible, although unusual.  See C<part_init>\nfor a full list.",
  .run = run_part_get_parttype
};

struct command_entry fill_cmd_entry = {
  .name = "fill",
  .shortdesc = "fill a file with octets",
  .podbody = "=head1 SYNOPSIS\n\n fill c len path\n\n=head1 DESCRIPTION\n\nThis command creates a new file called C<path>.  The initial\ncontent of the file is C<len> octets of C<c>, where C<c>\nmust be a number in the range C<[0..255]>.\n\nTo fill a file with zero bytes (sparsely), it is\nmuch more efficient to use C<truncate_size>.\nTo create a file with a pattern of repeating bytes\nuse C<fill_pattern>.",
  .run = run_fill
};

struct command_entry available_cmd_entry = {
  .name = "available",
  .shortdesc = "test availability of some parts of the API",
  .podbody = "=head1 SYNOPSIS\n\n available groups\n\n=head1 DESCRIPTION\n\nThis command is used to check the availability of some\ngroups of functionality in the appliance, which not all builds of\nthe libguestfs appliance will be able to provide.\n\nThe libguestfs groups, and the functions that those\ngroups correspond to, are listed in L<guestfs(3)/AVAILABILITY>.\nYou can also fetch this list at runtime by calling\nC<available_all_groups>.\n\nThe argument C<groups> is a list of group names, eg:\nC<[\"inotify\", \"augeas\"]> would check for the availability of\nthe Linux inotify functions and Augeas (configuration file\nediting) functions.\n\nThe command returns no error if I<all> requested groups are available.\n\nIt fails with an error if one or more of the requested\ngroups is unavailable in the appliance.\n\nIf an unknown group name is included in the\nlist of groups then an error is always returned.\n\nI<Notes:>\n\n=over 4\n\n=item *\n\nYou must call C<launch> before calling this function.\n\nThe reason is because we don't know what groups are\nsupported by the appliance/daemon until it is running and can\nbe queried.\n\n=item *\n\nIf a group of functions is available, this does not necessarily\nmean that they will work.  You still have to check for errors\nwhen calling individual API functions even if they are\navailable.\n\n=item *\n\nIt is usually the job of distro packagers to build\ncomplete functionality into the libguestfs appliance.\nUpstream libguestfs, if built from source with all\nrequirements satisfied, will support everything.\n\n=item *\n\nThis call was added in version C<1.0.80>.  In previous\nversions of libguestfs all you could do would be to speculatively\nexecute a command to find out if the daemon implemented it.\nSee also C<version>.\n\n=back",
  .run = run_available
};

struct command_entry dd_cmd_entry = {
  .name = "dd",
  .shortdesc = "copy from source to destination using dd",
  .podbody = "=head1 SYNOPSIS\n\n dd src dest\n\n=head1 DESCRIPTION\n\nThis command copies from one source device or file C<src>\nto another destination device or file C<dest>.  Normally you\nwould use this to copy to or from a device or partition, for\nexample to duplicate a filesystem.\n\nIf the destination is a device, it must be as large or larger\nthan the source file or device, otherwise the copy will fail.\nThis command cannot do partial copies (see C<copy_size>).",
  .run = run_dd
};

struct command_entry filesize_cmd_entry = {
  .name = "filesize",
  .shortdesc = "return the size of the file in bytes",
  .podbody = "=head1 SYNOPSIS\n\n filesize file\n\n=head1 DESCRIPTION\n\nThis command returns the size of C<file> in bytes.\n\nTo get other stats about a file, use C<stat>, C<lstat>,\nC<is_dir>, C<is_file> etc.\nTo get the size of block devices, use C<blockdev_getsize64>.",
  .run = run_filesize
};

struct command_entry lvrename_cmd_entry = {
  .name = "lvrename",
  .shortdesc = "rename an LVM logical volume",
  .podbody = "=head1 SYNOPSIS\n\n lvrename logvol newlogvol\n\n=head1 DESCRIPTION\n\nRename a logical volume C<logvol> with the new name C<newlogvol>.",
  .run = run_lvrename
};

struct command_entry vgrename_cmd_entry = {
  .name = "vgrename",
  .shortdesc = "rename an LVM volume group",
  .podbody = "=head1 SYNOPSIS\n\n vgrename volgroup newvolgroup\n\n=head1 DESCRIPTION\n\nRename a volume group C<volgroup> with the new name C<newvolgroup>.",
  .run = run_vgrename
};

struct command_entry initrd_cat_cmd_entry = {
  .name = "initrd-cat",
  .shortdesc = "list the contents of a single file in an initrd",
  .podbody = "=head1 SYNOPSIS\n\n initrd-cat initrdpath filename\n\n=head1 DESCRIPTION\n\nThis command unpacks the file C<filename> from the initrd file\ncalled C<initrdpath>.  The filename must be given I<without> the\ninitial C</> character.\n\nFor example, in guestfish you could use the following command\nto examine the boot script (usually called C</init>)\ncontained in a Linux initrd or initramfs image:\n\n initrd-cat /boot/initrd-<version>.img init\n\nSee also C<initrd_list>.\n\nBecause of the message protocol, there is a transfer limit\nof somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.",
  .run = run_initrd_cat
};

struct command_entry pvuuid_cmd_entry = {
  .name = "pvuuid",
  .shortdesc = "get the UUID of a physical volume",
  .podbody = "=head1 SYNOPSIS\n\n pvuuid device\n\n=head1 DESCRIPTION\n\nThis command returns the UUID of the LVM PV C<device>.",
  .run = run_pvuuid
};

struct command_entry vguuid_cmd_entry = {
  .name = "vguuid",
  .shortdesc = "get the UUID of a volume group",
  .podbody = "=head1 SYNOPSIS\n\n vguuid vgname\n\n=head1 DESCRIPTION\n\nThis command returns the UUID of the LVM VG named C<vgname>.",
  .run = run_vguuid
};

struct command_entry lvuuid_cmd_entry = {
  .name = "lvuuid",
  .shortdesc = "get the UUID of a logical volume",
  .podbody = "=head1 SYNOPSIS\n\n lvuuid device\n\n=head1 DESCRIPTION\n\nThis command returns the UUID of the LVM LV C<device>.",
  .run = run_lvuuid
};

struct command_entry vgpvuuids_cmd_entry = {
  .name = "vgpvuuids",
  .shortdesc = "get the PV UUIDs containing the volume group",
  .podbody = "=head1 SYNOPSIS\n\n vgpvuuids vgname\n\n=head1 DESCRIPTION\n\nGiven a VG called C<vgname>, this returns the UUIDs of all\nthe physical volumes that this volume group resides on.\n\nYou can use this along with C<pvs> and C<pvuuid>\ncalls to associate physical volumes and volume groups.\n\nSee also C<vglvuuids>.",
  .run = run_vgpvuuids
};

struct command_entry vglvuuids_cmd_entry = {
  .name = "vglvuuids",
  .shortdesc = "get the LV UUIDs of all LVs in the volume group",
  .podbody = "=head1 SYNOPSIS\n\n vglvuuids vgname\n\n=head1 DESCRIPTION\n\nGiven a VG called C<vgname>, this returns the UUIDs of all\nthe logical volumes created in this volume group.\n\nYou can use this along with C<lvs> and C<lvuuid>\ncalls to associate logical volumes and volume groups.\n\nSee also C<vgpvuuids>.",
  .run = run_vglvuuids
};

struct command_entry copy_size_cmd_entry = {
  .name = "copy-size",
  .shortdesc = "copy size bytes from source to destination using dd",
  .podbody = "=head1 SYNOPSIS\n\n copy-size src dest size\n\n=head1 DESCRIPTION\n\nThis command copies exactly C<size> bytes from one source device\nor file C<src> to another destination device or file C<dest>.\n\nNote this will fail if the source is too short or if the destination\nis not large enough.",
  .run = run_copy_size
};

struct command_entry zero_device_cmd_entry = {
  .name = "zero-device",
  .shortdesc = "write zeroes to an entire device",
  .podbody = "=head1 SYNOPSIS\n\n zero-device device\n\n=head1 DESCRIPTION\n\nThis command writes zeroes over the entire C<device>.  Compare\nwith C<zero> which just zeroes the first few blocks of\na device.\n\nB<This command is dangerous.  Without careful use you\ncan easily destroy all your data>.",
  .run = run_zero_device
};

struct command_entry txz_in_cmd_entry = {
  .name = "txz-in",
  .shortdesc = "unpack compressed tarball to directory",
  .podbody = "=head1 SYNOPSIS\n\n txz-in tarball directory\n\n=head1 DESCRIPTION\n\nThis command uploads and unpacks local file C<tarball> (an\nI<xz compressed> tar file) into C<directory>.",
  .run = run_txz_in
};

struct command_entry txz_out_cmd_entry = {
  .name = "txz-out",
  .shortdesc = "pack directory into compressed tarball",
  .podbody = "=head1 SYNOPSIS\n\n txz-out directory tarball\n\n=head1 DESCRIPTION\n\nThis command packs the contents of C<directory> and downloads\nit to local file C<tarball> (as an xz compressed tar archive).",
  .run = run_txz_out
};

struct command_entry ntfsresize_cmd_entry = {
  .name = "ntfsresize",
  .shortdesc = "resize an NTFS filesystem",
  .podbody = "=head1 SYNOPSIS\n\n ntfsresize device\n\n=head1 DESCRIPTION\n\nThis command resizes an NTFS filesystem, expanding or\nshrinking it to the size of the underlying device.\nSee also L<ntfsresize(8)>.",
  .run = run_ntfsresize
};

struct command_entry vgscan_cmd_entry = {
  .name = "vgscan",
  .shortdesc = "rescan for LVM physical volumes, volume groups and logical volumes",
  .podbody = "=head1 SYNOPSIS\n\n vgscan\n\n=head1 DESCRIPTION\n\nThis rescans all block devices and rebuilds the list of LVM\nphysical volumes, volume groups and logical volumes.",
  .run = run_vgscan
};

struct command_entry part_del_cmd_entry = {
  .name = "part-del",
  .shortdesc = "delete a partition",
  .podbody = "=head1 SYNOPSIS\n\n part-del device partnum\n\n=head1 DESCRIPTION\n\nThis command deletes the partition numbered C<partnum> on C<device>.\n\nNote that in the case of MBR partitioning, deleting an\nextended partition also deletes any logical partitions\nit contains.",
  .run = run_part_del
};

struct command_entry part_get_bootable_cmd_entry = {
  .name = "part-get-bootable",
  .shortdesc = "return true if a partition is bootable",
  .podbody = "=head1 SYNOPSIS\n\n part-get-bootable device partnum\n\n=head1 DESCRIPTION\n\nThis command returns true if the partition C<partnum> on\nC<device> has the bootable flag set.\n\nSee also C<part_set_bootable>.",
  .run = run_part_get_bootable
};

struct command_entry part_get_mbr_id_cmd_entry = {
  .name = "part-get-mbr-id",
  .shortdesc = "get the MBR type byte (ID byte) from a partition",
  .podbody = "=head1 SYNOPSIS\n\n part-get-mbr-id device partnum\n\n=head1 DESCRIPTION\n\nReturns the MBR type byte (also known as the ID byte) from\nthe numbered partition C<partnum>.\n\nNote that only MBR (old DOS-style) partitions have type bytes.\nYou will get undefined results for other partition table\ntypes (see C<part_get_parttype>).",
  .run = run_part_get_mbr_id
};

struct command_entry part_set_mbr_id_cmd_entry = {
  .name = "part-set-mbr-id",
  .shortdesc = "set the MBR type byte (ID byte) of a partition",
  .podbody = "=head1 SYNOPSIS\n\n part-set-mbr-id device partnum idbyte\n\n=head1 DESCRIPTION\n\nSets the MBR type byte (also known as the ID byte) of\nthe numbered partition C<partnum> to C<idbyte>.  Note\nthat the type bytes quoted in most documentation are\nin fact hexadecimal numbers, but usually documented\nwithout any leading \"0x\" which might be confusing.\n\nNote that only MBR (old DOS-style) partitions have type bytes.\nYou will get undefined results for other partition table\ntypes (see C<part_get_parttype>).",
  .run = run_part_set_mbr_id
};

struct command_entry checksum_device_cmd_entry = {
  .name = "checksum-device",
  .shortdesc = "compute MD5, SHAx or CRC checksum of the contents of a device",
  .podbody = "=head1 SYNOPSIS\n\n checksum-device csumtype device\n\n=head1 DESCRIPTION\n\nThis call computes the MD5, SHAx or CRC checksum of the\ncontents of the device named C<device>.  For the types of\nchecksums supported see the C<checksum> command.",
  .run = run_checksum_device
};

struct command_entry lvresize_free_cmd_entry = {
  .name = "lvresize-free",
  .shortdesc = "expand an LV to fill free space",
  .podbody = "=head1 SYNOPSIS\n\n lvresize-free lv percent\n\n=head1 DESCRIPTION\n\nThis expands an existing logical volume C<lv> so that it fills\nC<pc>% of the remaining free space in the volume group.  Commonly\nyou would call this with pc = 100 which expands the logical volume\nas much as possible, using all remaining free space in the volume\ngroup.",
  .run = run_lvresize_free
};

struct command_entry aug_clear_cmd_entry = {
  .name = "aug-clear",
  .shortdesc = "clear Augeas path",
  .podbody = "=head1 SYNOPSIS\n\n aug-clear augpath\n\n=head1 DESCRIPTION\n\nSet the value associated with C<path> to C<NULL>.  This\nis the same as the L<augtool(1)> C<clear> command.",
  .run = run_aug_clear
};

struct command_entry get_umask_cmd_entry = {
  .name = "get-umask",
  .shortdesc = "get the current umask",
  .podbody = "=head1 SYNOPSIS\n\n get-umask\n\n=head1 DESCRIPTION\n\nReturn the current umask.  By default the umask is C<022>\nunless it has been set by calling C<umask>.",
  .run = run_get_umask
};

struct command_entry debug_upload_cmd_entry = {
  .name = "debug-upload",
  .shortdesc = "upload a file to the appliance (internal use only)",
  .podbody = "=head1 SYNOPSIS\n\n debug-upload filename tmpname mode\n\n=head1 DESCRIPTION\n\nThe C<debug_upload> command uploads a file to\nthe libguestfs appliance.\n\nThere is no comprehensive help for this command.  You have\nto look at the file C<daemon/debug.c> in the libguestfs source\nto find out what it is for.",
  .run = run_debug_upload
};

struct command_entry base64_in_cmd_entry = {
  .name = "base64-in",
  .shortdesc = "upload base64-encoded data to file",
  .podbody = "=head1 SYNOPSIS\n\n base64-in base64file filename\n\n=head1 DESCRIPTION\n\nThis command uploads base64-encoded data from C<base64file>\nto C<filename>.",
  .run = run_base64_in
};

struct command_entry base64_out_cmd_entry = {
  .name = "base64-out",
  .shortdesc = "download file and encode as base64",
  .podbody = "=head1 SYNOPSIS\n\n base64-out filename base64file\n\n=head1 DESCRIPTION\n\nThis command downloads the contents of C<filename>, writing\nit out to local file C<base64file> encoded as base64.",
  .run = run_base64_out
};

struct command_entry checksums_out_cmd_entry = {
  .name = "checksums-out",
  .shortdesc = "compute MD5, SHAx or CRC checksum of files in a directory",
  .podbody = "=head1 SYNOPSIS\n\n checksums-out csumtype directory sumsfile\n\n=head1 DESCRIPTION\n\nThis command computes the checksums of all regular files in\nC<directory> and then emits a list of those checksums to\nthe local output file C<sumsfile>.\n\nThis can be used for verifying the integrity of a virtual\nmachine.  However to be properly secure you should pay\nattention to the output of the checksum command (it uses\nthe ones from GNU coreutils).  In particular when the\nfilename is not printable, coreutils uses a special\nbackslash syntax.  For more information, see the GNU\ncoreutils info file.",
  .run = run_checksums_out
};

struct command_entry fill_pattern_cmd_entry = {
  .name = "fill-pattern",
  .shortdesc = "fill a file with a repeating pattern of bytes",
  .podbody = "=head1 SYNOPSIS\n\n fill-pattern pattern len path\n\n=head1 DESCRIPTION\n\nThis function is like C<fill> except that it creates\na new file of length C<len> containing the repeating pattern\nof bytes in C<pattern>.  The pattern is truncated if necessary\nto ensure the length of the file is exactly C<len> bytes.",
  .run = run_fill_pattern
};

struct command_entry write_cmd_entry = {
  .name = "write",
  .shortdesc = "create a new file",
  .podbody = "=head1 SYNOPSIS\n\n write path content\n\n=head1 DESCRIPTION\n\nThis call creates a file called C<path>.  The content of the\nfile is the string C<content> (which can contain any 8 bit data).\n\nBecause of the message protocol, there is a transfer limit\nof somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.",
  .run = run_write
};

struct command_entry pwrite_cmd_entry = {
  .name = "pwrite",
  .shortdesc = "write to part of a file",
  .podbody = "=head1 SYNOPSIS\n\n pwrite path content offset\n\n=head1 DESCRIPTION\n\nThis command writes to part of a file.  It writes the data\nbuffer C<content> to the file C<path> starting at offset C<offset>.\n\nThis command implements the L<pwrite(2)> system call, and like\nthat system call it may not write the full data requested.  The\nreturn value is the number of bytes that were actually written\nto the file.  This could even be 0, although short writes are\nunlikely for regular files in ordinary circumstances.\n\nSee also C<pread>, C<pwrite_device>.\n\nBecause of the message protocol, there is a transfer limit\nof somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.",
  .run = run_pwrite
};

struct command_entry resize2fs_size_cmd_entry = {
  .name = "resize2fs-size",
  .shortdesc = "resize an ext2, ext3 or ext4 filesystem (with size)",
  .podbody = "=head1 SYNOPSIS\n\n resize2fs-size device size\n\n=head1 DESCRIPTION\n\nThis command is the same as C<resize2fs> except that it\nallows you to specify the new size (in bytes) explicitly.",
  .run = run_resize2fs_size
};

struct command_entry pvresize_size_cmd_entry = {
  .name = "pvresize-size",
  .shortdesc = "resize an LVM physical volume (with size)",
  .podbody = "=head1 SYNOPSIS\n\n pvresize-size device size\n\n=head1 DESCRIPTION\n\nThis command is the same as C<pvresize> except that it\nallows you to specify the new size (in bytes) explicitly.",
  .run = run_pvresize_size
};

struct command_entry ntfsresize_size_cmd_entry = {
  .name = "ntfsresize-size",
  .shortdesc = "resize an NTFS filesystem (with size)",
  .podbody = "=head1 SYNOPSIS\n\n ntfsresize-size device size\n\n=head1 DESCRIPTION\n\nThis command is the same as C<ntfsresize> except that it\nallows you to specify the new size (in bytes) explicitly.",
  .run = run_ntfsresize_size
};

struct command_entry available_all_groups_cmd_entry = {
  .name = "available-all-groups",
  .shortdesc = "return a list of all optional groups",
  .podbody = "=head1 SYNOPSIS\n\n available-all-groups\n\n=head1 DESCRIPTION\n\nThis command returns a list of all optional groups that this\ndaemon knows about.  Note this returns both supported and unsupported\ngroups.  To find out which ones the daemon can actually support\nyou have to call C<available> on each member of the\nreturned list.\n\nSee also C<available> and L<guestfs(3)/AVAILABILITY>.",
  .run = run_available_all_groups
};

struct command_entry fallocate64_cmd_entry = {
  .name = "fallocate64",
  .shortdesc = "preallocate a file in the guest filesystem",
  .podbody = "=head1 SYNOPSIS\n\n fallocate64 path len\n\n=head1 DESCRIPTION\n\nThis command preallocates a file (containing zero bytes) named\nC<path> of size C<len> bytes.  If the file exists already, it\nis overwritten.\n\nNote that this call allocates disk blocks for the file.\nTo create a sparse file use C<truncate_size> instead.\n\nThe deprecated call C<fallocate> does the same,\nbut owing to an oversight it only allowed 30 bit lengths\nto be specified, effectively limiting the maximum size\nof files created through that call to 1GB.\n\nDo not confuse this with the guestfish-specific\nC<alloc> and C<sparse> commands which create\na file in the host and attach it as a device.",
  .run = run_fallocate64
};

struct command_entry vfs_label_cmd_entry = {
  .name = "vfs-label",
  .shortdesc = "get the filesystem label",
  .podbody = "=head1 SYNOPSIS\n\n vfs-label device\n\n=head1 DESCRIPTION\n\nThis returns the filesystem label of the filesystem on\nC<device>.\n\nIf the filesystem is unlabeled, this returns the empty string.\n\nTo find a filesystem from the label, use C<findfs_label>.",
  .run = run_vfs_label
};

struct command_entry vfs_uuid_cmd_entry = {
  .name = "vfs-uuid",
  .shortdesc = "get the filesystem UUID",
  .podbody = "=head1 SYNOPSIS\n\n vfs-uuid device\n\n=head1 DESCRIPTION\n\nThis returns the filesystem UUID of the filesystem on\nC<device>.\n\nIf the filesystem does not have a UUID, this returns the empty string.\n\nTo find a filesystem from the UUID, use C<findfs_uuid>.",
  .run = run_vfs_uuid
};

struct command_entry lvm_set_filter_cmd_entry = {
  .name = "lvm-set-filter",
  .shortdesc = "set LVM device filter",
  .podbody = "=head1 SYNOPSIS\n\n lvm-set-filter devices\n\n=head1 DESCRIPTION\n\nThis sets the LVM device filter so that LVM will only be\nable to \"see\" the block devices in the list C<devices>,\nand will ignore all other attached block devices.\n\nWhere disk image(s) contain duplicate PVs or VGs, this\ncommand is useful to get LVM to ignore the duplicates, otherwise\nLVM can get confused.  Note also there are two types\nof duplication possible: either cloned PVs/VGs which have\nidentical UUIDs; or VGs that are not cloned but just happen\nto have the same name.  In normal operation you cannot\ncreate this situation, but you can do it outside LVM, eg.\nby cloning disk images or by bit twiddling inside the LVM\nmetadata.\n\nThis command also clears the LVM cache and performs a volume\ngroup scan.\n\nYou can filter whole block devices or individual partitions.\n\nYou cannot use this if any VG is currently in use (eg.\ncontains a mounted filesystem), even if you are not\nfiltering out that VG.",
  .run = run_lvm_set_filter
};

struct command_entry lvm_clear_filter_cmd_entry = {
  .name = "lvm-clear-filter",
  .shortdesc = "clear LVM device filter",
  .podbody = "=head1 SYNOPSIS\n\n lvm-clear-filter\n\n=head1 DESCRIPTION\n\nThis undoes the effect of C<lvm_set_filter>.  LVM\nwill be able to see every block device.\n\nThis command also clears the LVM cache and performs a volume\ngroup scan.",
  .run = run_lvm_clear_filter
};

struct command_entry luks_open_cmd_entry = {
  .name = "luks-open",
  .shortdesc = "open a LUKS-encrypted block device",
  .podbody = "=head1 SYNOPSIS\n\n luks-open device mapname\n\n=head1 DESCRIPTION\n\nThis command opens a block device which has been encrypted\naccording to the Linux Unified Key Setup (LUKS) standard.\n\nC<device> is the encrypted block device or partition.\n\nThe caller must supply one of the keys associated with the\nLUKS block device, in the C<key> parameter.\n\nThis creates a new block device called C</dev/mapper/mapname>.\nReads and writes to this block device are decrypted from and\nencrypted to the underlying C<device> respectively.\n\nIf this block device contains LVM volume groups, then\ncalling C<vgscan> followed by C<vg_activate_all>\nwill make them visible.\n\nThis command has one or more key or passphrase parameters.\nGuestfish will prompt for these separately.",
  .run = run_luks_open
};

struct command_entry luks_open_ro_cmd_entry = {
  .name = "luks-open-ro",
  .shortdesc = "open a LUKS-encrypted block device read-only",
  .podbody = "=head1 SYNOPSIS\n\n luks-open-ro device mapname\n\n=head1 DESCRIPTION\n\nThis is the same as C<luks_open> except that a read-only\nmapping is created.\n\nThis command has one or more key or passphrase parameters.\nGuestfish will prompt for these separately.",
  .run = run_luks_open_ro
};

struct command_entry luks_close_cmd_entry = {
  .name = "luks-close",
  .shortdesc = "close a LUKS device",
  .podbody = "=head1 SYNOPSIS\n\n luks-close device\n\n=head1 DESCRIPTION\n\nThis closes a LUKS device that was created earlier by\nC<luks_open> or C<luks_open_ro>.  The\nC<device> parameter must be the name of the LUKS mapping\ndevice (ie. C</dev/mapper/mapname>) and I<not> the name\nof the underlying block device.",
  .run = run_luks_close
};

struct command_entry luks_format_cmd_entry = {
  .name = "luks-format",
  .shortdesc = "format a block device as a LUKS encrypted device",
  .podbody = "=head1 SYNOPSIS\n\n luks-format device keyslot\n\n=head1 DESCRIPTION\n\nThis command erases existing data on C<device> and formats\nthe device as a LUKS encrypted device.  C<key> is the\ninitial key, which is added to key slot C<slot>.  (LUKS\nsupports 8 key slots, numbered 0-7).\n\nThis command has one or more key or passphrase parameters.\nGuestfish will prompt for these separately.\n\nB<This command is dangerous.  Without careful use you\ncan easily destroy all your data>.",
  .run = run_luks_format
};

struct command_entry luks_format_cipher_cmd_entry = {
  .name = "luks-format-cipher",
  .shortdesc = "format a block device as a LUKS encrypted device",
  .podbody = "=head1 SYNOPSIS\n\n luks-format-cipher device keyslot cipher\n\n=head1 DESCRIPTION\n\nThis command is the same as C<luks_format> but\nit also allows you to set the C<cipher> used.\n\nThis command has one or more key or passphrase parameters.\nGuestfish will prompt for these separately.\n\nB<This command is dangerous.  Without careful use you\ncan easily destroy all your data>.",
  .run = run_luks_format_cipher
};

struct command_entry luks_add_key_cmd_entry = {
  .name = "luks-add-key",
  .shortdesc = "add a key on a LUKS encrypted device",
  .podbody = "=head1 SYNOPSIS\n\n luks-add-key device keyslot\n\n=head1 DESCRIPTION\n\nThis command adds a new key on LUKS device C<device>.\nC<key> is any existing key, and is used to access the device.\nC<newkey> is the new key to add.  C<keyslot> is the key slot\nthat will be replaced.\n\nNote that if C<keyslot> already contains a key, then this\ncommand will fail.  You have to use C<luks_kill_slot>\nfirst to remove that key.\n\nThis command has one or more key or passphrase parameters.\nGuestfish will prompt for these separately.",
  .run = run_luks_add_key
};

struct command_entry luks_kill_slot_cmd_entry = {
  .name = "luks-kill-slot",
  .shortdesc = "remove a key from a LUKS encrypted device",
  .podbody = "=head1 SYNOPSIS\n\n luks-kill-slot device keyslot\n\n=head1 DESCRIPTION\n\nThis command deletes the key in key slot C<keyslot> from the\nencrypted LUKS device C<device>.  C<key> must be one of the\nI<other> keys.\n\nThis command has one or more key or passphrase parameters.\nGuestfish will prompt for these separately.",
  .run = run_luks_kill_slot
};

struct command_entry is_lv_cmd_entry = {
  .name = "is-lv",
  .shortdesc = "test if device is a logical volume",
  .podbody = "=head1 SYNOPSIS\n\n is-lv device\n\n=head1 DESCRIPTION\n\nThis command tests whether C<device> is a logical volume, and\nreturns true iff this is the case.",
  .run = run_is_lv
};

struct command_entry findfs_uuid_cmd_entry = {
  .name = "findfs-uuid",
  .shortdesc = "find a filesystem by UUID",
  .podbody = "=head1 SYNOPSIS\n\n findfs-uuid uuid\n\n=head1 DESCRIPTION\n\nThis command searches the filesystems and returns the one\nwhich has the given UUID.  An error is returned if no such\nfilesystem can be found.\n\nTo find the UUID of a filesystem, use C<vfs_uuid>.",
  .run = run_findfs_uuid
};

struct command_entry findfs_label_cmd_entry = {
  .name = "findfs-label",
  .shortdesc = "find a filesystem by label",
  .podbody = "=head1 SYNOPSIS\n\n findfs-label label\n\n=head1 DESCRIPTION\n\nThis command searches the filesystems and returns the one\nwhich has the given label.  An error is returned if no such\nfilesystem can be found.\n\nTo find the label of a filesystem, use C<vfs_label>.",
  .run = run_findfs_label
};

struct command_entry is_chardev_cmd_entry = {
  .name = "is-chardev",
  .shortdesc = "test if character device",
  .podbody = "=head1 SYNOPSIS\n\n is-chardev path\n\n=head1 DESCRIPTION\n\nThis returns C<true> if and only if there is a character device\nwith the given C<path> name.\n\nSee also C<stat>.",
  .run = run_is_chardev
};

struct command_entry is_blockdev_cmd_entry = {
  .name = "is-blockdev",
  .shortdesc = "test if block device",
  .podbody = "=head1 SYNOPSIS\n\n is-blockdev path\n\n=head1 DESCRIPTION\n\nThis returns C<true> if and only if there is a block device\nwith the given C<path> name.\n\nSee also C<stat>.",
  .run = run_is_blockdev
};

struct command_entry is_fifo_cmd_entry = {
  .name = "is-fifo",
  .shortdesc = "test if FIFO (named pipe)",
  .podbody = "=head1 SYNOPSIS\n\n is-fifo path\n\n=head1 DESCRIPTION\n\nThis returns C<true> if and only if there is a FIFO (named pipe)\nwith the given C<path> name.\n\nSee also C<stat>.",
  .run = run_is_fifo
};

struct command_entry is_symlink_cmd_entry = {
  .name = "is-symlink",
  .shortdesc = "test if symbolic link",
  .podbody = "=head1 SYNOPSIS\n\n is-symlink path\n\n=head1 DESCRIPTION\n\nThis returns C<true> if and only if there is a symbolic link\nwith the given C<path> name.\n\nSee also C<stat>.",
  .run = run_is_symlink
};

struct command_entry is_socket_cmd_entry = {
  .name = "is-socket",
  .shortdesc = "test if socket",
  .podbody = "=head1 SYNOPSIS\n\n is-socket path\n\n=head1 DESCRIPTION\n\nThis returns C<true> if and only if there is a Unix domain socket\nwith the given C<path> name.\n\nSee also C<stat>.",
  .run = run_is_socket
};

struct command_entry part_to_dev_cmd_entry = {
  .name = "part-to-dev",
  .shortdesc = "convert partition name to device name",
  .podbody = "=head1 SYNOPSIS\n\n part-to-dev partition\n\n=head1 DESCRIPTION\n\nThis function takes a partition name (eg. \"/dev/sdb1\") and\nremoves the partition number, returning the device name\n(eg. \"/dev/sdb\").\n\nThe named partition must exist, for example as a string returned\nfrom C<list_partitions>.",
  .run = run_part_to_dev
};

struct command_entry upload_offset_cmd_entry = {
  .name = "upload-offset",
  .shortdesc = "upload a file from the local machine with offset",
  .podbody = "=head1 SYNOPSIS\n\n upload-offset filename remotefilename offset\n\n=head1 DESCRIPTION\n\nUpload local file C<filename> to C<remotefilename> on the\nfilesystem.\n\nC<remotefilename> is overwritten starting at the byte C<offset>\nspecified.  The intention is to overwrite parts of existing\nfiles or devices, although if a non-existant file is specified\nthen it is created with a \"hole\" before C<offset>.  The\nsize of the data written is implicit in the size of the\nsource C<filename>.\n\nNote that there is no limit on the amount of data that\ncan be uploaded with this call, unlike with C<pwrite>,\nand this call always writes the full amount unless an\nerror occurs.\n\nSee also C<upload>, C<pwrite>.",
  .run = run_upload_offset
};

struct command_entry download_offset_cmd_entry = {
  .name = "download-offset",
  .shortdesc = "download a file to the local machine with offset and size",
  .podbody = "=head1 SYNOPSIS\n\n download-offset remotefilename filename offset size\n\n=head1 DESCRIPTION\n\nDownload file C<remotefilename> and save it as C<filename>\non the local machine.\n\nC<remotefilename> is read for C<size> bytes starting at C<offset>\n(this region must be within the file or device).\n\nNote that there is no limit on the amount of data that\ncan be downloaded with this call, unlike with C<pread>,\nand this call always reads the full amount unless an\nerror occurs.\n\nSee also C<download>, C<pread>.",
  .run = run_download_offset
};

struct command_entry pwrite_device_cmd_entry = {
  .name = "pwrite-device",
  .shortdesc = "write to part of a device",
  .podbody = "=head1 SYNOPSIS\n\n pwrite-device device content offset\n\n=head1 DESCRIPTION\n\nThis command writes to part of a device.  It writes the data\nbuffer C<content> to C<device> starting at offset C<offset>.\n\nThis command implements the L<pwrite(2)> system call, and like\nthat system call it may not write the full data requested\n(although short writes to disk devices and partitions are\nprobably impossible with standard Linux kernels).\n\nSee also C<pwrite>.\n\nBecause of the message protocol, there is a transfer limit\nof somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.",
  .run = run_pwrite_device
};

struct command_entry pread_device_cmd_entry = {
  .name = "pread-device",
  .shortdesc = "read part of a device",
  .podbody = "=head1 SYNOPSIS\n\n pread-device device count offset\n\n=head1 DESCRIPTION\n\nThis command lets you read part of a file.  It reads C<count>\nbytes of C<device>, starting at C<offset>.\n\nThis may read fewer bytes than requested.  For further details\nsee the L<pread(2)> system call.\n\nSee also C<pread>.\n\nBecause of the message protocol, there is a transfer limit\nof somewhere between 2MB and 4MB.  See L<guestfs(3)/PROTOCOL LIMITS>.",
  .run = run_pread_device
};

struct command_entry lvm_canonical_lv_name_cmd_entry = {
  .name = "lvm-canonical-lv-name",
  .shortdesc = "get canonical name of an LV",
  .podbody = "=head1 SYNOPSIS\n\n lvm-canonical-lv-name lvname\n\n=head1 DESCRIPTION\n\nThis converts alternative naming schemes for LVs that you\nmight find to the canonical name.  For example, C</dev/mapper/VG-LV>\nis converted to C</dev/VG/LV>.\n\nThis command returns an error if the C<lvname> parameter does\nnot refer to a logical volume.\n\nSee also C<is_lv>.",
  .run = run_lvm_canonical_lv_name
};

void list_commands (void)
{
  printf ("    %-16s     %s\n", _("Command"), _("Description"));
  list_builtin_commands ();
  printf ("%-20s %s\n", "add-cdrom", _("add a CD-ROM disk image to examine"));
  printf ("%-20s %s\n", "add-drive", _("add an image to examine or modify"));
  printf ("%-20s %s\n", "add-drive-opts", _("add an image to examine or modify"));
  printf ("%-20s %s\n", "add-drive-ro", _("add a drive in snapshot mode (read-only)"));
  printf ("%-20s %s\n", "add-drive-ro-with-if", _("add a drive read-only specifying the QEMU block emulation to use"));
  printf ("%-20s %s\n", "add-drive-with-if", _("add a drive specifying the QEMU block emulation to use"));
  printf ("%-20s %s\n", "alloc", _("allocate and add a disk file"));
  printf ("%-20s %s\n", "aug-clear", _("clear Augeas path"));
  printf ("%-20s %s\n", "aug-close", _("close the current Augeas handle"));
  printf ("%-20s %s\n", "aug-defnode", _("define an Augeas node"));
  printf ("%-20s %s\n", "aug-defvar", _("define an Augeas variable"));
  printf ("%-20s %s\n", "aug-get", _("look up the value of an Augeas path"));
  printf ("%-20s %s\n", "aug-init", _("create a new Augeas handle"));
  printf ("%-20s %s\n", "aug-insert", _("insert a sibling Augeas node"));
  printf ("%-20s %s\n", "aug-load", _("load files into the tree"));
  printf ("%-20s %s\n", "aug-ls", _("list Augeas nodes under augpath"));
  printf ("%-20s %s\n", "aug-match", _("return Augeas nodes which match augpath"));
  printf ("%-20s %s\n", "aug-mv", _("move Augeas node"));
  printf ("%-20s %s\n", "aug-rm", _("remove an Augeas path"));
  printf ("%-20s %s\n", "aug-save", _("write all pending Augeas changes to disk"));
  printf ("%-20s %s\n", "aug-set", _("set Augeas path to value"));
  printf ("%-20s %s\n", "available", _("test availability of some parts of the API"));
  printf ("%-20s %s\n", "available-all-groups", _("return a list of all optional groups"));
  printf ("%-20s %s\n", "base64-in", _("upload base64-encoded data to file"));
  printf ("%-20s %s\n", "base64-out", _("download file and encode as base64"));
  printf ("%-20s %s\n", "blockdev-flushbufs", _("flush device buffers"));
  printf ("%-20s %s\n", "blockdev-getbsz", _("get blocksize of block device"));
  printf ("%-20s %s\n", "blockdev-getro", _("is block device set to read-only"));
  printf ("%-20s %s\n", "blockdev-getsize64", _("get total size of device in bytes"));
  printf ("%-20s %s\n", "blockdev-getss", _("get sectorsize of block device"));
  printf ("%-20s %s\n", "blockdev-getsz", _("get total size of device in 512-byte sectors"));
  printf ("%-20s %s\n", "blockdev-rereadpt", _("reread partition table"));
  printf ("%-20s %s\n", "blockdev-setbsz", _("set blocksize of block device"));
  printf ("%-20s %s\n", "blockdev-setro", _("set block device to read-only"));
  printf ("%-20s %s\n", "blockdev-setrw", _("set block device to read-write"));
  printf ("%-20s %s\n", "case-sensitive-path", _("return true path on case-insensitive filesystem"));
  printf ("%-20s %s\n", "cat", _("list the contents of a file"));
  printf ("%-20s %s\n", "checksum", _("compute MD5, SHAx or CRC checksum of file"));
  printf ("%-20s %s\n", "checksum-device", _("compute MD5, SHAx or CRC checksum of the contents of a device"));
  printf ("%-20s %s\n", "checksums-out", _("compute MD5, SHAx or CRC checksum of files in a directory"));
  printf ("%-20s %s\n", "chmod", _("change file mode"));
  printf ("%-20s %s\n", "chown", _("change file owner and group"));
  printf ("%-20s %s\n", "command", _("run a command from the guest filesystem"));
  printf ("%-20s %s\n", "command-lines", _("run a command, returning lines"));
  printf ("%-20s %s\n", "config", _("add qemu parameters"));
  printf ("%-20s %s\n", "copy-in", _("copy local files or directories into an image"));
  printf ("%-20s %s\n", "copy-out", _("copy remote files or directories out of an image"));
  printf ("%-20s %s\n", "copy-size", _("copy size bytes from source to destination using dd"));
  printf ("%-20s %s\n", "cp", _("copy a file"));
  printf ("%-20s %s\n", "cp-a", _("copy a file or directory recursively"));
  printf ("%-20s %s\n", "dd", _("copy from source to destination using dd"));
  printf ("%-20s %s\n", "debug", _("debugging and internals"));
  printf ("%-20s %s\n", "debug-upload", _("upload a file to the appliance (internal use only)"));
  printf ("%-20s %s\n", "df", _("report file system disk space usage"));
  printf ("%-20s %s\n", "df-h", _("report file system disk space usage (human readable)"));
  printf ("%-20s %s\n", "dmesg", _("return kernel messages"));
  printf ("%-20s %s\n", "download", _("download a file to the local machine"));
  printf ("%-20s %s\n", "download-offset", _("download a file to the local machine with offset and size"));
  printf ("%-20s %s\n", "drop-caches", _("drop kernel page cache, dentries and inodes"));
  printf ("%-20s %s\n", "du", _("estimate file space usage"));
  printf ("%-20s %s\n", "e2fsck-f", _("check an ext2/ext3 filesystem"));
  printf ("%-20s %s\n", "echo", _("display a line of text"));
  printf ("%-20s %s\n", "echo-daemon", _("echo arguments back to the client"));
  printf ("%-20s %s\n", "edit", _("edit a file"));
  printf ("%-20s %s\n", "egrep", _("return lines matching a pattern"));
  printf ("%-20s %s\n", "egrepi", _("return lines matching a pattern"));
  printf ("%-20s %s\n", "equal", _("test if two files have equal contents"));
  printf ("%-20s %s\n", "exists", _("test if file or directory exists"));
  printf ("%-20s %s\n", "fallocate", _("preallocate a file in the guest filesystem"));
  printf ("%-20s %s\n", "fallocate64", _("preallocate a file in the guest filesystem"));
  printf ("%-20s %s\n", "fgrep", _("return lines matching a pattern"));
  printf ("%-20s %s\n", "fgrepi", _("return lines matching a pattern"));
  printf ("%-20s %s\n", "file", _("determine file type"));
  printf ("%-20s %s\n", "file-architecture", _("detect the architecture of a binary file"));
  printf ("%-20s %s\n", "filesize", _("return the size of the file in bytes"));
  printf ("%-20s %s\n", "fill", _("fill a file with octets"));
  printf ("%-20s %s\n", "fill-pattern", _("fill a file with a repeating pattern of bytes"));
  printf ("%-20s %s\n", "find", _("find all files and directories"));
  printf ("%-20s %s\n", "find0", _("find all files and directories, returning NUL-separated list"));
  printf ("%-20s %s\n", "findfs-label", _("find a filesystem by label"));
  printf ("%-20s %s\n", "findfs-uuid", _("find a filesystem by UUID"));
  printf ("%-20s %s\n", "fsck", _("run the filesystem checker"));
  printf ("%-20s %s\n", "get-append", _("get the additional kernel options"));
  printf ("%-20s %s\n", "get-autosync", _("get autosync mode"));
  printf ("%-20s %s\n", "get-direct", _("get direct appliance mode flag"));
  printf ("%-20s %s\n", "get-e2label", _("get the ext2/3/4 filesystem label"));
  printf ("%-20s %s\n", "get-e2uuid", _("get the ext2/3/4 filesystem UUID"));
  printf ("%-20s %s\n", "get-memsize", _("get memory allocated to the qemu subprocess"));
  printf ("%-20s %s\n", "get-network", _("get enable network flag"));
  printf ("%-20s %s\n", "get-path", _("get the search path"));
  printf ("%-20s %s\n", "get-pid", _("get PID of qemu subprocess"));
  printf ("%-20s %s\n", "get-qemu", _("get the qemu binary"));
  printf ("%-20s %s\n", "get-recovery-proc", _("get recovery process enabled flag"));
  printf ("%-20s %s\n", "get-selinux", _("get SELinux enabled flag"));
  printf ("%-20s %s\n", "get-state", _("get the current state"));
  printf ("%-20s %s\n", "get-trace", _("get command trace enabled flag"));
  printf ("%-20s %s\n", "get-umask", _("get the current umask"));
  printf ("%-20s %s\n", "get-verbose", _("get verbose mode"));
  printf ("%-20s %s\n", "getcon", _("get SELinux security context"));
  printf ("%-20s %s\n", "getxattrs", _("list extended attributes of a file or directory"));
  printf ("%-20s %s\n", "glob", _("expand wildcards in command"));
  printf ("%-20s %s\n", "glob-expand", _("expand a wildcard path"));
  printf ("%-20s %s\n", "grep", _("return lines matching a pattern"));
  printf ("%-20s %s\n", "grepi", _("return lines matching a pattern"));
  printf ("%-20s %s\n", "grub-install", _("install GRUB"));
  printf ("%-20s %s\n", "head", _("return first 10 lines of a file"));
  printf ("%-20s %s\n", "head-n", _("return first N lines of a file"));
  printf ("%-20s %s\n", "hexdump", _("dump a file in hexadecimal"));
  printf ("%-20s %s\n", "hexedit", _("edit with a hex editor"));
  printf ("%-20s %s\n", "initrd-cat", _("list the contents of a single file in an initrd"));
  printf ("%-20s %s\n", "initrd-list", _("list files in an initrd"));
  printf ("%-20s %s\n", "inotify-add-watch", _("add an inotify watch"));
  printf ("%-20s %s\n", "inotify-close", _("close the inotify handle"));
  printf ("%-20s %s\n", "inotify-files", _("return list of watched files that had events"));
  printf ("%-20s %s\n", "inotify-init", _("create an inotify handle"));
  printf ("%-20s %s\n", "inotify-read", _("return list of inotify events"));
  printf ("%-20s %s\n", "inotify-rm-watch", _("remove an inotify watch"));
  printf ("%-20s %s\n", "inspect-get-arch", _("get architecture of inspected operating system"));
  printf ("%-20s %s\n", "inspect-get-distro", _("get distro of inspected operating system"));
  printf ("%-20s %s\n", "inspect-get-filesystems", _("get filesystems associated with inspected operating system"));
  printf ("%-20s %s\n", "inspect-get-major-version", _("get major version of inspected operating system"));
  printf ("%-20s %s\n", "inspect-get-minor-version", _("get minor version of inspected operating system"));
  printf ("%-20s %s\n", "inspect-get-mountpoints", _("get mountpoints of inspected operating system"));
  printf ("%-20s %s\n", "inspect-get-product-name", _("get product name of inspected operating system"));
  printf ("%-20s %s\n", "inspect-get-type", _("get type of inspected operating system"));
  printf ("%-20s %s\n", "inspect-get-windows-systemroot", _("get Windows systemroot of inspected operating system"));
  printf ("%-20s %s\n", "inspect-os", _("inspect disk and return list of operating systems found"));
  printf ("%-20s %s\n", "is-blockdev", _("test if block device"));
  printf ("%-20s %s\n", "is-busy", _("is busy processing a command"));
  printf ("%-20s %s\n", "is-chardev", _("test if character device"));
  printf ("%-20s %s\n", "is-config", _("is in configuration state"));
  printf ("%-20s %s\n", "is-dir", _("test if a directory"));
  printf ("%-20s %s\n", "is-fifo", _("test if FIFO (named pipe)"));
  printf ("%-20s %s\n", "is-file", _("test if a regular file"));
  printf ("%-20s %s\n", "is-launching", _("is launching subprocess"));
  printf ("%-20s %s\n", "is-lv", _("test if device is a logical volume"));
  printf ("%-20s %s\n", "is-ready", _("is ready to accept commands"));
  printf ("%-20s %s\n", "is-socket", _("test if socket"));
  printf ("%-20s %s\n", "is-symlink", _("test if symbolic link"));
  printf ("%-20s %s\n", "kill-subprocess", _("kill the qemu subprocess"));
  printf ("%-20s %s\n", "launch", _("launch the qemu subprocess"));
  printf ("%-20s %s\n", "lcd", _("change working directory"));
  printf ("%-20s %s\n", "lchown", _("change file owner and group"));
  printf ("%-20s %s\n", "lgetxattrs", _("list extended attributes of a file or directory"));
  printf ("%-20s %s\n", "list-devices", _("list the block devices"));
  printf ("%-20s %s\n", "list-filesystems", _("list filesystems"));
  printf ("%-20s %s\n", "list-partitions", _("list the partitions"));
  printf ("%-20s %s\n", "ll", _("list the files in a directory (long format)"));
  printf ("%-20s %s\n", "ln", _("create a hard link"));
  printf ("%-20s %s\n", "ln-f", _("create a hard link"));
  printf ("%-20s %s\n", "ln-s", _("create a symbolic link"));
  printf ("%-20s %s\n", "ln-sf", _("create a symbolic link"));
  printf ("%-20s %s\n", "lremovexattr", _("remove extended attribute of a file or directory"));
  printf ("%-20s %s\n", "ls", _("list the files in a directory"));
  printf ("%-20s %s\n", "lsetxattr", _("set extended attribute of a file or directory"));
  printf ("%-20s %s\n", "lstat", _("get file information for a symbolic link"));
  printf ("%-20s %s\n", "lstatlist", _("lstat on multiple files"));
  printf ("%-20s %s\n", "luks-add-key", _("add a key on a LUKS encrypted device"));
  printf ("%-20s %s\n", "luks-close", _("close a LUKS device"));
  printf ("%-20s %s\n", "luks-format", _("format a block device as a LUKS encrypted device"));
  printf ("%-20s %s\n", "luks-format-cipher", _("format a block device as a LUKS encrypted device"));
  printf ("%-20s %s\n", "luks-kill-slot", _("remove a key from a LUKS encrypted device"));
  printf ("%-20s %s\n", "luks-open", _("open a LUKS-encrypted block device"));
  printf ("%-20s %s\n", "luks-open-ro", _("open a LUKS-encrypted block device read-only"));
  printf ("%-20s %s\n", "lvcreate", _("create an LVM logical volume"));
  printf ("%-20s %s\n", "lvm-canonical-lv-name", _("get canonical name of an LV"));
  printf ("%-20s %s\n", "lvm-clear-filter", _("clear LVM device filter"));
  printf ("%-20s %s\n", "lvm-remove-all", _("remove all LVM LVs, VGs and PVs"));
  printf ("%-20s %s\n", "lvm-set-filter", _("set LVM device filter"));
  printf ("%-20s %s\n", "lvremove", _("remove an LVM logical volume"));
  printf ("%-20s %s\n", "lvrename", _("rename an LVM logical volume"));
  printf ("%-20s %s\n", "lvresize", _("resize an LVM logical volume"));
  printf ("%-20s %s\n", "lvresize-free", _("expand an LV to fill free space"));
  printf ("%-20s %s\n", "lvs", _("list the LVM logical volumes (LVs)"));
  printf ("%-20s %s\n", "lvs-full", _("list the LVM logical volumes (LVs)"));
  printf ("%-20s %s\n", "lvuuid", _("get the UUID of a logical volume"));
  printf ("%-20s %s\n", "lxattrlist", _("lgetxattr on multiple files"));
  printf ("%-20s %s\n", "man", _("open the manual"));
  printf ("%-20s %s\n", "mkdir", _("create a directory"));
  printf ("%-20s %s\n", "mkdir-mode", _("create a directory with a particular mode"));
  printf ("%-20s %s\n", "mkdir-p", _("create a directory and parents"));
  printf ("%-20s %s\n", "mkdtemp", _("create a temporary directory"));
  printf ("%-20s %s\n", "mke2fs-J", _("make ext2/3/4 filesystem with external journal"));
  printf ("%-20s %s\n", "mke2fs-JL", _("make ext2/3/4 filesystem with external journal"));
  printf ("%-20s %s\n", "mke2fs-JU", _("make ext2/3/4 filesystem with external journal"));
  printf ("%-20s %s\n", "mke2journal", _("make ext2/3/4 external journal"));
  printf ("%-20s %s\n", "mke2journal-L", _("make ext2/3/4 external journal with label"));
  printf ("%-20s %s\n", "mke2journal-U", _("make ext2/3/4 external journal with UUID"));
  printf ("%-20s %s\n", "mkfifo", _("make FIFO (named pipe)"));
  printf ("%-20s %s\n", "mkfs", _("make a filesystem"));
  printf ("%-20s %s\n", "mkfs-b", _("make a filesystem with block size"));
  printf ("%-20s %s\n", "mkmountpoint", _("create a mountpoint"));
  printf ("%-20s %s\n", "mknod", _("make block, character or FIFO devices"));
  printf ("%-20s %s\n", "mknod-b", _("make block device node"));
  printf ("%-20s %s\n", "mknod-c", _("make char device node"));
  printf ("%-20s %s\n", "mkswap", _("create a swap partition"));
  printf ("%-20s %s\n", "mkswap-L", _("create a swap partition with a label"));
  printf ("%-20s %s\n", "mkswap-U", _("create a swap partition with an explicit UUID"));
  printf ("%-20s %s\n", "mkswap-file", _("create a swap file"));
  printf ("%-20s %s\n", "modprobe", _("load a kernel module"));
  printf ("%-20s %s\n", "more", _("view a file"));
  printf ("%-20s %s\n", "mount", _("mount a guest disk at a position in the filesystem"));
  printf ("%-20s %s\n", "mount-loop", _("mount a file using the loop device"));
  printf ("%-20s %s\n", "mount-options", _("mount a guest disk with mount options"));
  printf ("%-20s %s\n", "mount-ro", _("mount a guest disk, read-only"));
  printf ("%-20s %s\n", "mount-vfs", _("mount a guest disk with mount options and vfstype"));
  printf ("%-20s %s\n", "mountpoints", _("show mountpoints"));
  printf ("%-20s %s\n", "mounts", _("show mounted filesystems"));
  printf ("%-20s %s\n", "mv", _("move a file"));
  printf ("%-20s %s\n", "ntfs-3g-probe", _("probe NTFS volume"));
  printf ("%-20s %s\n", "ntfsresize", _("resize an NTFS filesystem"));
  printf ("%-20s %s\n", "ntfsresize-size", _("resize an NTFS filesystem (with size)"));
  printf ("%-20s %s\n", "part-add", _("add a partition to the device"));
  printf ("%-20s %s\n", "part-del", _("delete a partition"));
  printf ("%-20s %s\n", "part-disk", _("partition whole disk with a single primary partition"));
  printf ("%-20s %s\n", "part-get-bootable", _("return true if a partition is bootable"));
  printf ("%-20s %s\n", "part-get-mbr-id", _("get the MBR type byte (ID byte) from a partition"));
  printf ("%-20s %s\n", "part-get-parttype", _("get the partition table type"));
  printf ("%-20s %s\n", "part-init", _("create an empty partition table"));
  printf ("%-20s %s\n", "part-list", _("list partitions on a device"));
  printf ("%-20s %s\n", "part-set-bootable", _("make a partition bootable"));
  printf ("%-20s %s\n", "part-set-mbr-id", _("set the MBR type byte (ID byte) of a partition"));
  printf ("%-20s %s\n", "part-set-name", _("set partition name"));
  printf ("%-20s %s\n", "part-to-dev", _("convert partition name to device name"));
  printf ("%-20s %s\n", "ping-daemon", _("ping the guest daemon"));
  printf ("%-20s %s\n", "pread", _("read part of a file"));
  printf ("%-20s %s\n", "pread-device", _("read part of a device"));
  printf ("%-20s %s\n", "pvcreate", _("create an LVM physical volume"));
  printf ("%-20s %s\n", "pvremove", _("remove an LVM physical volume"));
  printf ("%-20s %s\n", "pvresize", _("resize an LVM physical volume"));
  printf ("%-20s %s\n", "pvresize-size", _("resize an LVM physical volume (with size)"));
  printf ("%-20s %s\n", "pvs", _("list the LVM physical volumes (PVs)"));
  printf ("%-20s %s\n", "pvs-full", _("list the LVM physical volumes (PVs)"));
  printf ("%-20s %s\n", "pvuuid", _("get the UUID of a physical volume"));
  printf ("%-20s %s\n", "pwrite", _("write to part of a file"));
  printf ("%-20s %s\n", "pwrite-device", _("write to part of a device"));
  printf ("%-20s %s\n", "read-file", _("read a file"));
  printf ("%-20s %s\n", "read-lines", _("read file as lines"));
  printf ("%-20s %s\n", "readdir", _("read directories entries"));
  printf ("%-20s %s\n", "readlink", _("read the target of a symbolic link"));
  printf ("%-20s %s\n", "readlinklist", _("readlink on multiple files"));
  printf ("%-20s %s\n", "realpath", _("canonicalized absolute pathname"));
  printf ("%-20s %s\n", "removexattr", _("remove extended attribute of a file or directory"));
  printf ("%-20s %s\n", "reopen", _("close and reopen libguestfs handle"));
  printf ("%-20s %s\n", "resize2fs", _("resize an ext2, ext3 or ext4 filesystem"));
  printf ("%-20s %s\n", "resize2fs-size", _("resize an ext2, ext3 or ext4 filesystem (with size)"));
  printf ("%-20s %s\n", "rm", _("remove a file"));
  printf ("%-20s %s\n", "rm-rf", _("remove a file or directory recursively"));
  printf ("%-20s %s\n", "rmdir", _("remove a directory"));
  printf ("%-20s %s\n", "rmmountpoint", _("remove a mountpoint"));
  printf ("%-20s %s\n", "scrub-device", _("scrub (securely wipe) a device"));
  printf ("%-20s %s\n", "scrub-file", _("scrub (securely wipe) a file"));
  printf ("%-20s %s\n", "scrub-freespace", _("scrub (securely wipe) free space"));
  printf ("%-20s %s\n", "set-append", _("add options to kernel command line"));
  printf ("%-20s %s\n", "set-autosync", _("set autosync mode"));
  printf ("%-20s %s\n", "set-direct", _("enable or disable direct appliance mode"));
  printf ("%-20s %s\n", "set-e2label", _("set the ext2/3/4 filesystem label"));
  printf ("%-20s %s\n", "set-e2uuid", _("set the ext2/3/4 filesystem UUID"));
  printf ("%-20s %s\n", "set-memsize", _("set memory allocated to the qemu subprocess"));
  printf ("%-20s %s\n", "set-network", _("set enable network flag"));
  printf ("%-20s %s\n", "set-path", _("set the search path"));
  printf ("%-20s %s\n", "set-qemu", _("set the qemu binary"));
  printf ("%-20s %s\n", "set-recovery-proc", _("enable or disable the recovery process"));
  printf ("%-20s %s\n", "set-selinux", _("set SELinux enabled or disabled at appliance boot"));
  printf ("%-20s %s\n", "set-trace", _("enable or disable command traces"));
  printf ("%-20s %s\n", "set-verbose", _("set verbose mode"));
  printf ("%-20s %s\n", "setcon", _("set SELinux security context"));
  printf ("%-20s %s\n", "setxattr", _("set extended attribute of a file or directory"));
  printf ("%-20s %s\n", "sfdisk", _("create partitions on a block device"));
  printf ("%-20s %s\n", "sfdiskM", _("create partitions on a block device"));
  printf ("%-20s %s\n", "sfdisk-N", _("modify a single partition on a block device"));
  printf ("%-20s %s\n", "sfdisk-disk-geometry", _("display the disk geometry from the partition table"));
  printf ("%-20s %s\n", "sfdisk-kernel-geometry", _("display the kernel geometry"));
  printf ("%-20s %s\n", "sfdisk-l", _("display the partition table"));
  printf ("%-20s %s\n", "sh", _("run a command via the shell"));
  printf ("%-20s %s\n", "sh-lines", _("run a command via the shell returning lines"));
  printf ("%-20s %s\n", "sleep", _("sleep for some seconds"));
  printf ("%-20s %s\n", "sparse", _("create a sparse disk image and add"));
  printf ("%-20s %s\n", "stat", _("get file information"));
  printf ("%-20s %s\n", "statvfs", _("get file system statistics"));
  printf ("%-20s %s\n", "strings", _("print the printable strings in a file"));
  printf ("%-20s %s\n", "strings-e", _("print the printable strings in a file"));
  printf ("%-20s %s\n", "supported", _("list supported groups of commands"));
  printf ("%-20s %s\n", "swapoff-device", _("disable swap on device"));
  printf ("%-20s %s\n", "swapoff-file", _("disable swap on file"));
  printf ("%-20s %s\n", "swapoff-label", _("disable swap on labeled swap partition"));
  printf ("%-20s %s\n", "swapoff-uuid", _("disable swap on swap partition by UUID"));
  printf ("%-20s %s\n", "swapon-device", _("enable swap on device"));
  printf ("%-20s %s\n", "swapon-file", _("enable swap on file"));
  printf ("%-20s %s\n", "swapon-label", _("enable swap on labeled swap partition"));
  printf ("%-20s %s\n", "swapon-uuid", _("enable swap on swap partition by UUID"));
  printf ("%-20s %s\n", "sync", _("sync disks, writes are flushed through to the disk image"));
  printf ("%-20s %s\n", "tail", _("return last 10 lines of a file"));
  printf ("%-20s %s\n", "tail-n", _("return last N lines of a file"));
  printf ("%-20s %s\n", "tar-in", _("unpack tarfile to directory"));
  printf ("%-20s %s\n", "tar-out", _("pack directory into tarfile"));
  printf ("%-20s %s\n", "tgz-in", _("unpack compressed tarball to directory"));
  printf ("%-20s %s\n", "tgz-out", _("pack directory into compressed tarball"));
  printf ("%-20s %s\n", "time", _("print elapsed time taken to run a command"));
  printf ("%-20s %s\n", "touch", _("update file timestamps or create a new file"));
  printf ("%-20s %s\n", "truncate", _("truncate a file to zero size"));
  printf ("%-20s %s\n", "truncate-size", _("truncate a file to a particular size"));
  printf ("%-20s %s\n", "tune2fs-l", _("get ext2/ext3/ext4 superblock details"));
  printf ("%-20s %s\n", "txz-in", _("unpack compressed tarball to directory"));
  printf ("%-20s %s\n", "txz-out", _("pack directory into compressed tarball"));
  printf ("%-20s %s\n", "umask", _("set file mode creation mask (umask)"));
  printf ("%-20s %s\n", "umount", _("unmount a filesystem"));
  printf ("%-20s %s\n", "umount-all", _("unmount all filesystems"));
  printf ("%-20s %s\n", "upload", _("upload a file from the local machine"));
  printf ("%-20s %s\n", "upload-offset", _("upload a file from the local machine with offset"));
  printf ("%-20s %s\n", "utimens", _("set timestamp of a file with nanosecond precision"));
  printf ("%-20s %s\n", "version", _("get the library version number"));
  printf ("%-20s %s\n", "vfs-label", _("get the filesystem label"));
  printf ("%-20s %s\n", "vfs-type", _("get the Linux VFS type corresponding to a mounted device"));
  printf ("%-20s %s\n", "vfs-uuid", _("get the filesystem UUID"));
  printf ("%-20s %s\n", "vg-activate", _("activate or deactivate some volume groups"));
  printf ("%-20s %s\n", "vg-activate-all", _("activate or deactivate all volume groups"));
  printf ("%-20s %s\n", "vgcreate", _("create an LVM volume group"));
  printf ("%-20s %s\n", "vglvuuids", _("get the LV UUIDs of all LVs in the volume group"));
  printf ("%-20s %s\n", "vgpvuuids", _("get the PV UUIDs containing the volume group"));
  printf ("%-20s %s\n", "vgremove", _("remove an LVM volume group"));
  printf ("%-20s %s\n", "vgrename", _("rename an LVM volume group"));
  printf ("%-20s %s\n", "vgs", _("list the LVM volume groups (VGs)"));
  printf ("%-20s %s\n", "vgs-full", _("list the LVM volume groups (VGs)"));
  printf ("%-20s %s\n", "vgscan", _("rescan for LVM physical volumes, volume groups and logical volumes"));
  printf ("%-20s %s\n", "vguuid", _("get the UUID of a volume group"));
  printf ("%-20s %s\n", "wc-c", _("count characters in a file"));
  printf ("%-20s %s\n", "wc-l", _("count lines in a file"));
  printf ("%-20s %s\n", "wc-w", _("count words in a file"));
  printf ("%-20s %s\n", "write", _("create a new file"));
  printf ("%-20s %s\n", "write-file", _("create a file"));
  printf ("%-20s %s\n", "zegrep", _("return lines matching a pattern"));
  printf ("%-20s %s\n", "zegrepi", _("return lines matching a pattern"));
  printf ("%-20s %s\n", "zero", _("write zeroes to the device"));
  printf ("%-20s %s\n", "zero-device", _("write zeroes to an entire device"));
  printf ("%-20s %s\n", "zerofree", _("zero unused inodes and disk blocks on ext2/3 filesystem"));
  printf ("%-20s %s\n", "zfgrep", _("return lines matching a pattern"));
  printf ("%-20s %s\n", "zfgrepi", _("return lines matching a pattern"));
  printf ("%-20s %s\n", "zfile", _("determine file type inside a compressed file"));
  printf ("%-20s %s\n", "zgrep", _("return lines matching a pattern"));
  printf ("%-20s %s\n", "zgrepi", _("return lines matching a pattern"));
  printf ("    %s\n",          _("Use -h <cmd> / help <cmd> to show detailed help for a command."));
}

int display_command (const char *cmd)
{
  const struct command_table *ct;

  ct = lookup_fish_command (cmd, strlen (cmd));
  if (ct) {
    pod2text (ct->entry->name, ct->entry->shortdesc, ct->entry->podbody);
    return 0;
  }
  else
    return display_builtin_command (cmd);
}

static void print_int_bool_indent (struct guestfs_int_bool *int_bool, const char *indent)
{
  printf ("%si: %" PRIi32 "\n", indent, int_bool->i);
  printf ("%sb: %" PRIi32 "\n", indent, int_bool->b);
}

static void print_lvm_pv_indent (struct guestfs_lvm_pv *lvm_pv, const char *indent)
{
  unsigned int i;

  printf ("%spv_name: %s\n", indent, lvm_pv->pv_name);
  printf ("%spv_uuid: ", indent);
  for (i = 0; i < 32; ++i)
    printf ("%c", lvm_pv->pv_uuid[i]);
  printf ("\n");
  printf ("%spv_fmt: %s\n", indent, lvm_pv->pv_fmt);
  printf ("%spv_size: %" PRIu64 "\n", indent, lvm_pv->pv_size);
  printf ("%sdev_size: %" PRIu64 "\n", indent, lvm_pv->dev_size);
  printf ("%spv_free: %" PRIu64 "\n", indent, lvm_pv->pv_free);
  printf ("%spv_used: %" PRIu64 "\n", indent, lvm_pv->pv_used);
  printf ("%spv_attr: %s\n", indent, lvm_pv->pv_attr);
  printf ("%spv_pe_count: %" PRIi64 "\n", indent, lvm_pv->pv_pe_count);
  printf ("%spv_pe_alloc_count: %" PRIi64 "\n", indent, lvm_pv->pv_pe_alloc_count);
  printf ("%spv_tags: %s\n", indent, lvm_pv->pv_tags);
  printf ("%spe_start: %" PRIu64 "\n", indent, lvm_pv->pe_start);
  printf ("%spv_mda_count: %" PRIi64 "\n", indent, lvm_pv->pv_mda_count);
  printf ("%spv_mda_free: %" PRIu64 "\n", indent, lvm_pv->pv_mda_free);
}

static void print_lvm_vg_indent (struct guestfs_lvm_vg *lvm_vg, const char *indent)
{
  unsigned int i;

  printf ("%svg_name: %s\n", indent, lvm_vg->vg_name);
  printf ("%svg_uuid: ", indent);
  for (i = 0; i < 32; ++i)
    printf ("%c", lvm_vg->vg_uuid[i]);
  printf ("\n");
  printf ("%svg_fmt: %s\n", indent, lvm_vg->vg_fmt);
  printf ("%svg_attr: %s\n", indent, lvm_vg->vg_attr);
  printf ("%svg_size: %" PRIu64 "\n", indent, lvm_vg->vg_size);
  printf ("%svg_free: %" PRIu64 "\n", indent, lvm_vg->vg_free);
  printf ("%svg_sysid: %s\n", indent, lvm_vg->vg_sysid);
  printf ("%svg_extent_size: %" PRIu64 "\n", indent, lvm_vg->vg_extent_size);
  printf ("%svg_extent_count: %" PRIi64 "\n", indent, lvm_vg->vg_extent_count);
  printf ("%svg_free_count: %" PRIi64 "\n", indent, lvm_vg->vg_free_count);
  printf ("%smax_lv: %" PRIi64 "\n", indent, lvm_vg->max_lv);
  printf ("%smax_pv: %" PRIi64 "\n", indent, lvm_vg->max_pv);
  printf ("%spv_count: %" PRIi64 "\n", indent, lvm_vg->pv_count);
  printf ("%slv_count: %" PRIi64 "\n", indent, lvm_vg->lv_count);
  printf ("%ssnap_count: %" PRIi64 "\n", indent, lvm_vg->snap_count);
  printf ("%svg_seqno: %" PRIi64 "\n", indent, lvm_vg->vg_seqno);
  printf ("%svg_tags: %s\n", indent, lvm_vg->vg_tags);
  printf ("%svg_mda_count: %" PRIi64 "\n", indent, lvm_vg->vg_mda_count);
  printf ("%svg_mda_free: %" PRIu64 "\n", indent, lvm_vg->vg_mda_free);
}

static void print_lvm_lv_indent (struct guestfs_lvm_lv *lvm_lv, const char *indent)
{
  unsigned int i;

  printf ("%slv_name: %s\n", indent, lvm_lv->lv_name);
  printf ("%slv_uuid: ", indent);
  for (i = 0; i < 32; ++i)
    printf ("%c", lvm_lv->lv_uuid[i]);
  printf ("\n");
  printf ("%slv_attr: %s\n", indent, lvm_lv->lv_attr);
  printf ("%slv_major: %" PRIi64 "\n", indent, lvm_lv->lv_major);
  printf ("%slv_minor: %" PRIi64 "\n", indent, lvm_lv->lv_minor);
  printf ("%slv_kernel_major: %" PRIi64 "\n", indent, lvm_lv->lv_kernel_major);
  printf ("%slv_kernel_minor: %" PRIi64 "\n", indent, lvm_lv->lv_kernel_minor);
  printf ("%slv_size: %" PRIu64 "\n", indent, lvm_lv->lv_size);
  printf ("%sseg_count: %" PRIi64 "\n", indent, lvm_lv->seg_count);
  printf ("%sorigin: %s\n", indent, lvm_lv->origin);
  if (lvm_lv->snap_percent >= 0) printf ("%ssnap_percent: %g %%\n", indent, lvm_lv->snap_percent);
  else printf ("%ssnap_percent: \n", indent);
  if (lvm_lv->copy_percent >= 0) printf ("%scopy_percent: %g %%\n", indent, lvm_lv->copy_percent);
  else printf ("%scopy_percent: \n", indent);
  printf ("%smove_pv: %s\n", indent, lvm_lv->move_pv);
  printf ("%slv_tags: %s\n", indent, lvm_lv->lv_tags);
  printf ("%smirror_log: %s\n", indent, lvm_lv->mirror_log);
  printf ("%smodules: %s\n", indent, lvm_lv->modules);
}

static void print_stat_indent (struct guestfs_stat *stat, const char *indent)
{
  printf ("%sdev: %" PRIi64 "\n", indent, stat->dev);
  printf ("%sino: %" PRIi64 "\n", indent, stat->ino);
  printf ("%smode: %" PRIi64 "\n", indent, stat->mode);
  printf ("%snlink: %" PRIi64 "\n", indent, stat->nlink);
  printf ("%suid: %" PRIi64 "\n", indent, stat->uid);
  printf ("%sgid: %" PRIi64 "\n", indent, stat->gid);
  printf ("%srdev: %" PRIi64 "\n", indent, stat->rdev);
  printf ("%ssize: %" PRIi64 "\n", indent, stat->size);
  printf ("%sblksize: %" PRIi64 "\n", indent, stat->blksize);
  printf ("%sblocks: %" PRIi64 "\n", indent, stat->blocks);
  printf ("%satime: %" PRIi64 "\n", indent, stat->atime);
  printf ("%smtime: %" PRIi64 "\n", indent, stat->mtime);
  printf ("%sctime: %" PRIi64 "\n", indent, stat->ctime);
}

static void print_statvfs_indent (struct guestfs_statvfs *statvfs, const char *indent)
{
  printf ("%sbsize: %" PRIi64 "\n", indent, statvfs->bsize);
  printf ("%sfrsize: %" PRIi64 "\n", indent, statvfs->frsize);
  printf ("%sblocks: %" PRIi64 "\n", indent, statvfs->blocks);
  printf ("%sbfree: %" PRIi64 "\n", indent, statvfs->bfree);
  printf ("%sbavail: %" PRIi64 "\n", indent, statvfs->bavail);
  printf ("%sfiles: %" PRIi64 "\n", indent, statvfs->files);
  printf ("%sffree: %" PRIi64 "\n", indent, statvfs->ffree);
  printf ("%sfavail: %" PRIi64 "\n", indent, statvfs->favail);
  printf ("%sfsid: %" PRIi64 "\n", indent, statvfs->fsid);
  printf ("%sflag: %" PRIi64 "\n", indent, statvfs->flag);
  printf ("%snamemax: %" PRIi64 "\n", indent, statvfs->namemax);
}

static void print_dirent_indent (struct guestfs_dirent *dirent, const char *indent)
{
  printf ("%sino: %" PRIi64 "\n", indent, dirent->ino);
  printf ("%sftyp: %c\n", indent, dirent->ftyp);
  printf ("%sname: %s\n", indent, dirent->name);
}

static void print_version_indent (struct guestfs_version *version, const char *indent)
{
  printf ("%smajor: %" PRIi64 "\n", indent, version->major);
  printf ("%sminor: %" PRIi64 "\n", indent, version->minor);
  printf ("%srelease: %" PRIi64 "\n", indent, version->release);
  printf ("%sextra: %s\n", indent, version->extra);
}

static void print_xattr_indent (struct guestfs_xattr *xattr, const char *indent)
{
  unsigned int i;

  printf ("%sattrname: %s\n", indent, xattr->attrname);
  printf ("%sattrval: ", indent);
  for (i = 0; i < xattr->attrval_len; ++i)
    if (c_isprint (xattr->attrval[i]))
      printf ("%c", xattr->attrval[i]);
    else
      printf ("\\x%02x", xattr->attrval[i]);
  printf ("\n");
}

static void print_inotify_event_indent (struct guestfs_inotify_event *inotify_event, const char *indent)
{
  printf ("%sin_wd: %" PRIi64 "\n", indent, inotify_event->in_wd);
  printf ("%sin_mask: %" PRIu32 "\n", indent, inotify_event->in_mask);
  printf ("%sin_cookie: %" PRIu32 "\n", indent, inotify_event->in_cookie);
  printf ("%sin_name: %s\n", indent, inotify_event->in_name);
}

static void print_partition_indent (struct guestfs_partition *partition, const char *indent)
{
  printf ("%spart_num: %" PRIi32 "\n", indent, partition->part_num);
  printf ("%spart_start: %" PRIu64 "\n", indent, partition->part_start);
  printf ("%spart_end: %" PRIu64 "\n", indent, partition->part_end);
  printf ("%spart_size: %" PRIu64 "\n", indent, partition->part_size);
}

static void print_lvm_vg_list (struct guestfs_lvm_vg_list *lvm_vgs)
{
  unsigned int i;

  for (i = 0; i < lvm_vgs->len; ++i) {
    printf ("[%d] = {\n", i);
    print_lvm_vg_indent (&lvm_vgs->val[i], "  ");
    printf ("}\n");
  }
}

static void print_stat_list (struct guestfs_stat_list *stats)
{
  unsigned int i;

  for (i = 0; i < stats->len; ++i) {
    printf ("[%d] = {\n", i);
    print_stat_indent (&stats->val[i], "  ");
    printf ("}\n");
  }
}

static void print_dirent_list (struct guestfs_dirent_list *dirents)
{
  unsigned int i;

  for (i = 0; i < dirents->len; ++i) {
    printf ("[%d] = {\n", i);
    print_dirent_indent (&dirents->val[i], "  ");
    printf ("}\n");
  }
}

static void print_partition_list (struct guestfs_partition_list *partitions)
{
  unsigned int i;

  for (i = 0; i < partitions->len; ++i) {
    printf ("[%d] = {\n", i);
    print_partition_indent (&partitions->val[i], "  ");
    printf ("}\n");
  }
}

static void print_lvm_lv_list (struct guestfs_lvm_lv_list *lvm_lvs)
{
  unsigned int i;

  for (i = 0; i < lvm_lvs->len; ++i) {
    printf ("[%d] = {\n", i);
    print_lvm_lv_indent (&lvm_lvs->val[i], "  ");
    printf ("}\n");
  }
}

static void print_xattr_list (struct guestfs_xattr_list *xattrs)
{
  unsigned int i;

  for (i = 0; i < xattrs->len; ++i) {
    printf ("[%d] = {\n", i);
    print_xattr_indent (&xattrs->val[i], "  ");
    printf ("}\n");
  }
}

static void print_lvm_pv_list (struct guestfs_lvm_pv_list *lvm_pvs)
{
  unsigned int i;

  for (i = 0; i < lvm_pvs->len; ++i) {
    printf ("[%d] = {\n", i);
    print_lvm_pv_indent (&lvm_pvs->val[i], "  ");
    printf ("}\n");
  }
}

static void print_inotify_event_list (struct guestfs_inotify_event_list *inotify_events)
{
  unsigned int i;

  for (i = 0; i < inotify_events->len; ++i) {
    printf ("[%d] = {\n", i);
    print_inotify_event_indent (&inotify_events->val[i], "  ");
    printf ("}\n");
  }
}

static void print_stat (struct guestfs_stat *stat)
{
  print_stat_indent (stat, "");
}

static void print_statvfs (struct guestfs_statvfs *statvfs)
{
  print_statvfs_indent (statvfs, "");
}

static void print_version (struct guestfs_version *version)
{
  print_version_indent (version, "");
}

static void print_int_bool (struct guestfs_int_bool *int_bool)
{
  print_int_bool_indent (int_bool, "");
}

static int
run_launch (const char *cmd, size_t argc, char *argv[])
{
  int r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_launch (g);
  return r;
}

static int
run_kill_subprocess (const char *cmd, size_t argc, char *argv[])
{
  int r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_kill_subprocess (g);
  return r;
}

static int
run_add_drive (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *filename;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  filename = argv[i++];
  r = guestfs_add_drive (g, filename);
  return r;
}

static int
run_add_cdrom (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *filename;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  filename = argv[i++];
  r = guestfs_add_cdrom (g, filename);
  return r;
}

static int
run_add_drive_ro (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *filename;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  filename = argv[i++];
  r = guestfs_add_drive_ro (g, filename);
  return r;
}

static int
run_config (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *qemuparam;
  const char *qemuvalue;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  qemuparam = argv[i++];
  qemuvalue = STRNEQ (argv[i], "") ? argv[i] : NULL;
  i++;
  r = guestfs_config (g, qemuparam, qemuvalue);
  return r;
}

static int
run_set_qemu (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *qemu;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  qemu = STRNEQ (argv[i], "") ? argv[i] : NULL;
  i++;
  r = guestfs_set_qemu (g, qemu);
  return r;
}

static int
run_get_qemu (const char *cmd, size_t argc, char *argv[])
{
  const char *r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_get_qemu (g);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  return 0;
}

static int
run_set_path (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *searchpath;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  searchpath = STRNEQ (argv[i], "") ? argv[i] : NULL;
  i++;
  r = guestfs_set_path (g, searchpath);
  return r;
}

static int
run_get_path (const char *cmd, size_t argc, char *argv[])
{
  const char *r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_get_path (g);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  return 0;
}

static int
run_set_append (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *append;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  append = STRNEQ (argv[i], "") ? argv[i] : NULL;
  i++;
  r = guestfs_set_append (g, append);
  return r;
}

static int
run_get_append (const char *cmd, size_t argc, char *argv[])
{
  const char *r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_get_append (g);
  printf ("%s\n", r ? : "(null)");
  return 0;
}

static int
run_set_autosync (const char *cmd, size_t argc, char *argv[])
{
  int r;
  int autosync;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  autosync = is_true (argv[i++]) ? 1 : 0;
  r = guestfs_set_autosync (g, autosync);
  return r;
}

static int
run_get_autosync (const char *cmd, size_t argc, char *argv[])
{
  int r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_get_autosync (g);
  if (r == -1) return -1;
  if (r) printf ("true\n"); else printf ("false\n");
  return 0;
}

static int
run_set_verbose (const char *cmd, size_t argc, char *argv[])
{
  int r;
  int verbose;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  verbose = is_true (argv[i++]) ? 1 : 0;
  r = guestfs_set_verbose (g, verbose);
  return r;
}

static int
run_get_verbose (const char *cmd, size_t argc, char *argv[])
{
  int r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_get_verbose (g);
  if (r == -1) return -1;
  if (r) printf ("true\n"); else printf ("false\n");
  return 0;
}

static int
run_is_ready (const char *cmd, size_t argc, char *argv[])
{
  int r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_is_ready (g);
  if (r == -1) return -1;
  if (r) printf ("true\n"); else printf ("false\n");
  return 0;
}

static int
run_is_config (const char *cmd, size_t argc, char *argv[])
{
  int r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_is_config (g);
  if (r == -1) return -1;
  if (r) printf ("true\n"); else printf ("false\n");
  return 0;
}

static int
run_is_launching (const char *cmd, size_t argc, char *argv[])
{
  int r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_is_launching (g);
  if (r == -1) return -1;
  if (r) printf ("true\n"); else printf ("false\n");
  return 0;
}

static int
run_is_busy (const char *cmd, size_t argc, char *argv[])
{
  int r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_is_busy (g);
  if (r == -1) return -1;
  if (r) printf ("true\n"); else printf ("false\n");
  return 0;
}

static int
run_get_state (const char *cmd, size_t argc, char *argv[])
{
  int r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_get_state (g);
  if (r == -1) return -1;
  printf ("%d\n", r);
  return 0;
}

static int
run_set_memsize (const char *cmd, size_t argc, char *argv[])
{
  int r;
  int memsize;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "memsize", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "memsize");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    memsize = r;
  }
  r = guestfs_set_memsize (g, memsize);
  return r;
}

static int
run_get_memsize (const char *cmd, size_t argc, char *argv[])
{
  int r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_get_memsize (g);
  if (r == -1) return -1;
  printf ("%d\n", r);
  return 0;
}

static int
run_get_pid (const char *cmd, size_t argc, char *argv[])
{
  int r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_get_pid (g);
  if (r == -1) return -1;
  printf ("%d\n", r);
  return 0;
}

static int
run_version (const char *cmd, size_t argc, char *argv[])
{
  struct guestfs_version *r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_version (g);
  if (r == NULL) return -1;
  print_version (r);
  guestfs_free_version (r);
  return 0;
}

static int
run_set_selinux (const char *cmd, size_t argc, char *argv[])
{
  int r;
  int selinux;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  selinux = is_true (argv[i++]) ? 1 : 0;
  r = guestfs_set_selinux (g, selinux);
  return r;
}

static int
run_get_selinux (const char *cmd, size_t argc, char *argv[])
{
  int r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_get_selinux (g);
  if (r == -1) return -1;
  if (r) printf ("true\n"); else printf ("false\n");
  return 0;
}

static int
run_set_trace (const char *cmd, size_t argc, char *argv[])
{
  int r;
  int trace;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  trace = is_true (argv[i++]) ? 1 : 0;
  r = guestfs_set_trace (g, trace);
  return r;
}

static int
run_get_trace (const char *cmd, size_t argc, char *argv[])
{
  int r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_get_trace (g);
  if (r == -1) return -1;
  if (r) printf ("true\n"); else printf ("false\n");
  return 0;
}

static int
run_set_direct (const char *cmd, size_t argc, char *argv[])
{
  int r;
  int direct;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  direct = is_true (argv[i++]) ? 1 : 0;
  r = guestfs_set_direct (g, direct);
  return r;
}

static int
run_get_direct (const char *cmd, size_t argc, char *argv[])
{
  int r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_get_direct (g);
  if (r == -1) return -1;
  if (r) printf ("true\n"); else printf ("false\n");
  return 0;
}

static int
run_set_recovery_proc (const char *cmd, size_t argc, char *argv[])
{
  int r;
  int recoveryproc;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  recoveryproc = is_true (argv[i++]) ? 1 : 0;
  r = guestfs_set_recovery_proc (g, recoveryproc);
  return r;
}

static int
run_get_recovery_proc (const char *cmd, size_t argc, char *argv[])
{
  int r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_get_recovery_proc (g);
  if (r == -1) return -1;
  if (r) printf ("true\n"); else printf ("false\n");
  return 0;
}

static int
run_add_drive_with_if (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *filename;
  const char *iface;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  filename = argv[i++];
  iface = argv[i++];
  r = guestfs_add_drive_with_if (g, filename, iface);
  return r;
}

static int
run_add_drive_ro_with_if (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *filename;
  const char *iface;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  filename = argv[i++];
  iface = argv[i++];
  r = guestfs_add_drive_ro_with_if (g, filename, iface);
  return r;
}

static int
run_file_architecture (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  char *filename;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  filename = resolve_win_path (argv[i++]);
  if (filename == NULL) return -1;
  r = guestfs_file_architecture (g, filename);
  free (filename);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_inspect_os (const char *cmd, size_t argc, char *argv[])
{
  char **r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_inspect_os (g);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_inspect_get_type (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  const char *root;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  root = argv[i++];
  r = guestfs_inspect_get_type (g, root);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_inspect_get_arch (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  const char *root;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  root = argv[i++];
  r = guestfs_inspect_get_arch (g, root);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_inspect_get_distro (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  const char *root;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  root = argv[i++];
  r = guestfs_inspect_get_distro (g, root);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_inspect_get_major_version (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *root;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  root = argv[i++];
  r = guestfs_inspect_get_major_version (g, root);
  if (r == -1) return -1;
  printf ("%d\n", r);
  return 0;
}

static int
run_inspect_get_minor_version (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *root;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  root = argv[i++];
  r = guestfs_inspect_get_minor_version (g, root);
  if (r == -1) return -1;
  printf ("%d\n", r);
  return 0;
}

static int
run_inspect_get_product_name (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  const char *root;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  root = argv[i++];
  r = guestfs_inspect_get_product_name (g, root);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_inspect_get_mountpoints (const char *cmd, size_t argc, char *argv[])
{
  char **r;
  const char *root;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  root = argv[i++];
  r = guestfs_inspect_get_mountpoints (g, root);
  if (r == NULL) return -1;
  print_table (r);
  free_strings (r);
  return 0;
}

static int
run_inspect_get_filesystems (const char *cmd, size_t argc, char *argv[])
{
  char **r;
  const char *root;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  root = argv[i++];
  r = guestfs_inspect_get_filesystems (g, root);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_set_network (const char *cmd, size_t argc, char *argv[])
{
  int r;
  int network;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  network = is_true (argv[i++]) ? 1 : 0;
  r = guestfs_set_network (g, network);
  return r;
}

static int
run_get_network (const char *cmd, size_t argc, char *argv[])
{
  int r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_get_network (g);
  if (r == -1) return -1;
  if (r) printf ("true\n"); else printf ("false\n");
  return 0;
}

static int
run_list_filesystems (const char *cmd, size_t argc, char *argv[])
{
  char **r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_list_filesystems (g);
  if (r == NULL) return -1;
  print_table (r);
  free_strings (r);
  return 0;
}

static int
run_add_drive_opts (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *filename;
  struct guestfs_add_drive_opts_argv optargs_s = { .bitmask = 0 };
  struct guestfs_add_drive_opts_argv *optargs = &optargs_s;
  size_t i = 0;

  if (argc < 1 || argc > 4) {
    fprintf (stderr, _("%s should have %d-%d parameter(s)\n"), cmd, 1, 4);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  filename = argv[i++];

  for (; i < argc; ++i) {
    uint64_t this_mask;
    const char *this_arg;

    if (STRPREFIX (argv[i], "readonly:")) {
      optargs_s.readonly = is_true (&argv[i][9]) ? 1 : 0;
      this_mask = GUESTFS_ADD_DRIVE_OPTS_READONLY_BITMASK;
      this_arg = "readonly";
    }
    else if (STRPREFIX (argv[i], "format:")) {
      optargs_s.format = &argv[i][7];
      this_mask = GUESTFS_ADD_DRIVE_OPTS_FORMAT_BITMASK;
      this_arg = "format";
    }
    else if (STRPREFIX (argv[i], "iface:")) {
      optargs_s.iface = &argv[i][6];
      this_mask = GUESTFS_ADD_DRIVE_OPTS_IFACE_BITMASK;
      this_arg = "iface";
    }
    else {
      fprintf (stderr, _("%s: unknown optional argument \"%s\"\n"),
               cmd, argv[i]);
      return -1;
    }

    if (optargs_s.bitmask & this_mask) {
      fprintf (stderr, _("%s: optional argument \"%s\" given twice\n"),
               cmd, this_arg);
      return -1;
    }
    optargs_s.bitmask |= this_mask;
  }

  r = guestfs_add_drive_opts_argv (g, filename, optargs);
  return r;
}

static int
run_inspect_get_windows_systemroot (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  const char *root;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  root = argv[i++];
  r = guestfs_inspect_get_windows_systemroot (g, root);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_mount (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  const char *mountpoint;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  mountpoint = argv[i++];
  r = guestfs_mount (g, device, mountpoint);
  return r;
}

static int
run_sync (const char *cmd, size_t argc, char *argv[])
{
  int r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_sync (g);
  return r;
}

static int
run_touch (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *path;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_touch (g, path);
  free (path);
  return r;
}

static int
run_cat (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  char *path;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_cat (g, path);
  free (path);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_ll (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  char *directory;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  directory = resolve_win_path (argv[i++]);
  if (directory == NULL) return -1;
  r = guestfs_ll (g, directory);
  free (directory);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_ls (const char *cmd, size_t argc, char *argv[])
{
  char **r;
  char *directory;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  directory = resolve_win_path (argv[i++]);
  if (directory == NULL) return -1;
  r = guestfs_ls (g, directory);
  free (directory);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_list_devices (const char *cmd, size_t argc, char *argv[])
{
  char **r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_list_devices (g);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_list_partitions (const char *cmd, size_t argc, char *argv[])
{
  char **r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_list_partitions (g);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_pvs (const char *cmd, size_t argc, char *argv[])
{
  char **r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_pvs (g);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_vgs (const char *cmd, size_t argc, char *argv[])
{
  char **r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_vgs (g);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_lvs (const char *cmd, size_t argc, char *argv[])
{
  char **r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_lvs (g);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_pvs_full (const char *cmd, size_t argc, char *argv[])
{
  struct guestfs_lvm_pv_list *r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_pvs_full (g);
  if (r == NULL) return -1;
  print_lvm_pv_list (r);
  guestfs_free_lvm_pv_list (r);
  return 0;
}

static int
run_vgs_full (const char *cmd, size_t argc, char *argv[])
{
  struct guestfs_lvm_vg_list *r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_vgs_full (g);
  if (r == NULL) return -1;
  print_lvm_vg_list (r);
  guestfs_free_lvm_vg_list (r);
  return 0;
}

static int
run_lvs_full (const char *cmd, size_t argc, char *argv[])
{
  struct guestfs_lvm_lv_list *r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_lvs_full (g);
  if (r == NULL) return -1;
  print_lvm_lv_list (r);
  guestfs_free_lvm_lv_list (r);
  return 0;
}

static int
run_read_lines (const char *cmd, size_t argc, char *argv[])
{
  char **r;
  char *path;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_read_lines (g, path);
  free (path);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_aug_init (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *root;
  int flags;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  root = resolve_win_path (argv[i++]);
  if (root == NULL) return -1;
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "flags", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "flags");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    flags = r;
  }
  r = guestfs_aug_init (g, root, flags);
  free (root);
  return r;
}

static int
run_aug_close (const char *cmd, size_t argc, char *argv[])
{
  int r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_aug_close (g);
  return r;
}

static int
run_aug_defvar (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *name;
  const char *expr;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  name = argv[i++];
  expr = STRNEQ (argv[i], "") ? argv[i] : NULL;
  i++;
  r = guestfs_aug_defvar (g, name, expr);
  if (r == -1) return -1;
  printf ("%d\n", r);
  return 0;
}

static int
run_aug_defnode (const char *cmd, size_t argc, char *argv[])
{
  struct guestfs_int_bool *r;
  const char *name;
  const char *expr;
  const char *val;
  size_t i = 0;

  if (argc != 3) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 3);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  name = argv[i++];
  expr = argv[i++];
  val = argv[i++];
  r = guestfs_aug_defnode (g, name, expr, val);
  if (r == NULL) return -1;
  print_int_bool (r);
  guestfs_free_int_bool (r);
  return 0;
}

static int
run_aug_get (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  const char *augpath;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  augpath = argv[i++];
  r = guestfs_aug_get (g, augpath);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_aug_set (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *augpath;
  const char *val;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  augpath = argv[i++];
  val = argv[i++];
  r = guestfs_aug_set (g, augpath, val);
  return r;
}

static int
run_aug_insert (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *augpath;
  const char *label;
  int before;
  size_t i = 0;

  if (argc != 3) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 3);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  augpath = argv[i++];
  label = argv[i++];
  before = is_true (argv[i++]) ? 1 : 0;
  r = guestfs_aug_insert (g, augpath, label, before);
  return r;
}

static int
run_aug_rm (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *augpath;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  augpath = argv[i++];
  r = guestfs_aug_rm (g, augpath);
  if (r == -1) return -1;
  printf ("%d\n", r);
  return 0;
}

static int
run_aug_mv (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *src;
  const char *dest;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  src = argv[i++];
  dest = argv[i++];
  r = guestfs_aug_mv (g, src, dest);
  return r;
}

static int
run_aug_match (const char *cmd, size_t argc, char *argv[])
{
  char **r;
  const char *augpath;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  augpath = argv[i++];
  r = guestfs_aug_match (g, augpath);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_aug_save (const char *cmd, size_t argc, char *argv[])
{
  int r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_aug_save (g);
  return r;
}

static int
run_aug_load (const char *cmd, size_t argc, char *argv[])
{
  int r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_aug_load (g);
  return r;
}

static int
run_aug_ls (const char *cmd, size_t argc, char *argv[])
{
  char **r;
  const char *augpath;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  augpath = argv[i++];
  r = guestfs_aug_ls (g, augpath);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_rm (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *path;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_rm (g, path);
  free (path);
  return r;
}

static int
run_rmdir (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *path;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_rmdir (g, path);
  free (path);
  return r;
}

static int
run_rm_rf (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *path;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_rm_rf (g, path);
  free (path);
  return r;
}

static int
run_mkdir (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *path;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_mkdir (g, path);
  free (path);
  return r;
}

static int
run_mkdir_p (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *path;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_mkdir_p (g, path);
  free (path);
  return r;
}

static int
run_chmod (const char *cmd, size_t argc, char *argv[])
{
  int r;
  int mode;
  char *path;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "mode", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "mode");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    mode = r;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_chmod (g, mode, path);
  free (path);
  return r;
}

static int
run_chown (const char *cmd, size_t argc, char *argv[])
{
  int r;
  int owner;
  int group;
  char *path;
  size_t i = 0;

  if (argc != 3) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 3);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "owner", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "owner");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    owner = r;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "group", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "group");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    group = r;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_chown (g, owner, group, path);
  free (path);
  return r;
}

static int
run_exists (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *path;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_exists (g, path);
  free (path);
  if (r == -1) return -1;
  if (r) printf ("true\n"); else printf ("false\n");
  return 0;
}

static int
run_is_file (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *path;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_is_file (g, path);
  free (path);
  if (r == -1) return -1;
  if (r) printf ("true\n"); else printf ("false\n");
  return 0;
}

static int
run_is_dir (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *path;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_is_dir (g, path);
  free (path);
  if (r == -1) return -1;
  if (r) printf ("true\n"); else printf ("false\n");
  return 0;
}

static int
run_pvcreate (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  r = guestfs_pvcreate (g, device);
  return r;
}

static int
run_vgcreate (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *volgroup;
  char **physvols;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  volgroup = argv[i++];
  physvols = parse_string_list (argv[i++]);
  if (physvols == NULL) return -1;
  r = guestfs_vgcreate (g, volgroup, physvols);
  free_strings (physvols);
  return r;
}

static int
run_lvcreate (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *logvol;
  const char *volgroup;
  int mbytes;
  size_t i = 0;

  if (argc != 3) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 3);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  logvol = argv[i++];
  volgroup = argv[i++];
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "mbytes", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "mbytes");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    mbytes = r;
  }
  r = guestfs_lvcreate (g, logvol, volgroup, mbytes);
  return r;
}

static int
run_mkfs (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *fstype;
  const char *device;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  fstype = argv[i++];
  device = argv[i++];
  r = guestfs_mkfs (g, fstype, device);
  return r;
}

static int
run_sfdisk (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  int cyls;
  int heads;
  int sectors;
  char **lines;
  size_t i = 0;

  if (argc != 5) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 5);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "cyls", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "cyls");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    cyls = r;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "heads", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "heads");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    heads = r;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "sectors", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "sectors");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    sectors = r;
  }
  lines = parse_string_list (argv[i++]);
  if (lines == NULL) return -1;
  r = guestfs_sfdisk (g, device, cyls, heads, sectors, lines);
  free_strings (lines);
  return r;
}

static int
run_write_file (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *path;
  const char *content;
  int size;
  size_t i = 0;

  if (argc != 3) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 3);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  content = argv[i++];
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "size", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "size");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    size = r;
  }
  r = guestfs_write_file (g, path, content, size);
  free (path);
  return r;
}

static int
run_umount (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *pathordevice;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  pathordevice = argv[i++];
  r = guestfs_umount (g, pathordevice);
  return r;
}

static int
run_mounts (const char *cmd, size_t argc, char *argv[])
{
  char **r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_mounts (g);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_umount_all (const char *cmd, size_t argc, char *argv[])
{
  int r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_umount_all (g);
  return r;
}

static int
run_lvm_remove_all (const char *cmd, size_t argc, char *argv[])
{
  int r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_lvm_remove_all (g);
  return r;
}

static int
run_file (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  char *path;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_file (g, path);
  free (path);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_command (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  char **arguments;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  arguments = parse_string_list (argv[i++]);
  if (arguments == NULL) return -1;
  r = guestfs_command (g, arguments);
  free_strings (arguments);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_command_lines (const char *cmd, size_t argc, char *argv[])
{
  char **r;
  char **arguments;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  arguments = parse_string_list (argv[i++]);
  if (arguments == NULL) return -1;
  r = guestfs_command_lines (g, arguments);
  free_strings (arguments);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_stat (const char *cmd, size_t argc, char *argv[])
{
  struct guestfs_stat *r;
  char *path;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_stat (g, path);
  free (path);
  if (r == NULL) return -1;
  print_stat (r);
  guestfs_free_stat (r);
  return 0;
}

static int
run_lstat (const char *cmd, size_t argc, char *argv[])
{
  struct guestfs_stat *r;
  char *path;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_lstat (g, path);
  free (path);
  if (r == NULL) return -1;
  print_stat (r);
  guestfs_free_stat (r);
  return 0;
}

static int
run_statvfs (const char *cmd, size_t argc, char *argv[])
{
  struct guestfs_statvfs *r;
  char *path;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_statvfs (g, path);
  free (path);
  if (r == NULL) return -1;
  print_statvfs (r);
  guestfs_free_statvfs (r);
  return 0;
}

static int
run_tune2fs_l (const char *cmd, size_t argc, char *argv[])
{
  char **r;
  const char *device;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  r = guestfs_tune2fs_l (g, device);
  if (r == NULL) return -1;
  print_table (r);
  free_strings (r);
  return 0;
}

static int
run_blockdev_setro (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  r = guestfs_blockdev_setro (g, device);
  return r;
}

static int
run_blockdev_setrw (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  r = guestfs_blockdev_setrw (g, device);
  return r;
}

static int
run_blockdev_getro (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  r = guestfs_blockdev_getro (g, device);
  if (r == -1) return -1;
  if (r) printf ("true\n"); else printf ("false\n");
  return 0;
}

static int
run_blockdev_getss (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  r = guestfs_blockdev_getss (g, device);
  if (r == -1) return -1;
  printf ("%d\n", r);
  return 0;
}

static int
run_blockdev_getbsz (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  r = guestfs_blockdev_getbsz (g, device);
  if (r == -1) return -1;
  printf ("%d\n", r);
  return 0;
}

static int
run_blockdev_setbsz (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  int blocksize;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "blocksize", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "blocksize");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    blocksize = r;
  }
  r = guestfs_blockdev_setbsz (g, device, blocksize);
  return r;
}

static int
run_blockdev_getsz (const char *cmd, size_t argc, char *argv[])
{
  int64_t r;
  const char *device;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  r = guestfs_blockdev_getsz (g, device);
  if (r == -1) return -1;
  printf ("%" PRIi64 "\n", r);
  return 0;
}

static int
run_blockdev_getsize64 (const char *cmd, size_t argc, char *argv[])
{
  int64_t r;
  const char *device;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  r = guestfs_blockdev_getsize64 (g, device);
  if (r == -1) return -1;
  printf ("%" PRIi64 "\n", r);
  return 0;
}

static int
run_blockdev_flushbufs (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  r = guestfs_blockdev_flushbufs (g, device);
  return r;
}

static int
run_blockdev_rereadpt (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  r = guestfs_blockdev_rereadpt (g, device);
  return r;
}

static int
run_upload (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *filename;
  char *remotefilename;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  filename = file_in (argv[i++]);
  if (filename == NULL) return -1;
  remotefilename = resolve_win_path (argv[i++]);
  if (remotefilename == NULL) return -1;
  r = guestfs_upload (g, filename, remotefilename);
  free_file_in (filename);
  free (remotefilename);
  return r;
}

static int
run_download (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *remotefilename;
  char *filename;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  remotefilename = resolve_win_path (argv[i++]);
  if (remotefilename == NULL) return -1;
  filename = file_out (argv[i++]);
  if (filename == NULL) return -1;
  r = guestfs_download (g, remotefilename, filename);
  free (remotefilename);
  free (filename);
  return r;
}

static int
run_checksum (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  const char *csumtype;
  char *path;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  csumtype = argv[i++];
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_checksum (g, csumtype, path);
  free (path);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_tar_in (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *tarfile;
  char *directory;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  tarfile = file_in (argv[i++]);
  if (tarfile == NULL) return -1;
  directory = resolve_win_path (argv[i++]);
  if (directory == NULL) return -1;
  r = guestfs_tar_in (g, tarfile, directory);
  free_file_in (tarfile);
  free (directory);
  return r;
}

static int
run_tar_out (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *directory;
  char *tarfile;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  directory = argv[i++];
  tarfile = file_out (argv[i++]);
  if (tarfile == NULL) return -1;
  r = guestfs_tar_out (g, directory, tarfile);
  free (tarfile);
  return r;
}

static int
run_tgz_in (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *tarball;
  char *directory;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  tarball = file_in (argv[i++]);
  if (tarball == NULL) return -1;
  directory = resolve_win_path (argv[i++]);
  if (directory == NULL) return -1;
  r = guestfs_tgz_in (g, tarball, directory);
  free_file_in (tarball);
  free (directory);
  return r;
}

static int
run_tgz_out (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *directory;
  char *tarball;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  directory = resolve_win_path (argv[i++]);
  if (directory == NULL) return -1;
  tarball = file_out (argv[i++]);
  if (tarball == NULL) return -1;
  r = guestfs_tgz_out (g, directory, tarball);
  free (directory);
  free (tarball);
  return r;
}

static int
run_mount_ro (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  const char *mountpoint;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  mountpoint = argv[i++];
  r = guestfs_mount_ro (g, device, mountpoint);
  return r;
}

static int
run_mount_options (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *options;
  const char *device;
  const char *mountpoint;
  size_t i = 0;

  if (argc != 3) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 3);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  options = argv[i++];
  device = argv[i++];
  mountpoint = argv[i++];
  r = guestfs_mount_options (g, options, device, mountpoint);
  return r;
}

static int
run_mount_vfs (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *options;
  const char *vfstype;
  const char *device;
  const char *mountpoint;
  size_t i = 0;

  if (argc != 4) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 4);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  options = argv[i++];
  vfstype = argv[i++];
  device = argv[i++];
  mountpoint = argv[i++];
  r = guestfs_mount_vfs (g, options, vfstype, device, mountpoint);
  return r;
}

static int
run_debug (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  const char *subcmd;
  char **extraargs;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  subcmd = argv[i++];
  extraargs = parse_string_list (argv[i++]);
  if (extraargs == NULL) return -1;
  r = guestfs_debug (g, subcmd, extraargs);
  free_strings (extraargs);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_lvremove (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  r = guestfs_lvremove (g, device);
  return r;
}

static int
run_vgremove (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *vgname;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  vgname = argv[i++];
  r = guestfs_vgremove (g, vgname);
  return r;
}

static int
run_pvremove (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  r = guestfs_pvremove (g, device);
  return r;
}

static int
run_set_e2label (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  const char *label;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  label = argv[i++];
  r = guestfs_set_e2label (g, device, label);
  return r;
}

static int
run_get_e2label (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  const char *device;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  r = guestfs_get_e2label (g, device);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_set_e2uuid (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  const char *uuid;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  uuid = argv[i++];
  r = guestfs_set_e2uuid (g, device, uuid);
  return r;
}

static int
run_get_e2uuid (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  const char *device;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  r = guestfs_get_e2uuid (g, device);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_fsck (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *fstype;
  const char *device;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  fstype = argv[i++];
  device = argv[i++];
  r = guestfs_fsck (g, fstype, device);
  if (r == -1) return -1;
  printf ("%s%x\n", r != 0 ? "0x" : "", r);
  return 0;
}

static int
run_zero (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  r = guestfs_zero (g, device);
  return r;
}

static int
run_grub_install (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *root;
  const char *device;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  root = resolve_win_path (argv[i++]);
  if (root == NULL) return -1;
  device = argv[i++];
  r = guestfs_grub_install (g, root, device);
  free (root);
  return r;
}

static int
run_cp (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *src;
  char *dest;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  src = resolve_win_path (argv[i++]);
  if (src == NULL) return -1;
  dest = resolve_win_path (argv[i++]);
  if (dest == NULL) return -1;
  r = guestfs_cp (g, src, dest);
  free (src);
  free (dest);
  return r;
}

static int
run_cp_a (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *src;
  char *dest;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  src = resolve_win_path (argv[i++]);
  if (src == NULL) return -1;
  dest = resolve_win_path (argv[i++]);
  if (dest == NULL) return -1;
  r = guestfs_cp_a (g, src, dest);
  free (src);
  free (dest);
  return r;
}

static int
run_mv (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *src;
  char *dest;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  src = resolve_win_path (argv[i++]);
  if (src == NULL) return -1;
  dest = resolve_win_path (argv[i++]);
  if (dest == NULL) return -1;
  r = guestfs_mv (g, src, dest);
  free (src);
  free (dest);
  return r;
}

static int
run_drop_caches (const char *cmd, size_t argc, char *argv[])
{
  int r;
  int whattodrop;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "whattodrop", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "whattodrop");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    whattodrop = r;
  }
  r = guestfs_drop_caches (g, whattodrop);
  return r;
}

static int
run_dmesg (const char *cmd, size_t argc, char *argv[])
{
  char *r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_dmesg (g);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_ping_daemon (const char *cmd, size_t argc, char *argv[])
{
  int r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_ping_daemon (g);
  return r;
}

static int
run_equal (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *file1;
  char *file2;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  file1 = resolve_win_path (argv[i++]);
  if (file1 == NULL) return -1;
  file2 = resolve_win_path (argv[i++]);
  if (file2 == NULL) return -1;
  r = guestfs_equal (g, file1, file2);
  free (file1);
  free (file2);
  if (r == -1) return -1;
  if (r) printf ("true\n"); else printf ("false\n");
  return 0;
}

static int
run_strings (const char *cmd, size_t argc, char *argv[])
{
  char **r;
  char *path;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_strings (g, path);
  free (path);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_strings_e (const char *cmd, size_t argc, char *argv[])
{
  char **r;
  const char *encoding;
  char *path;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  encoding = argv[i++];
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_strings_e (g, encoding, path);
  free (path);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_hexdump (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  char *path;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_hexdump (g, path);
  free (path);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_zerofree (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  r = guestfs_zerofree (g, device);
  return r;
}

static int
run_pvresize (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  r = guestfs_pvresize (g, device);
  return r;
}

static int
run_sfdisk_N (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  int partnum;
  int cyls;
  int heads;
  int sectors;
  const char *line;
  size_t i = 0;

  if (argc != 6) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 6);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "partnum", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "partnum");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    partnum = r;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "cyls", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "cyls");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    cyls = r;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "heads", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "heads");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    heads = r;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "sectors", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "sectors");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    sectors = r;
  }
  line = argv[i++];
  r = guestfs_sfdisk_N (g, device, partnum, cyls, heads, sectors, line);
  return r;
}

static int
run_sfdisk_l (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  const char *device;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  r = guestfs_sfdisk_l (g, device);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_sfdisk_kernel_geometry (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  const char *device;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  r = guestfs_sfdisk_kernel_geometry (g, device);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_sfdisk_disk_geometry (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  const char *device;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  r = guestfs_sfdisk_disk_geometry (g, device);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_vg_activate_all (const char *cmd, size_t argc, char *argv[])
{
  int r;
  int activate;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  activate = is_true (argv[i++]) ? 1 : 0;
  r = guestfs_vg_activate_all (g, activate);
  return r;
}

static int
run_vg_activate (const char *cmd, size_t argc, char *argv[])
{
  int r;
  int activate;
  char **volgroups;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  activate = is_true (argv[i++]) ? 1 : 0;
  volgroups = parse_string_list (argv[i++]);
  if (volgroups == NULL) return -1;
  r = guestfs_vg_activate (g, activate, volgroups);
  free_strings (volgroups);
  return r;
}

static int
run_lvresize (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  int mbytes;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "mbytes", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "mbytes");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    mbytes = r;
  }
  r = guestfs_lvresize (g, device, mbytes);
  return r;
}

static int
run_resize2fs (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  r = guestfs_resize2fs (g, device);
  return r;
}

static int
run_find (const char *cmd, size_t argc, char *argv[])
{
  char **r;
  char *directory;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  directory = resolve_win_path (argv[i++]);
  if (directory == NULL) return -1;
  r = guestfs_find (g, directory);
  free (directory);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_e2fsck_f (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  r = guestfs_e2fsck_f (g, device);
  return r;
}

static int
run_sleep (const char *cmd, size_t argc, char *argv[])
{
  int r;
  int secs;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "secs", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "secs");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    secs = r;
  }
  r = guestfs_sleep (g, secs);
  return r;
}

static int
run_ntfs_3g_probe (const char *cmd, size_t argc, char *argv[])
{
  int r;
  int rw;
  const char *device;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  rw = is_true (argv[i++]) ? 1 : 0;
  device = argv[i++];
  r = guestfs_ntfs_3g_probe (g, rw, device);
  if (r == -1) return -1;
  printf ("%d\n", r);
  return 0;
}

static int
run_sh (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  const char *command;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  command = argv[i++];
  r = guestfs_sh (g, command);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_sh_lines (const char *cmd, size_t argc, char *argv[])
{
  char **r;
  const char *command;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  command = argv[i++];
  r = guestfs_sh_lines (g, command);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_glob_expand (const char *cmd, size_t argc, char *argv[])
{
  char **r;
  char *pattern;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  pattern = resolve_win_path (argv[i++]);
  if (pattern == NULL) return -1;
  r = guestfs_glob_expand (g, pattern);
  free (pattern);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_scrub_device (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  r = guestfs_scrub_device (g, device);
  return r;
}

static int
run_scrub_file (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *file;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  file = resolve_win_path (argv[i++]);
  if (file == NULL) return -1;
  r = guestfs_scrub_file (g, file);
  free (file);
  return r;
}

static int
run_scrub_freespace (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *dir;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  dir = resolve_win_path (argv[i++]);
  if (dir == NULL) return -1;
  r = guestfs_scrub_freespace (g, dir);
  free (dir);
  return r;
}

static int
run_mkdtemp (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  char *template;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  template = resolve_win_path (argv[i++]);
  if (template == NULL) return -1;
  r = guestfs_mkdtemp (g, template);
  free (template);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_wc_l (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *path;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_wc_l (g, path);
  free (path);
  if (r == -1) return -1;
  printf ("%d\n", r);
  return 0;
}

static int
run_wc_w (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *path;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_wc_w (g, path);
  free (path);
  if (r == -1) return -1;
  printf ("%d\n", r);
  return 0;
}

static int
run_wc_c (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *path;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_wc_c (g, path);
  free (path);
  if (r == -1) return -1;
  printf ("%d\n", r);
  return 0;
}

static int
run_head (const char *cmd, size_t argc, char *argv[])
{
  char **r;
  char *path;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_head (g, path);
  free (path);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_head_n (const char *cmd, size_t argc, char *argv[])
{
  char **r;
  int nrlines;
  char *path;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "nrlines", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "nrlines");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    nrlines = r;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_head_n (g, nrlines, path);
  free (path);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_tail (const char *cmd, size_t argc, char *argv[])
{
  char **r;
  char *path;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_tail (g, path);
  free (path);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_tail_n (const char *cmd, size_t argc, char *argv[])
{
  char **r;
  int nrlines;
  char *path;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "nrlines", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "nrlines");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    nrlines = r;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_tail_n (g, nrlines, path);
  free (path);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_df (const char *cmd, size_t argc, char *argv[])
{
  char *r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_df (g);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_df_h (const char *cmd, size_t argc, char *argv[])
{
  char *r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_df_h (g);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_du (const char *cmd, size_t argc, char *argv[])
{
  int64_t r;
  char *path;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_du (g, path);
  free (path);
  if (r == -1) return -1;
  printf ("%" PRIi64 "\n", r);
  return 0;
}

static int
run_initrd_list (const char *cmd, size_t argc, char *argv[])
{
  char **r;
  char *path;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_initrd_list (g, path);
  free (path);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_mount_loop (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *file;
  char *mountpoint;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  file = resolve_win_path (argv[i++]);
  if (file == NULL) return -1;
  mountpoint = resolve_win_path (argv[i++]);
  if (mountpoint == NULL) return -1;
  r = guestfs_mount_loop (g, file, mountpoint);
  free (file);
  free (mountpoint);
  return r;
}

static int
run_mkswap (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  r = guestfs_mkswap (g, device);
  return r;
}

static int
run_mkswap_L (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *label;
  const char *device;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  label = argv[i++];
  device = argv[i++];
  r = guestfs_mkswap_L (g, label, device);
  return r;
}

static int
run_mkswap_U (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *uuid;
  const char *device;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  uuid = argv[i++];
  device = argv[i++];
  r = guestfs_mkswap_U (g, uuid, device);
  return r;
}

static int
run_mknod (const char *cmd, size_t argc, char *argv[])
{
  int r;
  int mode;
  int devmajor;
  int devminor;
  char *path;
  size_t i = 0;

  if (argc != 4) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 4);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "mode", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "mode");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    mode = r;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "devmajor", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "devmajor");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    devmajor = r;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "devminor", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "devminor");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    devminor = r;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_mknod (g, mode, devmajor, devminor, path);
  free (path);
  return r;
}

static int
run_mkfifo (const char *cmd, size_t argc, char *argv[])
{
  int r;
  int mode;
  char *path;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "mode", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "mode");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    mode = r;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_mkfifo (g, mode, path);
  free (path);
  return r;
}

static int
run_mknod_b (const char *cmd, size_t argc, char *argv[])
{
  int r;
  int mode;
  int devmajor;
  int devminor;
  char *path;
  size_t i = 0;

  if (argc != 4) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 4);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "mode", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "mode");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    mode = r;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "devmajor", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "devmajor");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    devmajor = r;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "devminor", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "devminor");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    devminor = r;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_mknod_b (g, mode, devmajor, devminor, path);
  free (path);
  return r;
}

static int
run_mknod_c (const char *cmd, size_t argc, char *argv[])
{
  int r;
  int mode;
  int devmajor;
  int devminor;
  char *path;
  size_t i = 0;

  if (argc != 4) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 4);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "mode", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "mode");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    mode = r;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "devmajor", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "devmajor");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    devmajor = r;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "devminor", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "devminor");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    devminor = r;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_mknod_c (g, mode, devmajor, devminor, path);
  free (path);
  return r;
}

static int
run_umask (const char *cmd, size_t argc, char *argv[])
{
  int r;
  int mask;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "mask", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "mask");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    mask = r;
  }
  r = guestfs_umask (g, mask);
  if (r == -1) return -1;
  printf ("%s%o\n", r != 0 ? "0" : "", r);
  return 0;
}

static int
run_readdir (const char *cmd, size_t argc, char *argv[])
{
  struct guestfs_dirent_list *r;
  char *dir;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  dir = resolve_win_path (argv[i++]);
  if (dir == NULL) return -1;
  r = guestfs_readdir (g, dir);
  free (dir);
  if (r == NULL) return -1;
  print_dirent_list (r);
  guestfs_free_dirent_list (r);
  return 0;
}

static int
run_sfdiskM (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  char **lines;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  lines = parse_string_list (argv[i++]);
  if (lines == NULL) return -1;
  r = guestfs_sfdiskM (g, device, lines);
  free_strings (lines);
  return r;
}

static int
run_zfile (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  const char *meth;
  char *path;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  meth = argv[i++];
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_zfile (g, meth, path);
  free (path);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_getxattrs (const char *cmd, size_t argc, char *argv[])
{
  struct guestfs_xattr_list *r;
  char *path;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_getxattrs (g, path);
  free (path);
  if (r == NULL) return -1;
  print_xattr_list (r);
  guestfs_free_xattr_list (r);
  return 0;
}

static int
run_lgetxattrs (const char *cmd, size_t argc, char *argv[])
{
  struct guestfs_xattr_list *r;
  char *path;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_lgetxattrs (g, path);
  free (path);
  if (r == NULL) return -1;
  print_xattr_list (r);
  guestfs_free_xattr_list (r);
  return 0;
}

static int
run_setxattr (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *xattr;
  const char *val;
  int vallen;
  char *path;
  size_t i = 0;

  if (argc != 4) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 4);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  xattr = argv[i++];
  val = argv[i++];
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "vallen", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "vallen");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    vallen = r;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_setxattr (g, xattr, val, vallen, path);
  free (path);
  return r;
}

static int
run_lsetxattr (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *xattr;
  const char *val;
  int vallen;
  char *path;
  size_t i = 0;

  if (argc != 4) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 4);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  xattr = argv[i++];
  val = argv[i++];
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "vallen", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "vallen");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    vallen = r;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_lsetxattr (g, xattr, val, vallen, path);
  free (path);
  return r;
}

static int
run_removexattr (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *xattr;
  char *path;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  xattr = argv[i++];
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_removexattr (g, xattr, path);
  free (path);
  return r;
}

static int
run_lremovexattr (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *xattr;
  char *path;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  xattr = argv[i++];
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_lremovexattr (g, xattr, path);
  free (path);
  return r;
}

static int
run_mountpoints (const char *cmd, size_t argc, char *argv[])
{
  char **r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_mountpoints (g);
  if (r == NULL) return -1;
  print_table (r);
  free_strings (r);
  return 0;
}

static int
run_mkmountpoint (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *exemptpath;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  exemptpath = argv[i++];
  r = guestfs_mkmountpoint (g, exemptpath);
  return r;
}

static int
run_rmmountpoint (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *exemptpath;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  exemptpath = argv[i++];
  r = guestfs_rmmountpoint (g, exemptpath);
  return r;
}

static int
run_read_file (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  size_t size;
  char *path;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_read_file (g, path, &size);
  free (path);
  if (r == NULL) return -1;
  if (full_write (1, r, size) != size) {
    perror ("write");
    free (r);
    return -1;
  }
  free (r);
  return 0;
}

static int
run_grep (const char *cmd, size_t argc, char *argv[])
{
  char **r;
  const char *regex;
  char *path;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  regex = argv[i++];
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_grep (g, regex, path);
  free (path);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_egrep (const char *cmd, size_t argc, char *argv[])
{
  char **r;
  const char *regex;
  char *path;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  regex = argv[i++];
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_egrep (g, regex, path);
  free (path);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_fgrep (const char *cmd, size_t argc, char *argv[])
{
  char **r;
  const char *pattern;
  char *path;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  pattern = argv[i++];
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_fgrep (g, pattern, path);
  free (path);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_grepi (const char *cmd, size_t argc, char *argv[])
{
  char **r;
  const char *regex;
  char *path;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  regex = argv[i++];
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_grepi (g, regex, path);
  free (path);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_egrepi (const char *cmd, size_t argc, char *argv[])
{
  char **r;
  const char *regex;
  char *path;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  regex = argv[i++];
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_egrepi (g, regex, path);
  free (path);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_fgrepi (const char *cmd, size_t argc, char *argv[])
{
  char **r;
  const char *pattern;
  char *path;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  pattern = argv[i++];
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_fgrepi (g, pattern, path);
  free (path);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_zgrep (const char *cmd, size_t argc, char *argv[])
{
  char **r;
  const char *regex;
  char *path;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  regex = argv[i++];
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_zgrep (g, regex, path);
  free (path);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_zegrep (const char *cmd, size_t argc, char *argv[])
{
  char **r;
  const char *regex;
  char *path;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  regex = argv[i++];
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_zegrep (g, regex, path);
  free (path);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_zfgrep (const char *cmd, size_t argc, char *argv[])
{
  char **r;
  const char *pattern;
  char *path;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  pattern = argv[i++];
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_zfgrep (g, pattern, path);
  free (path);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_zgrepi (const char *cmd, size_t argc, char *argv[])
{
  char **r;
  const char *regex;
  char *path;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  regex = argv[i++];
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_zgrepi (g, regex, path);
  free (path);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_zegrepi (const char *cmd, size_t argc, char *argv[])
{
  char **r;
  const char *regex;
  char *path;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  regex = argv[i++];
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_zegrepi (g, regex, path);
  free (path);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_zfgrepi (const char *cmd, size_t argc, char *argv[])
{
  char **r;
  const char *pattern;
  char *path;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  pattern = argv[i++];
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_zfgrepi (g, pattern, path);
  free (path);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_realpath (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  char *path;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_realpath (g, path);
  free (path);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_ln (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *target;
  char *linkname;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  target = argv[i++];
  linkname = resolve_win_path (argv[i++]);
  if (linkname == NULL) return -1;
  r = guestfs_ln (g, target, linkname);
  free (linkname);
  return r;
}

static int
run_ln_f (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *target;
  char *linkname;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  target = argv[i++];
  linkname = resolve_win_path (argv[i++]);
  if (linkname == NULL) return -1;
  r = guestfs_ln_f (g, target, linkname);
  free (linkname);
  return r;
}

static int
run_ln_s (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *target;
  char *linkname;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  target = argv[i++];
  linkname = resolve_win_path (argv[i++]);
  if (linkname == NULL) return -1;
  r = guestfs_ln_s (g, target, linkname);
  free (linkname);
  return r;
}

static int
run_ln_sf (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *target;
  char *linkname;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  target = argv[i++];
  linkname = resolve_win_path (argv[i++]);
  if (linkname == NULL) return -1;
  r = guestfs_ln_sf (g, target, linkname);
  free (linkname);
  return r;
}

static int
run_readlink (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  char *path;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_readlink (g, path);
  free (path);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_fallocate (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *path;
  int len;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "len", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "len");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    len = r;
  }
  r = guestfs_fallocate (g, path, len);
  free (path);
  return r;
}

static int
run_swapon_device (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  r = guestfs_swapon_device (g, device);
  return r;
}

static int
run_swapoff_device (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  r = guestfs_swapoff_device (g, device);
  return r;
}

static int
run_swapon_file (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *file;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  file = resolve_win_path (argv[i++]);
  if (file == NULL) return -1;
  r = guestfs_swapon_file (g, file);
  free (file);
  return r;
}

static int
run_swapoff_file (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *file;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  file = resolve_win_path (argv[i++]);
  if (file == NULL) return -1;
  r = guestfs_swapoff_file (g, file);
  free (file);
  return r;
}

static int
run_swapon_label (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *label;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  label = argv[i++];
  r = guestfs_swapon_label (g, label);
  return r;
}

static int
run_swapoff_label (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *label;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  label = argv[i++];
  r = guestfs_swapoff_label (g, label);
  return r;
}

static int
run_swapon_uuid (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *uuid;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  uuid = argv[i++];
  r = guestfs_swapon_uuid (g, uuid);
  return r;
}

static int
run_swapoff_uuid (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *uuid;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  uuid = argv[i++];
  r = guestfs_swapoff_uuid (g, uuid);
  return r;
}

static int
run_mkswap_file (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *path;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_mkswap_file (g, path);
  free (path);
  return r;
}

static int
run_inotify_init (const char *cmd, size_t argc, char *argv[])
{
  int r;
  int maxevents;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "maxevents", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "maxevents");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    maxevents = r;
  }
  r = guestfs_inotify_init (g, maxevents);
  return r;
}

static int
run_inotify_add_watch (const char *cmd, size_t argc, char *argv[])
{
  int64_t r;
  char *path;
  int mask;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "mask", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "mask");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    mask = r;
  }
  r = guestfs_inotify_add_watch (g, path, mask);
  free (path);
  if (r == -1) return -1;
  printf ("%" PRIi64 "\n", r);
  return 0;
}

static int
run_inotify_rm_watch (const char *cmd, size_t argc, char *argv[])
{
  int r;
  int wd;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "wd", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "wd");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    wd = r;
  }
  r = guestfs_inotify_rm_watch (g, wd);
  return r;
}

static int
run_inotify_read (const char *cmd, size_t argc, char *argv[])
{
  struct guestfs_inotify_event_list *r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_inotify_read (g);
  if (r == NULL) return -1;
  print_inotify_event_list (r);
  guestfs_free_inotify_event_list (r);
  return 0;
}

static int
run_inotify_files (const char *cmd, size_t argc, char *argv[])
{
  char **r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_inotify_files (g);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_inotify_close (const char *cmd, size_t argc, char *argv[])
{
  int r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_inotify_close (g);
  return r;
}

static int
run_setcon (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *context;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  context = argv[i++];
  r = guestfs_setcon (g, context);
  return r;
}

static int
run_getcon (const char *cmd, size_t argc, char *argv[])
{
  char *r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_getcon (g);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_mkfs_b (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *fstype;
  int blocksize;
  const char *device;
  size_t i = 0;

  if (argc != 3) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 3);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  fstype = argv[i++];
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "blocksize", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "blocksize");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    blocksize = r;
  }
  device = argv[i++];
  r = guestfs_mkfs_b (g, fstype, blocksize, device);
  return r;
}

static int
run_mke2journal (const char *cmd, size_t argc, char *argv[])
{
  int r;
  int blocksize;
  const char *device;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "blocksize", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "blocksize");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    blocksize = r;
  }
  device = argv[i++];
  r = guestfs_mke2journal (g, blocksize, device);
  return r;
}

static int
run_mke2journal_L (const char *cmd, size_t argc, char *argv[])
{
  int r;
  int blocksize;
  const char *label;
  const char *device;
  size_t i = 0;

  if (argc != 3) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 3);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "blocksize", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "blocksize");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    blocksize = r;
  }
  label = argv[i++];
  device = argv[i++];
  r = guestfs_mke2journal_L (g, blocksize, label, device);
  return r;
}

static int
run_mke2journal_U (const char *cmd, size_t argc, char *argv[])
{
  int r;
  int blocksize;
  const char *uuid;
  const char *device;
  size_t i = 0;

  if (argc != 3) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 3);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "blocksize", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "blocksize");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    blocksize = r;
  }
  uuid = argv[i++];
  device = argv[i++];
  r = guestfs_mke2journal_U (g, blocksize, uuid, device);
  return r;
}

static int
run_mke2fs_J (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *fstype;
  int blocksize;
  const char *device;
  const char *journal;
  size_t i = 0;

  if (argc != 4) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 4);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  fstype = argv[i++];
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "blocksize", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "blocksize");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    blocksize = r;
  }
  device = argv[i++];
  journal = argv[i++];
  r = guestfs_mke2fs_J (g, fstype, blocksize, device, journal);
  return r;
}

static int
run_mke2fs_JL (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *fstype;
  int blocksize;
  const char *device;
  const char *label;
  size_t i = 0;

  if (argc != 4) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 4);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  fstype = argv[i++];
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "blocksize", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "blocksize");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    blocksize = r;
  }
  device = argv[i++];
  label = argv[i++];
  r = guestfs_mke2fs_JL (g, fstype, blocksize, device, label);
  return r;
}

static int
run_mke2fs_JU (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *fstype;
  int blocksize;
  const char *device;
  const char *uuid;
  size_t i = 0;

  if (argc != 4) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 4);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  fstype = argv[i++];
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "blocksize", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "blocksize");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    blocksize = r;
  }
  device = argv[i++];
  uuid = argv[i++];
  r = guestfs_mke2fs_JU (g, fstype, blocksize, device, uuid);
  return r;
}

static int
run_modprobe (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *modulename;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  modulename = argv[i++];
  r = guestfs_modprobe (g, modulename);
  return r;
}

static int
run_echo_daemon (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  char **words;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  words = parse_string_list (argv[i++]);
  if (words == NULL) return -1;
  r = guestfs_echo_daemon (g, words);
  free_strings (words);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_find0 (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *directory;
  char *files;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  directory = resolve_win_path (argv[i++]);
  if (directory == NULL) return -1;
  files = file_out (argv[i++]);
  if (files == NULL) return -1;
  r = guestfs_find0 (g, directory, files);
  free (directory);
  free (files);
  return r;
}

static int
run_case_sensitive_path (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  char *path;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_case_sensitive_path (g, path);
  free (path);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_vfs_type (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  const char *device;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  r = guestfs_vfs_type (g, device);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_truncate (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *path;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_truncate (g, path);
  free (path);
  return r;
}

static int
run_truncate_size (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *path;
  int64_t size;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "size", "xstrtoll", xerr);
      return -1;
    }
    size = r;
  }
  r = guestfs_truncate_size (g, path, size);
  free (path);
  return r;
}

static int
run_utimens (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *path;
  int64_t atsecs;
  int64_t atnsecs;
  int64_t mtsecs;
  int64_t mtnsecs;
  size_t i = 0;

  if (argc != 5) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 5);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "atsecs", "xstrtoll", xerr);
      return -1;
    }
    atsecs = r;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "atnsecs", "xstrtoll", xerr);
      return -1;
    }
    atnsecs = r;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "mtsecs", "xstrtoll", xerr);
      return -1;
    }
    mtsecs = r;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "mtnsecs", "xstrtoll", xerr);
      return -1;
    }
    mtnsecs = r;
  }
  r = guestfs_utimens (g, path, atsecs, atnsecs, mtsecs, mtnsecs);
  free (path);
  return r;
}

static int
run_mkdir_mode (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *path;
  int mode;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "mode", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "mode");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    mode = r;
  }
  r = guestfs_mkdir_mode (g, path, mode);
  free (path);
  return r;
}

static int
run_lchown (const char *cmd, size_t argc, char *argv[])
{
  int r;
  int owner;
  int group;
  char *path;
  size_t i = 0;

  if (argc != 3) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 3);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "owner", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "owner");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    owner = r;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "group", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "group");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    group = r;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_lchown (g, owner, group, path);
  free (path);
  return r;
}

static int
run_lstatlist (const char *cmd, size_t argc, char *argv[])
{
  struct guestfs_stat_list *r;
  char *path;
  char **names;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  names = parse_string_list (argv[i++]);
  if (names == NULL) return -1;
  r = guestfs_lstatlist (g, path, names);
  free (path);
  free_strings (names);
  if (r == NULL) return -1;
  print_stat_list (r);
  guestfs_free_stat_list (r);
  return 0;
}

static int
run_lxattrlist (const char *cmd, size_t argc, char *argv[])
{
  struct guestfs_xattr_list *r;
  char *path;
  char **names;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  names = parse_string_list (argv[i++]);
  if (names == NULL) return -1;
  r = guestfs_lxattrlist (g, path, names);
  free (path);
  free_strings (names);
  if (r == NULL) return -1;
  print_xattr_list (r);
  guestfs_free_xattr_list (r);
  return 0;
}

static int
run_readlinklist (const char *cmd, size_t argc, char *argv[])
{
  char **r;
  char *path;
  char **names;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  names = parse_string_list (argv[i++]);
  if (names == NULL) return -1;
  r = guestfs_readlinklist (g, path, names);
  free (path);
  free_strings (names);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_pread (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  size_t size;
  char *path;
  int count;
  int64_t offset;
  size_t i = 0;

  if (argc != 3) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 3);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "count", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "count");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    count = r;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "offset", "xstrtoll", xerr);
      return -1;
    }
    offset = r;
  }
  r = guestfs_pread (g, path, count, offset, &size);
  free (path);
  if (r == NULL) return -1;
  if (full_write (1, r, size) != size) {
    perror ("write");
    free (r);
    return -1;
  }
  free (r);
  return 0;
}

static int
run_part_init (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  const char *parttype;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  parttype = argv[i++];
  r = guestfs_part_init (g, device, parttype);
  return r;
}

static int
run_part_add (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  const char *prlogex;
  int64_t startsect;
  int64_t endsect;
  size_t i = 0;

  if (argc != 4) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 4);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  prlogex = argv[i++];
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "startsect", "xstrtoll", xerr);
      return -1;
    }
    startsect = r;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "endsect", "xstrtoll", xerr);
      return -1;
    }
    endsect = r;
  }
  r = guestfs_part_add (g, device, prlogex, startsect, endsect);
  return r;
}

static int
run_part_disk (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  const char *parttype;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  parttype = argv[i++];
  r = guestfs_part_disk (g, device, parttype);
  return r;
}

static int
run_part_set_bootable (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  int partnum;
  int bootable;
  size_t i = 0;

  if (argc != 3) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 3);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "partnum", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "partnum");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    partnum = r;
  }
  bootable = is_true (argv[i++]) ? 1 : 0;
  r = guestfs_part_set_bootable (g, device, partnum, bootable);
  return r;
}

static int
run_part_set_name (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  int partnum;
  const char *name;
  size_t i = 0;

  if (argc != 3) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 3);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "partnum", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "partnum");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    partnum = r;
  }
  name = argv[i++];
  r = guestfs_part_set_name (g, device, partnum, name);
  return r;
}

static int
run_part_list (const char *cmd, size_t argc, char *argv[])
{
  struct guestfs_partition_list *r;
  const char *device;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  r = guestfs_part_list (g, device);
  if (r == NULL) return -1;
  print_partition_list (r);
  guestfs_free_partition_list (r);
  return 0;
}

static int
run_part_get_parttype (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  const char *device;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  r = guestfs_part_get_parttype (g, device);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_fill (const char *cmd, size_t argc, char *argv[])
{
  int r;
  int c;
  int len;
  char *path;
  size_t i = 0;

  if (argc != 3) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 3);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "c", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "c");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    c = r;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "len", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "len");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    len = r;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_fill (g, c, len, path);
  free (path);
  return r;
}

static int
run_available (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char **groups;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  groups = parse_string_list (argv[i++]);
  if (groups == NULL) return -1;
  r = guestfs_available (g, groups);
  free_strings (groups);
  return r;
}

static int
run_dd (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *src;
  char *dest;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  src = resolve_win_path (argv[i++]);
  if (src == NULL) return -1;
  dest = resolve_win_path (argv[i++]);
  if (dest == NULL) return -1;
  r = guestfs_dd (g, src, dest);
  free (src);
  free (dest);
  return r;
}

static int
run_filesize (const char *cmd, size_t argc, char *argv[])
{
  int64_t r;
  char *file;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  file = resolve_win_path (argv[i++]);
  if (file == NULL) return -1;
  r = guestfs_filesize (g, file);
  free (file);
  if (r == -1) return -1;
  printf ("%" PRIi64 "\n", r);
  return 0;
}

static int
run_lvrename (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *logvol;
  const char *newlogvol;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  logvol = argv[i++];
  newlogvol = argv[i++];
  r = guestfs_lvrename (g, logvol, newlogvol);
  return r;
}

static int
run_vgrename (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *volgroup;
  const char *newvolgroup;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  volgroup = argv[i++];
  newvolgroup = argv[i++];
  r = guestfs_vgrename (g, volgroup, newvolgroup);
  return r;
}

static int
run_initrd_cat (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  size_t size;
  char *initrdpath;
  const char *filename;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  initrdpath = resolve_win_path (argv[i++]);
  if (initrdpath == NULL) return -1;
  filename = argv[i++];
  r = guestfs_initrd_cat (g, initrdpath, filename, &size);
  free (initrdpath);
  if (r == NULL) return -1;
  if (full_write (1, r, size) != size) {
    perror ("write");
    free (r);
    return -1;
  }
  free (r);
  return 0;
}

static int
run_pvuuid (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  const char *device;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  r = guestfs_pvuuid (g, device);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_vguuid (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  const char *vgname;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  vgname = argv[i++];
  r = guestfs_vguuid (g, vgname);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_lvuuid (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  const char *device;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  r = guestfs_lvuuid (g, device);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_vgpvuuids (const char *cmd, size_t argc, char *argv[])
{
  char **r;
  const char *vgname;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  vgname = argv[i++];
  r = guestfs_vgpvuuids (g, vgname);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_vglvuuids (const char *cmd, size_t argc, char *argv[])
{
  char **r;
  const char *vgname;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  vgname = argv[i++];
  r = guestfs_vglvuuids (g, vgname);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_copy_size (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *src;
  char *dest;
  int64_t size;
  size_t i = 0;

  if (argc != 3) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 3);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  src = resolve_win_path (argv[i++]);
  if (src == NULL) return -1;
  dest = resolve_win_path (argv[i++]);
  if (dest == NULL) return -1;
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "size", "xstrtoll", xerr);
      return -1;
    }
    size = r;
  }
  r = guestfs_copy_size (g, src, dest, size);
  free (src);
  free (dest);
  return r;
}

static int
run_zero_device (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  r = guestfs_zero_device (g, device);
  return r;
}

static int
run_txz_in (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *tarball;
  char *directory;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  tarball = file_in (argv[i++]);
  if (tarball == NULL) return -1;
  directory = resolve_win_path (argv[i++]);
  if (directory == NULL) return -1;
  r = guestfs_txz_in (g, tarball, directory);
  free_file_in (tarball);
  free (directory);
  return r;
}

static int
run_txz_out (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *directory;
  char *tarball;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  directory = resolve_win_path (argv[i++]);
  if (directory == NULL) return -1;
  tarball = file_out (argv[i++]);
  if (tarball == NULL) return -1;
  r = guestfs_txz_out (g, directory, tarball);
  free (directory);
  free (tarball);
  return r;
}

static int
run_ntfsresize (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  r = guestfs_ntfsresize (g, device);
  return r;
}

static int
run_vgscan (const char *cmd, size_t argc, char *argv[])
{
  int r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_vgscan (g);
  return r;
}

static int
run_part_del (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  int partnum;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "partnum", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "partnum");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    partnum = r;
  }
  r = guestfs_part_del (g, device, partnum);
  return r;
}

static int
run_part_get_bootable (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  int partnum;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "partnum", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "partnum");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    partnum = r;
  }
  r = guestfs_part_get_bootable (g, device, partnum);
  if (r == -1) return -1;
  if (r) printf ("true\n"); else printf ("false\n");
  return 0;
}

static int
run_part_get_mbr_id (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  int partnum;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "partnum", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "partnum");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    partnum = r;
  }
  r = guestfs_part_get_mbr_id (g, device, partnum);
  if (r == -1) return -1;
  printf ("%s%x\n", r != 0 ? "0x" : "", r);
  return 0;
}

static int
run_part_set_mbr_id (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  int partnum;
  int idbyte;
  size_t i = 0;

  if (argc != 3) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 3);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "partnum", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "partnum");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    partnum = r;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "idbyte", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "idbyte");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    idbyte = r;
  }
  r = guestfs_part_set_mbr_id (g, device, partnum, idbyte);
  return r;
}

static int
run_checksum_device (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  const char *csumtype;
  const char *device;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  csumtype = argv[i++];
  device = argv[i++];
  r = guestfs_checksum_device (g, csumtype, device);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_lvresize_free (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *lv;
  int percent;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  lv = argv[i++];
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "percent", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "percent");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    percent = r;
  }
  r = guestfs_lvresize_free (g, lv, percent);
  return r;
}

static int
run_aug_clear (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *augpath;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  augpath = argv[i++];
  r = guestfs_aug_clear (g, augpath);
  return r;
}

static int
run_get_umask (const char *cmd, size_t argc, char *argv[])
{
  int r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_get_umask (g);
  if (r == -1) return -1;
  printf ("%s%o\n", r != 0 ? "0" : "", r);
  return 0;
}

static int
run_debug_upload (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *filename;
  const char *tmpname;
  int mode;
  size_t i = 0;

  if (argc != 3) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 3);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  filename = file_in (argv[i++]);
  if (filename == NULL) return -1;
  tmpname = argv[i++];
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "mode", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "mode");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    mode = r;
  }
  r = guestfs_debug_upload (g, filename, tmpname, mode);
  free_file_in (filename);
  return r;
}

static int
run_base64_in (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *base64file;
  char *filename;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  base64file = file_in (argv[i++]);
  if (base64file == NULL) return -1;
  filename = resolve_win_path (argv[i++]);
  if (filename == NULL) return -1;
  r = guestfs_base64_in (g, base64file, filename);
  free_file_in (base64file);
  free (filename);
  return r;
}

static int
run_base64_out (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *filename;
  char *base64file;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  filename = resolve_win_path (argv[i++]);
  if (filename == NULL) return -1;
  base64file = file_out (argv[i++]);
  if (base64file == NULL) return -1;
  r = guestfs_base64_out (g, filename, base64file);
  free (filename);
  free (base64file);
  return r;
}

static int
run_checksums_out (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *csumtype;
  char *directory;
  char *sumsfile;
  size_t i = 0;

  if (argc != 3) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 3);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  csumtype = argv[i++];
  directory = resolve_win_path (argv[i++]);
  if (directory == NULL) return -1;
  sumsfile = file_out (argv[i++]);
  if (sumsfile == NULL) return -1;
  r = guestfs_checksums_out (g, csumtype, directory, sumsfile);
  free (directory);
  free (sumsfile);
  return r;
}

static int
run_fill_pattern (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *pattern;
  int len;
  char *path;
  size_t i = 0;

  if (argc != 3) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 3);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  pattern = argv[i++];
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "len", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "len");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    len = r;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_fill_pattern (g, pattern, len, path);
  free (path);
  return r;
}

static int
run_write (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *path;
  const char *content;
  size_t content_size;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  content = argv[i];
  content_size = strlen (argv[i]);
  i++;
  r = guestfs_write (g, path, content, content_size);
  free (path);
  return r;
}

static int
run_pwrite (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *path;
  const char *content;
  size_t content_size;
  int64_t offset;
  size_t i = 0;

  if (argc != 3) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 3);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  content = argv[i];
  content_size = strlen (argv[i]);
  i++;
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "offset", "xstrtoll", xerr);
      return -1;
    }
    offset = r;
  }
  r = guestfs_pwrite (g, path, content, content_size, offset);
  free (path);
  if (r == -1) return -1;
  printf ("%d\n", r);
  return 0;
}

static int
run_resize2fs_size (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  int64_t size;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "size", "xstrtoll", xerr);
      return -1;
    }
    size = r;
  }
  r = guestfs_resize2fs_size (g, device, size);
  return r;
}

static int
run_pvresize_size (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  int64_t size;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "size", "xstrtoll", xerr);
      return -1;
    }
    size = r;
  }
  r = guestfs_pvresize_size (g, device, size);
  return r;
}

static int
run_ntfsresize_size (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  int64_t size;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "size", "xstrtoll", xerr);
      return -1;
    }
    size = r;
  }
  r = guestfs_ntfsresize_size (g, device, size);
  return r;
}

static int
run_available_all_groups (const char *cmd, size_t argc, char *argv[])
{
  char **r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_available_all_groups (g);
  if (r == NULL) return -1;
  print_strings (r);
  free_strings (r);
  return 0;
}

static int
run_fallocate64 (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *path;
  int64_t len;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "len", "xstrtoll", xerr);
      return -1;
    }
    len = r;
  }
  r = guestfs_fallocate64 (g, path, len);
  free (path);
  return r;
}

static int
run_vfs_label (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  const char *device;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  r = guestfs_vfs_label (g, device);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_vfs_uuid (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  const char *device;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  r = guestfs_vfs_uuid (g, device);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_lvm_set_filter (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char **devices;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  devices = parse_string_list (argv[i++]);
  if (devices == NULL) return -1;
  r = guestfs_lvm_set_filter (g, devices);
  free_strings (devices);
  return r;
}

static int
run_lvm_clear_filter (const char *cmd, size_t argc, char *argv[])
{
  int r;

  if (argc != 0) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 0);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  r = guestfs_lvm_clear_filter (g);
  return r;
}

static int
run_luks_open (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  char *key;
  const char *mapname;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  key = read_key ("key");
  if (key == NULL) return -1;
  mapname = argv[i++];
  r = guestfs_luks_open (g, device, key, mapname);
  free (key);
  return r;
}

static int
run_luks_open_ro (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  char *key;
  const char *mapname;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  key = read_key ("key");
  if (key == NULL) return -1;
  mapname = argv[i++];
  r = guestfs_luks_open_ro (g, device, key, mapname);
  free (key);
  return r;
}

static int
run_luks_close (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  r = guestfs_luks_close (g, device);
  return r;
}

static int
run_luks_format (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  char *key;
  int keyslot;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  key = read_key ("key");
  if (key == NULL) return -1;
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "keyslot", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "keyslot");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    keyslot = r;
  }
  r = guestfs_luks_format (g, device, key, keyslot);
  free (key);
  return r;
}

static int
run_luks_format_cipher (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  char *key;
  int keyslot;
  const char *cipher;
  size_t i = 0;

  if (argc != 3) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 3);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  key = read_key ("key");
  if (key == NULL) return -1;
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "keyslot", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "keyslot");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    keyslot = r;
  }
  cipher = argv[i++];
  r = guestfs_luks_format_cipher (g, device, key, keyslot, cipher);
  free (key);
  return r;
}

static int
run_luks_add_key (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  char *key;
  char *newkey;
  int keyslot;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  key = read_key ("key");
  if (key == NULL) return -1;
  newkey = read_key ("newkey");
  if (newkey == NULL) return -1;
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "keyslot", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "keyslot");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    keyslot = r;
  }
  r = guestfs_luks_add_key (g, device, key, newkey, keyslot);
  free (key);
  free (newkey);
  return r;
}

static int
run_luks_kill_slot (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  char *key;
  int keyslot;
  size_t i = 0;

  if (argc != 2) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 2);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  key = read_key ("key");
  if (key == NULL) return -1;
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "keyslot", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "keyslot");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    keyslot = r;
  }
  r = guestfs_luks_kill_slot (g, device, key, keyslot);
  free (key);
  return r;
}

static int
run_is_lv (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  r = guestfs_is_lv (g, device);
  if (r == -1) return -1;
  if (r) printf ("true\n"); else printf ("false\n");
  return 0;
}

static int
run_findfs_uuid (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  const char *uuid;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  uuid = argv[i++];
  r = guestfs_findfs_uuid (g, uuid);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_findfs_label (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  const char *label;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  label = argv[i++];
  r = guestfs_findfs_label (g, label);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_is_chardev (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *path;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_is_chardev (g, path);
  free (path);
  if (r == -1) return -1;
  if (r) printf ("true\n"); else printf ("false\n");
  return 0;
}

static int
run_is_blockdev (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *path;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_is_blockdev (g, path);
  free (path);
  if (r == -1) return -1;
  if (r) printf ("true\n"); else printf ("false\n");
  return 0;
}

static int
run_is_fifo (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *path;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_is_fifo (g, path);
  free (path);
  if (r == -1) return -1;
  if (r) printf ("true\n"); else printf ("false\n");
  return 0;
}

static int
run_is_symlink (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *path;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_is_symlink (g, path);
  free (path);
  if (r == -1) return -1;
  if (r) printf ("true\n"); else printf ("false\n");
  return 0;
}

static int
run_is_socket (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *path;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  path = resolve_win_path (argv[i++]);
  if (path == NULL) return -1;
  r = guestfs_is_socket (g, path);
  free (path);
  if (r == -1) return -1;
  if (r) printf ("true\n"); else printf ("false\n");
  return 0;
}

static int
run_part_to_dev (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  const char *partition;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  partition = argv[i++];
  r = guestfs_part_to_dev (g, partition);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

static int
run_upload_offset (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *filename;
  char *remotefilename;
  int64_t offset;
  size_t i = 0;

  if (argc != 3) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 3);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  filename = file_in (argv[i++]);
  if (filename == NULL) return -1;
  remotefilename = resolve_win_path (argv[i++]);
  if (remotefilename == NULL) return -1;
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "offset", "xstrtoll", xerr);
      return -1;
    }
    offset = r;
  }
  r = guestfs_upload_offset (g, filename, remotefilename, offset);
  free_file_in (filename);
  free (remotefilename);
  return r;
}

static int
run_download_offset (const char *cmd, size_t argc, char *argv[])
{
  int r;
  char *remotefilename;
  char *filename;
  int64_t offset;
  int64_t size;
  size_t i = 0;

  if (argc != 4) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 4);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  remotefilename = resolve_win_path (argv[i++]);
  if (remotefilename == NULL) return -1;
  filename = file_out (argv[i++]);
  if (filename == NULL) return -1;
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "offset", "xstrtoll", xerr);
      return -1;
    }
    offset = r;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "size", "xstrtoll", xerr);
      return -1;
    }
    size = r;
  }
  r = guestfs_download_offset (g, remotefilename, filename, offset, size);
  free (remotefilename);
  free (filename);
  return r;
}

static int
run_pwrite_device (const char *cmd, size_t argc, char *argv[])
{
  int r;
  const char *device;
  const char *content;
  size_t content_size;
  int64_t offset;
  size_t i = 0;

  if (argc != 3) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 3);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  content = argv[i];
  content_size = strlen (argv[i]);
  i++;
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "offset", "xstrtoll", xerr);
      return -1;
    }
    offset = r;
  }
  r = guestfs_pwrite_device (g, device, content, content_size, offset);
  if (r == -1) return -1;
  printf ("%d\n", r);
  return 0;
}

static int
run_pread_device (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  size_t size;
  const char *device;
  int count;
  int64_t offset;
  size_t i = 0;

  if (argc != 3) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 3);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  device = argv[i++];
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "count", "xstrtoll", xerr);
      return -1;
    }
    /* The Int type in the generator is a signed 31 bit int. */
    if (r < (-(2LL<<30)) || r > ((2LL<<30)-1)) {
      fprintf (stderr, _("%s: %s: integer out of range\n"), cmd, "count");
      return -1;
    }
    /* The check above should ensure this assignment does not overflow. */
    count = r;
  }
  {
    strtol_error xerr;
    long long r;

    xerr = xstrtoll (argv[i++], NULL, 0, &r, xstrtol_suffixes);
    if (xerr != LONGINT_OK) {
      fprintf (stderr,
               _("%s: %s: invalid integer parameter (%s returned %d)\n"),
               cmd, "offset", "xstrtoll", xerr);
      return -1;
    }
    offset = r;
  }
  r = guestfs_pread_device (g, device, count, offset, &size);
  if (r == NULL) return -1;
  if (full_write (1, r, size) != size) {
    perror ("write");
    free (r);
    return -1;
  }
  free (r);
  return 0;
}

static int
run_lvm_canonical_lv_name (const char *cmd, size_t argc, char *argv[])
{
  char *r;
  const char *lvname;
  size_t i = 0;

  if (argc != 1) {
    fprintf (stderr, _("%s should have %d parameter(s)\n"), cmd, 1);
    fprintf (stderr, _("type 'help %s' for help on %s\n"), cmd, cmd);
    return -1;
  }
  lvname = argv[i++];
  r = guestfs_lvm_canonical_lv_name (g, lvname);
  if (r == NULL) return -1;
  printf ("%s\n", r);
  free (r);
  return 0;
}

int
run_action (const char *cmd, size_t argc, char *argv[])
{
  const struct command_table *ct;

  ct = lookup_fish_command (cmd, strlen (cmd));
  if (ct)
    return ct->entry->run (cmd, argc, argv);
  else {
    fprintf (stderr, _("%s: unknown command\n"), cmd);
    if (command_num == 1)
      extended_help_message ();
    return -1;
  }
}
